//MAIN
#include "Main.h"
#include "..\Assembler\AsmForm.h"
#include "..\BasicEmulator\BasicEmuForm.h"
#include "..\CompilerForm\CompilerForm.h"
#include "..\PictureToAsm\PictureToAsmForm.h"

#include "resource.h"

HINSTANCE hInst;
int Fstil;
int IDord=1;
ApplicationClass Appl;
ApplicationClass* Application=&Appl;

//Forms declarations
MainForm* 		MainFormWin=NULL;
AsmForm*		AsmFormWin=NULL;
BasicEmu*		BasicEmuWin=NULL;
CompilerForm*	CompilerFormWin=NULL;
PictureToAsm*	PictureToAsmForm=NULL;

void TimerCallBack(){
	int x;
	if(BasicEmuWin&&BasicEmuWin->Timer1){
		if(BasicEmuWin->Timer1->Enabled)BasicEmuWin->Timer1->Enabled=false;
		for(x=0;x<5;x++)
			BasicEmuWin->OnTimer(BasicEmuWin->Timer1->ID);
		PostMessage(MainFormWin->hwnd,WM_USER,0,0);//to refresh GUI
	}
}

//******************************************************************************
//            WinMain
//******************************************************************************
int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    hInst=hThisInstance;
    Fstil=nFunsterStil;
    MSG messages;            // Here messages to the application are saved                     

    //Create Forms
    MainFormWin = new MainForm();
	
	AsmFormWin= new AsmForm(MainFormWin->hwnd,IDD_DLG_ASM);
	BasicEmuWin= new BasicEmu(MainFormWin->hwnd,IDD_DLG_BASIC_EMU);
	CompilerFormWin= new CompilerForm(MainFormWin->hwnd,IDD_DLG_COMPILER);
	PictureToAsmForm= new PictureToAsm(MainFormWin->hwnd,IDD_DLG_PIC_ASM);

    //Message processing loop
    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }
    
    //Delete Forms
    delete MainFormWin;
	delete AsmFormWin;
	delete BasicEmuWin;
	delete CompilerFormWin;
	delete PictureToAsmForm;
    
    //Exiting
    return messages.wParam;
}
