#ifndef SIDmusicH
#define SIDmusicH

//#include <math.h>

#define SIDMUSICSCALENUM 96

struct musicScale{
	char note[4];
	int value;
};


static const musicScale SIDmusical[]={
{"C0",0x0112},
{"C4",0x1125},
{"C0$",0x0123},
{"C4$",0x122A},
{"D0", 0x0134},
{"D4",0x133F},
{"D0$",0x0146},
{"D4$",0x1464},
{"E0",0x015A},
{"E4",0x159A  },
{"F0",0x016E},
{"F4",0x16E3  },
{"F0$",0x0184},
{"F4$",0x183F  },
{"G0",0x018B},
{"G4",0x1981  },
{"G0$",0x01B3},
{"G4$",0x1B38  },
{"A0",0x01CD},
{"A4",0x1CD6  },	//Normal A 440 Hz must be 
{"A0$",0x01E9},
{"A4$",0x1E80  },
{"B0",0x0206},
{"B4",0x205E  },
{"C1",0x0225},
{"C5",0x224B  },
{"C1$",0x0245},
{"C5$",0x2455  },
{"D1",0x0268},
{"D5",0x267E  },
{"D1$",0x028C},
{"D5$",0x28C8  },
{"E1",0x02B3},
{"E5",0x2B34  },
{"F1",0x02DC},
{"F5",0x2DC6  },
{"F1$",0x0308},
{"F5$",0x307F  },
{"G1",0x0336},
{"G5",0x3361  },
{"G1$",0x0367},
{"G5$",0x366F  },
{"A1",0x039B},
{"A5",0x39AC  },
{"A1$",0x03D2},
{"A5$",0x3D1A  },
{"B1",0x040C},
{"B5",0x40BC  },
{"C2",0x0449},
{"C6",0x4495  },
{"C2$",0x048B},
{"C6$",0x48A9  },
{"D2",0x04D0},
{"D6",0x4CFC  },
{"D2$",0x0519},
{"D6$",0x518F  },
{"E2",0x0567},
{"E6",0x5669  },
{"F2",0x05B9},
{"F6",0x5B8C  },
{"F2$",0x0610},
{"F6$",0x60FE  },
{"G2",0x066C},
{"G6",0x6602  },
{"G2$",0x06CE},
{"G6$",0x6CDF  },
{"A2",0x0735},
{"A6",0x7358  },
{"A2$",0x07A3},
{"A6$",0x7A34  },
{"B2",0x0817},
{"B6",0x8178  },
{"C3",0x0893},
{"C7",0x892B  },
{"C3$",0x0915},
{"C7$",0x9153  },
{"D3",0x099F},
{"D7",0x99F7  },
{"D3$",0x0A32},
{"D7$",0xA31F  },
{"E3",0x0ACD},
{"E7",0xACD2  },
{"F3",0x0B72},
{"F7",0xB719  },
{"F3$",0x0C20},
{"F7$",0xC1FC  },
{"G3",0x0C08},
{"G7",0xC085  },
{"G3$",0x0D9C},
{"G7$",0x0980  },
{"A3",0x0E6B},
{"A7",0xE6B0  },
{"A3$",0x0F46},
{"A7$",0xF467  },
{"B3",0x102F},
{"B7",0x1F2F}

};


/*
static musicScale SIDmusical[]={
{"C0",0},	//NOTE=-57
{"C0$",0},	//NOTE=-56
{"D0",0},	//NOTE=-55
{"D0$",0},	//NOTE=-54
{"E0",0},	//NOTE=-53
{"F0",0},	//NOTE=-52
{"F0$",0},	//NOTE=-51
{"G0",0},	//NOTE=-50
{"G0$",0},	//NOTE=-49
{"A0",0},	//NOTE=-48
{"A0$",0},	//NOTE=-47
{"B0",0},	//NOTE=-46
{"C1",0},	//NOTE=-45
{"C1$",0},	//NOTE=-44
{"D1",0},	//NOTE=-43
{"D1$",0},	//NOTE=-42
{"E1",0},	//NOTE=-41
{"F1",0},	//NOTE=-40
{"F1$",0},	//NOTE=-39
{"G1",0},	//NOTE=-38
{"G1$",0},	//NOTE=-37
{"A1",0},	//NOTE=-36
{"A1$",0},	//NOTE=-35
{"B1",0},	//NOTE=-34
{"C2",0},	//NOTE=-33
{"C2$",0},	//NOTE=-32
{"D2",0},	//NOTE=-31
{"D2$",0},	//NOTE=-30
{"E2",0},	//NOTE=-29
{"F2",0},	//NOTE=-28
{"F2$",0},	//NOTE=-27
{"G2",0},	//NOTE=-26
{"G2$",0},	//NOTE=-25
{"A2",0},	//NOTE=-24
{"A2$",0},	//NOTE=-23
{"B2",0},	//NOTE=-22
{"C3",0},	//NOTE=-21
{"C3$",0},	//NOTE=-20
{"D3",0},	//NOTE=-19
{"D3$",0},	//NOTE=-18
{"E3",0},	//NOTE=-17
{"F3",0},	//NOTE=-16
{"F3$",0},	//NOTE=-15
{"G3",0},	//NOTE=-14
{"G3$",0},	//NOTE=-13
{"A3",0},	//NOTE=-12
{"A3$",0},	//NOTE=-11
{"B3",0},	//NOTE=-10
{"C4",0},	//NOTE=-9
{"C4$",0},	//NOTE=-8
{"D4",0},	//NOTE=-7
{"D4$",0},	//NOTE=-6
{"E4",0},	//NOTE=-5
{"F4",0},	//NOTE=-4
{"F4$",0},	//NOTE=-3
{"G4",0},	//NOTE=-2
{"G4$",0},	//NOTE=-1
{"A4",0},	//normal A 440 Hz NOTE=0
{"A4$",0},	//NOTE=1
{"B4",0},	//NOTE=2
{"C5",0},
{"C5$",0},
{"D5",0},
{"D5$",0},
{"E5",0},
{"F5",0},
{"F5$",0},
{"G5",0},
{"G5$",0},
{"A5",0},
{"A5$",0},
{"B5",0},
{"C6",0},
{"C6$",0},
{"D6",0},
{"D6$",0},
{"E6",0},
{"F6",0},
{"F6$",0},
{"G6",0},
{"G6$",0},
{"A6",0},
{"A6$",0},
{"B6",0},
{"C7",0},
{"C7$",0},
{"D7",0},
{"D7$",0},
{"E7",0},
{"F7",0},
{"F7$",0},
{"G7",0},
{"G7$",0},
{"A7",0},
{"A7$",0},
{"B7",0},
{"",0}
};

#include "..\TStringListClass.h"


static void SIDmusicalGenerator(){
	double BASEFREQ = 440.0; //This is the Hz for the standard A note.
	double NOTE = 0.0;	//This is the note relative to the standard A. 0 = standard A itself, -1 = G# etc. 
	double STEPS_PER_OCTAVE = 12.0;	//Normally we use 12 notes per octave.
	double CONSTANT=17.02841924;
	double SID_FREQ;
	double FREQ_HZ;

	int x=0;
	int A4pos;
	while((SIDmusical[x].note[0]=='A')&&(SIDmusical[x].note[1]=='4'))x++;
	A4pos=x;
	for(;SIDmusical[x].note[0];x++,NOTE+=1.0){
		FREQ_HZ = BASEFREQ * pow((double)2.0,(NOTE/STEPS_PER_OCTAVE));
		SID_FREQ = CONSTANT * FREQ_HZ; //Calculate SID freq for a certain note (specified in Hz).
		SIDmusical[x].value=(int)SID_FREQ;
	}
	NOTE = 0.0;
	for(x=A4pos-1;x>=0;x--){
		NOTE-=1.0;
		FREQ_HZ = BASEFREQ * pow((double)2.0,(NOTE/STEPS_PER_OCTAVE));
		SID_FREQ = CONSTANT * FREQ_HZ; //Calculate SID freq for a certain note (specified in Hz).
		SIDmusical[x].value=(int)SID_FREQ;
	}
	
	//TEST
	TStringList*list=new TStringList();
	AnsiString s;
	x=0;
	while(SIDmusical[x].note[0]){
		sprintf(s.String,"%s, %X",SIDmusical[x].note,SIDmusical[x].value);
		x++;
		list->Add(s);
	}
	list->SaveToFile("SIDmusicalGenerator.txt");
	
	delete list;
}
*/

#endif
