RNGTABLTE: DB 0x00,0x00


HLT
NOP

;system variables
PageAct: DB 0x00
PageTo: DB 0x00
PageTo2: DB 0x00
sr1swap: DB 0x00,0x00
indexx: DB 0x00,0x00
indexy: DB 0x00,0x00
forstepind: DB 0x00
;Cursor
CurX: DB 0x00,0x00
CurY: DB 0x00,0x00
SysColor: DB 0xFF
;pattern coords
PatCstX: DB 0x00
PatCstY: DB 0x00
PatCenX: DB 0x00
PatCenY: DB 0x00
;Random number generation
RNGTABLTEDIM: DB 0x00,0x00
;Keyboard
KEYBreg: DB 0x00
;print number radix
Radix:	DB 0x00
;print number redirection
PrNumRedir: DB 0x00

;Temporary registers
B_tmp: DB 0x00
C_tmp: DB 0x00
D_tmp: DB 0x00
E_tmp: DB 0x00
H_tmp: DB 0x00
L_tmp: DB 0x00

;SID registers
SIDreg04: DB 0x00
SIDreg08: DB 0x00
SIDreg11: DB 0x00
SIDreg18: DB 0x00
SIDreg24: DB 0x00

;*********************************************
; SUBROUTINES
;*********************************************

;DUMMY CALLS
CALL Multiply
CALL Divider
CALL PRINT
CALL XPRINT
CALL PRINTDEC
CALL DRAWTO
CALL PUTPATTERN
CALL PUTPATMIRVER
CALL PUTPATTWIST
CALL PUTPATTWISMIR
CALL DELPATTERN
CALL DELAY
CALL PLOT
CALL RNG
CALL CLRSCR128
CALL GETCHAR

CALL MP_PUTARRAYD1
CALL MP_PUTARRAYD2
CALL MP_GETARRAYD1
CALL MP_GETARRAYD2
CALL MP_GETSTRING
CALL MP_PUTSTRING
CALL MP_READ
CALL MP_SID
CALL MP_SIDS
CALL MP_SVOICE1
CALL MP_SVOICE1S
CALL MP_SVOICE2
CALL MP_SVOICE2S
CALL MP_SVOICE3
CALL MP_SVOICE3S
CALL MP_SFILTER
CALL MP_SFILTERS
CALL MP_SFREQ1S
CALL MP_SPW1S
CALL MP_SFREQ2S
CALL MP_SPW2S
CALL MP_SFREQ3S
CALL MP_SPW3S

CALL INPUT
CALL STRCPY
CALL STRCMP
CALL STRPOS
CALL STRCAT
CALL STRLEN
CALL STRTONUM
CALL NUMTOSTR


;--------------------------------------------------------------------
; MULTIPLIER

#PROC Multiply
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
MVI A,0x80
AND B
JM compl1
MVI A,0x80
AND D
JM compl2
NormMul:
CALL UMultiply
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
RET

compl1:
CALL Compl2BC
MVI A,0x80
AND D
JM compl3
JMP complX

compl2:
CALL Compl2DE
MVI A,0x80
AND B
JM compl4
complX:
CALL UMultiply
CALL Compl2BC
RET

compl3:
CALL Compl2DE
JMP NormMul

compl4:
CALL Compl2BC
JMP NormMul

#END


#PROC UMultiply
MVI A,0x01
AND C
JZ m1
MOV L,E
MOV H,D
JMP m2
m1: MVI H,0
MVI L,0
m2: 
CALL SHLXDE

MVI A,0x02
AND C
JZ m3

CALL ADDXDE
m3: 
CALL SHLXDE
MVI A,0x04
AND C
JZ m4

CALL ADDXDE
m4: 
CALL SHLXDE
MVI A,0x08
AND C
JZ m5

CALL ADDXDE
m5: 
CALL SHLXDE
MVI A,0x10
AND C
JZ m6

CALL ADDXDE
m6: 
CALL SHLXDE
MVI A,0x20
AND C
JZ m7

CALL ADDXDE
m7: 
CALL SHLXDE
MVI A,0x40
AND C
JZ m8

CALL ADDXDE
m8: 
CALL SHLXDE
MVI A,0x80
AND C
JZ m9

CALL ADDXDE
m9: 
CALL SHLXDE
MVI A,0x01
AND B
JZ m10

CALL ADDXDE
m10: 
CALL SHLXDE
MVI A,0x02
AND B
JZ m11

CALL ADDXDE
m11: 
CALL SHLXDE
MVI A,0x04
AND B
JZ m12

CALL ADDXDE
m12: 
CALL SHLXDE
MVI A,0x08
AND B
JZ m13

CALL ADDXDE
m13: 
CALL SHLXDE
MVI A,0x10
AND B
JZ m14

CALL ADDXDE
m14: 
CALL SHLXDE
MVI A,0x20
AND B
JZ m15

CALL ADDXDE
m15: 
CALL SHLXDE
MVI A,0x40
AND B
JZ m16

CALL ADDXDE
m16:
MOV B,H
MOV C,L
RET
#END

#PROC ADDXDE
;ADDX
MOV A,E
ADD L
MOV L,A
MOV A,D
ADC H
MOV H,A
RET
#END


;--------------------------------------------------------------------
;DIVIDER

#PROC Divider
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
MVI A,0x80
AND B
JM compl1_d
MVI A,0x80
AND D
JM compl2_d
NormDiv:
CALL UDivider
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
RET

compl1_d:
CALL Compl2BC
MVI A,0x80
AND D
JM compl3_d
JMP complX_d

compl2_d:
CALL Compl2DE
MVI A,0x80
AND B
JM compl4_d
complX_d:
CALL UDivider
CALL Compl2BC
RET

compl3_d:
CALL Compl2DE
JMP NormDiv

compl4_d:
CALL Compl2BC
JMP NormDiv

#END



;BC=BC/DE
#PROC UDivider
XOR A
OR E
JNZ divcnt
XOR A
OR D
JNZ divcnt
MVI B,0xFF
MVI C,0xFF
RET

divcnt:
XOR A
OR B
JNZ divsh
XOR A
OR C
JNZ divsh
RET

divsh:
MVI A,0x01
SUB E
JNZ divgencnt
XOR A
SUB D
JNZ divgencnt
RET
divgencnt:
MVI A,0x01
AND E
JNZ divug1
CALL SHRXDE
CALL SHRXBC
JMP divsh

divug1:
XOR A
STA [shcntr]
STA [divsumH]
STA [divsumL]
MOV H,A
MOV L,A
MOV A,C
SUB E
JNZ divgen3
MOV A,B
SBB D
JNZ divgen3
MVI B,0x00
MVI C,0x01
RET

divgen3:
CALL SHLXDE
LDA [shcntr]
MVI H,0x01
ADD H
STA [shcntr]
MOV A,C
SUB E
MOV A,B
SBB D
JP divgen3
CALL SHRXDE
LDA [shcntr]
MVI H,0x01
SUB H
STA [shcntr]

mainsubcyc:
XOR A
MOV L,A
MOV H,A

;cycle for substraction
divsubs:
MOV A,C
SUB E
MOV C,A
MOV A,B
SBB D
MOV B,A
JM subsvege
INX HL
JMP divsubs
subsvege:
;correction with addition
MOV A,C
ADD E
MOV C,A
MOV A,B
ADC D
MOV B,A

;check if HL=0
XOR A
SUB H
JNZ atugr1
XOR A
SUB L
JZ subatugr
atugr1:

LDA [shcntr]
STA [mulcnt]
MOV A,H
STA [PdivsumH]
MOV A,L
STA [PdivsumL]

;test if sub counter ==0
MVI H,0x00
LDA [mulcnt]
SUB H
JZ nosubshift

;Shift sub counter
multcyc:
LDA [PdivsumL]
MOV L,A
LDA [PdivsumH]
MOV H,A
MOV A,L
ADD L
STA [PdivsumL]
MOV A,H
ADC H
STA [PdivsumH]
LDA [mulcnt]
MVI H,0x01
SUB H
STA [mulcnt]
JNZ multcyc

nosubshift:

;ADD to main result
LDA [PdivsumL]
MOV L,A
LDA [PdivsumH]
MOV H,A
LDA [divsumL]
ADD L
STA [divsumL]
LDA [divsumH]
ADC H
STA [divsumH]

subatugr:
;test if divider ==1
MVI A,0x01
SUB E
JZ testif0x1
JMP not0x1
testif0x1:
MVI A,0x00
SUB D
JZ divvegeend
not0x1:

CALL SHRXDE
LDA [shcntr]
MVI H,0x00
ADD H
JZ divvegeend
MVI H,0x01
SUB H
STA [shcntr]
JMP mainsubcyc

divvegeend:
LDA [divsumH]
MOV B,A
LDA [divsumL]
MOV C,A

RET
shcntr:
DB 0x00
divsumH:
DB 0x00
divsumL:
DB 0x00
mulcnt:
DB 0x00
PdivsumH:
DB 0x00
PdivsumL:
DB 0x00
NOP
#END


#PROC SHRXDE
;SHR
MOV A,D
RRA
MOV D,A
MOV A,E
RRA
MOV E,A
MVI A,0x7F
AND E
MOV E,A
MVI A,0x80
AND D
OR E
MOV E,A
MVI A,0x7F
AND D
MOV D,A
RET
#END

#PROC SHRXBC
;SHR
MOV A,B
RRA
MOV B,A
MOV A,C
RRA
MOV C,A
MVI A,0x7F
AND C
MOV C,A
MVI A,0x80
AND B
OR C
MOV C,A
MVI A,0x7F
AND B
MOV B,A
RET
#END

;legfelso bit nem lehet 1-es -> tulcsordulas
#PROC SHLXDE
;SHL
MOV A,D
RLA
MOV D,A
MOV A,E
RLA
MOV E,A
MVI A,0x01
AND E
OR D
MOV D,A
MVI A,0xFE
AND E
MOV E,A
RET
#END


#PROC Compl2BC
MOV A,B
CMA
MOV B,A
MOV A,C
CMA
MOV C,A
MVI A,0x01
ADD C
MOV C,A
MVI A,0x00
ADC B
MOV B,A
RET
#END

#PROC Compl2DE
MOV A,D
CMA
MOV D,A
MOV A,E
CMA
MOV E,A
MVI A,0x01
ADD E
MOV E,A
MVI A,0x00
ADC D
MOV D,A
RET
#END


;--------------------------------------------------------------------
;DRAWTO

#PROC DRAWTO
;Check if coords bigger than 255
MVI A,0x00
OR B
JNZ dr_inv%%
MVI A,0x00
OR D
JNZ dr_inv%%
LDA [CurX]
MVI B,0x00
OR B
JNZ dr_inv%%
LDA [CurY]
MVI B,0x00
OR B
JNZ dr_inv%%
;save endpoints
MOV A,C
STA [PEndX]
MOV A,E
STA [PEndY]
;check if StartX>EndX
LDA [CurX+1]
MOV B,A
MOV A,C
SUB B
JC dr_signOk%%
LDA [CurX+1]
MOV B,A
MOV A,C
STA [CurX+1]
MOV C,B
LDA [CurY+1]
MOV B,A
MOV A,E
STA [CurY+1]
MOV E,B
dr_signOk%%:
;compute Xdiff and Ydiff
LDA [CurX+1]
MOV B,A
MOV A,C
SUB B
STA [Xdiff]
LDA [CurY+1]
MOV B,A
MOV A,E
SUB B
STA [Ydiff]
;Check if Ydiff<0
MVI B,0x00
ADD B
JP dr_ypoz%%
CMA
MVI B,0x01
ADD B
STA [Ydiff]
MVI A,0x01
STA [Mmod]
JMP dr_ypn%%
dr_ypoz%%:
MVI A,0x00
STA [Mmod]
dr_ypn%%:
;check if Xdiff<Ydiff
LDA [Ydiff]
MOV B,A
LDA [Xdiff]
SUB B
JNC dr_mode1%%
MVI A,0x00
STA [Dmod]
JMP dr_mode0%%
;exchange X and Y coords
dr_mode1%%:
MVI A,0x01
STA [Dmod]
MOV A,C
MOV C,E
MOV E,A
LDA [CurX+1]
MOV B,A
LDA [CurY+1]
MOV D,A
MOV A,B
STA [CurY+1]
MOV A,D
STA [CurX+1]
LDA [Xdiff]
MOV B,A
LDA [Ydiff]
MOV D,A
MOV A,B
STA [Ydiff]
MOV A,D
STA [Xdiff]

dr_mode0%%:
MVI A,0x00
STA [Yerr]
STA [Yerr+1]

;compute line
LDA [CurX+1]
MOV B,A
LDA [CurY+1]
MOV D,A
;special case:
;when Dmod=Mmod=1
;XCHG start and endpoint
LDA [Mmod]
OR A
JZ dr_atusp%%
LDA [Dmod]
OR A
JZ dr_atusp%%
MOV A,B
MOV B,C
MOV C,A
MOV A,D
MOV D,E
MOV E,A
dr_atusp%%:
;drawing loop
drw_loop%%:
MOV A,B
SUB C
JZ drw_loop_ok%%
JNC drw_loop_ok%%
JMP drw_end%%
drw_loop_ok%%:
LDA [Dmod]
OR A
JZ dr_modeS%%
MOV A,B
STA [0xC003]
MOV A,D
STA [0xC002]
JMP dr_modeATU%%
dr_modeS%%:
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
dr_modeATU%%:
LDA [SysColor]
STA [0xC004]

LDA [Yerr+1]
MOV E,A
LDA [Ydiff]
ADD E
STA [Yerr+1]
LDA [Yerr]
MVI E,0
ADC E
STA [Yerr]

LDA [Yerr+1]
MOV E,A
LDA [Xdiff]
SUB E;Xdif-Yerr
STA [DRWtmp]
LDA [Yerr]
MOV E,A
MVI A,0x00
SBB E
JNC drw_cmp%%
MOV E,A
LDA [DRWtmp]
OR E
JZ drw_cmp%%
JMP drw_loop_inc%%

drw_cmp%%:
LDA [Mmod]
OR A
JZ dr_yNov%%
MOV A,D
MVI D,0x01
SUB D
MOV D,A
JMP dr_yVari%%
dr_yNov%%:
MVI A,0x01
ADD D
MOV D,A
dr_yVari%%:
;Yerr=Yerr-Xdiff
LDA [Xdiff]
MOV E,A
LDA [Yerr+1]
SUB E
STA [Yerr+1]
LDA [Yerr]
MVI E,0
SBB E
STA [Yerr]

drw_loop_inc%%:
MVI A,0x01
ADD B
MOV B,A
JMP drw_loop%%

dr_inv%%:
drw_end%%:
;cursor=endpoint of line
LDA [PEndX]
STA [CurX+1]
LDA [PEndY]
STA [CurY+1]
RET

#END

Xdiff: DB 0x00;unsigned
Ydiff: DB 0x00;unsigned
Yerr:  DB 0x00,0x00;signed
Dmod:  DB 0x00;mode: 1 or 0
Mmod:  DB 0x00;mode: 1 or 0
PEndX: DB 0x00
PEndY: DB 0x00
DRWtmp:DB 0x00

;--------------------------------------------------------------------


SZOVEG:
DB 0x53
DB 0x7A
DB 0x69
DB 0x61
DB 0x20
DB 0x42
DB 0x61
DB 0x72
DB 0x69
DB 0x00

HEXANUMMODE:
DB 0x00
HEXANUM:
DB 0x48
DB 0x45
DB 0x58
DB 0x41
DB 0x20
DB 0x20
DB 0x20
HEXANUM0xST:
DB 0x30
DB 0x78
HEXANUMST:
DB 0x41
DB 0x41
DB 0x41
DB 0x41
DB 0x48
HEXANUMEND:
DB 0x00
DB 0x00

_DECint:
DB 0x00
DB 0x00
_DECtmp:
DB 0x00
DB 0x00

#PROC XPRINT
;BC=KIIRANDO HEXA SZAM
MOV A,B
RRA
RRA
RRA
RRA
MVI E,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST]
MOV E,B
MVI A,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST+1]

MOV A,C
RRA
RRA
RRA
RRA
MVI E,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST+2]
MOV E,C
MVI A,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST+3]


MVI A,0x48
STA [HEXANUMEND-1]
LDA [HEXANUMMODE]
MVI B,0xFF
AND B
JZ Htestmode
JMP Hnormmode
Htestmode:
MVI A,0x0A
STA [HEXANUMEND-1]
LDA [Xcoord]
MVI B,0xFE
AND B
JZ NXRSTCUR
MVI C,0x0A
CALL PUTCHAR
NXRSTCUR:
MVI H,[HIGH HEXANUM]
MVI L,[LOW HEXANUM]
CALL PRINT
JMP HEXend
Hnormmode:
MVI A,0x00
STA [HEXANUMEND]
MVI H,[HIGH HEXANUMST]
MVI L,[LOW HEXANUMST]
CALL PRINT
HEXend:
RET
#END

#PROC XHPRCONV
MOV A,E
MVI D,0x0A
SUB D
JM XHP09
MOV A,E
MVI D,0x37
ADD D
JMP XHPV
XHP09:
MOV A,E
MVI D,0x30
ADD D
XHPV:
MOV E,A
RET
#END

#PROC PRINTDEC
;BC=kiirando decimalis szam
XOR A
STA [SZOVEG+9]
MVI H,[HIGH SZOVEG+8]
MVI L,[LOW SZOVEG+8]
MVI A,0x00
STA [SZOVEG]
MVI A,0x80
AND B
JZ pozitivDEC
MVI A,45
STA [SZOVEG]
MOV A,B
CMA
MOV B,A
MOV A,C
CMA
MOV C,A
MVI A,0x01
ADD C
MOV C,A
MVI A,0x00
ADC B
MOV B,A

pozitivDEC:
MVI A,0x00
OR B
JNZ _DECnonzero
MVI A,0x00
OR C
JNZ _DECnonzero
MVI A,48
MOV M,A
JMP _DECout

;while(BC!=0)
_DECnonzero:
MVI A,0x00
OR B
JNZ _DECciklc
MVI A,0x00
OR C
JNZ _DECciklc
JMP _DECsigncorr

_DECciklc:
MOV A,B
STA [_DECtmp]
MOV A,C
STA [_DECtmp+1]
MVI D,0
MVI E,10
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
CALL UDivider
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
MOV A,B
STA [_DECint]
MOV A,C
STA [_DECint+1]
MVI D,0
MVI E,10
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
CALL UMultiply
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
MOV D,B
MOV E,C
LDA [_DECtmp]
MOV B,A
LDA [_DECtmp+1]
MOV C,A
MOV A,C
SUB E
MOV C,A
MOV A,B
SBB D
MOV B,A
MVI A,48
ADD C
MOV C,A
MOV M,C
DCX HL
LDA [_DECint]
MOV B,A
LDA [_DECint+1]
MOV C,A
JMP _DECnonzero

_DECsigncorr:
LDA [SZOVEG]
MVI B,0xFF
AND B
JZ _DECoutC
MVI A,45
MOV M,A
JMP _DECout

_DECoutC:
INX HL
_DECout:
CALL PRINT
RET
#END

#PROC PRINT
LDA [PageTo]
STA [0xC007]
;redirection?
LDA [PrNumRedir]
MVI B,0
OR B
JZ Pnodredir
JMP Predirection
Pnodredir:
;HL: pointer to NULL terminated string
xcyc:
MOV C,M
MOV A,C
MVI B,0xFF
AND B
JZ xkilep
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
CALL PUTCHAR
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
INX HL
JMP xcyc
xkilep:
LDA [PageAct]
STA [0xC007]
RET
#END

#PROC PUTCHAR
;C=char to print out
;check if valid char
MVI A,0x00
OR C
JP validch
MVI C,0x20
validch:
;check if carriage return (10 or 13)
MVI A,10
SUB C
JZ carriageret
MVI A,13
SUB C
JZ carriageret
MVI A,2
SUB C
JNZ nodoublep
MVI C,58
nodoublep:
MOV E,C
LDA [Xcoord]
RLA
RLA
RLA
STA [XcoordTMP]
LDA [Ycoord]
RLA
RLA
RLA
STA [YcoordTMP]
MOV A,C
MVI B,0x10
SUB B
JP validchar
MVI A,0x10
validchar:
MVI B,0
MOV C,A
ADD C
MOV C,A
MOV A,B
ADC B
MOV B,A
MOV A,C
ADD C
MOV C,A
MOV A,B
ADC B
MOV B,A
MOV A,C
ADD C
MOV C,A
MOV A,B
ADC B
STA [AddrAddonH]
MOV A,C
STA [AddrAddonL]
MOV C,E
MVI A,0x07
STA [Xcikl]
STA [Ycikl]

putchcikl:	;cycle outside -------------

MVI A,[LOW CHARSET]
MOV L,A
MVI A,[HIGH CHARSET]
MOV H,A
LDA [AddrAddonL]
ADD L
MOV L,A
LDA [AddrAddonH]
ADC H
MOV H,A
LDA [Ycikl]
ADD L
MOV L,A
MVI A,0
ADC H
MOV H,A
MOV A,M
STA [Pixtmp]

putchciklins:	;cycle inside -------------

LDA [XcoordTMP]
MOV H,A
LDA [Xcikl]
ADD H
STA [0xC002]	;Xreg
LDA [YcoordTMP]
MOV H,A
LDA [Ycikl]
ADD H
STA [0xC003]	;Yreg

LDA [Pixtmp]
MOV L,A
RRA
STA [Pixtmp]
MOV A,L
MVI H,0x01
AND H
JZ nullpix
MVI A,255
STA [0xC004]	;Zreg
JMP pixatug
nullpix:
MVI A,0
STA [0xC004]	;Zreg
pixatug:
LDA [Xcikl]
MVI H,1
SUB H
STA [Xcikl]
JNZ putchciklins
LDA [Ycikl]
MVI H,1
SUB H
STA [Ycikl]
MVI A,7
STA [Xcikl]
JNZ putchcikl
;move cursor
LDA [Xcoord]
MVI B,1
ADD B
STA [Xcoord]
MVI B,19
SUB B
JM chplotexit
carriageret:
MVI A,0x01
STA [Xcoord]
LDA [Ycoord]
MVI B,0x01
ADD B
STA [Ycoord]
MVI B,14
SUB B
JM chplotexit
MVI A,0x01
STA [Ycoord]
CALL CLRSCR128
chplotexit:
RET
#END

Pixtmp:
DB 0x00
Xcikl:
DB 0x00
Ycikl:
DB 0x00
AddrAddonL:
DB 0x00
AddrAddonH:
DB 0x00
XcoordTMP:
DB 0x00
YcoordTMP:
DB 0x00
Xcoord:
DB 0x01
Ycoord:
DB 0x01


CHARSET:

CH_XTR1:	;up arrow
DB 0x00
DB 0x04
DB 0x0E
DB 0x15
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_XTR2:	;>=
DB 0x00
DB 0x10
DB 0x08
DB 0x04
DB 0x02
DB 0x1F
DB 0x00
DB 0x1F

CH_XTR3:	;<=
DB 0x00
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x1F
DB 0x00
DB 0x1F

CH_XTR4:	;not eq
DB 0x00
DB 0x00
DB 0x08
DB 0x1F
DB 0x04
DB 0x1F
DB 0x02
DB 0x00

CH_XTR5:	;pi
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x0A
DB 0x0A
DB 0x0A
DB 0x13

CH_XTR6:	;circle
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x0E
DB 0x00

CH_XTR7:	;sigma
DB 0x00
DB 0x1F
DB 0x11
DB 0x08
DB 0x04
DB 0x08
DB 0x11
DB 0x1F

CH_XTR8:	;degree
DB 0x00
DB 0x0C
DB 0x12
DB 0x12
DB 0x0C
DB 0x00
DB 0x00
DB 0x00

CH_XTR9:	;heart
DB 0x00
DB 0x00
DB 0x0A
DB 0x1F
DB 0x1F
DB 0x0E
DB 0x04
DB 0x00

CH_XTR10:	;treff
DB 0x00
DB 0x00
DB 0x04
DB 0x0E
DB 0x1F
DB 0x0E
DB 0x04
DB 0x00

CH_XTR11:	;full square
DB 0xFF
DB 0xFF
DB 0xFF
DB 0xFF
DB 0xFF
DB 0xFF
DB 0xFF
DB 0xFF

CH_XTR12:
DB 0x55
DB 0x55
DB 0x55
DB 0x55
DB 0x55
DB 0x55
DB 0x55
DB 0x55

CH_XTR13:
DB 0x55
DB 0xAA
DB 0x55
DB 0xAA
DB 0x55
DB 0xAA
DB 0x55
DB 0xAA

CH_XTR14:
DB 0xFF
DB 0x00
DB 0xFF
DB 0x00
DB 0xFF
DB 0x00
DB 0xFF
DB 0x00

CH_XTR15:
DB 0x00
DB 0xFF
DB 0x41
DB 0x41
DB 0x41
DB 0x41
DB 0x41
DB 0xFF

CH_XTR16:
DB 0x00
DB 0xFF
DB 0x49
DB 0x49
DB 0xFF
DB 0x49
DB 0x49
DB 0xFF

CH_@1:	;space
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00

CH_@6:	;!
DB 0x00
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x00
DB 0x04

CH_@7:	;"
DB 0x00
DB 0x0A
DB 0x0A
DB 0x0A
DB 0x00
DB 0x00
DB 0x00
DB 0x00

CH_@8:	;#
DB 0x00
DB 0x0A
DB 0x0A
DB 0x1F
DB 0x0A
DB 0x1F
DB 0x0A
DB 0x0A

CH_@9:	;$
DB 0x00
DB 0x04
DB 0x0F
DB 0x14
DB 0x0E
DB 0x05
DB 0x1E
DB 0x04

CH_EXT1:	;%
DB 0x00
DB 0x00
DB 0x09
DB 0x02
DB 0x04
DB 0x08
DB 0x12
DB 0x00

CH_@@@@4:	;&
DB 0x00
DB 0x0C
DB 0x12
DB 0x14
DB 0x08
DB 0x15
DB 0x12
DB 0x0D

CH_EXT2:	;'
DB 0x00
DB 0x10
DB 0x10
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00

CH_@@4:	;(
DB 0x00
DB 0x02
DB 0x04
DB 0x08
DB 0x08
DB 0x08
DB 0x04
DB 0x02

CH_@@3:	;)
DB 0x00
DB 0x08
DB 0x04
DB 0x02
DB 0x02
DB 0x02
DB 0x04
DB 0x08

CH_@3:	;*
DB 0x00
DB 0x00
DB 0x04
DB 0x15
DB 0x0E
DB 0x15
DB 0x04
DB 0x00

CH_@2:	;+
DB 0x00
DB 0x00
DB 0x04
DB 0x04
DB 0x1F
DB 0x04
DB 0x04
DB 0x00

CH_EXT_: ;,
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x0C
DB 0x04
DB 0x08

CH_@11:	;-
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x00
DB 0x00
DB 0x00

CH_@@1:	;.
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x0C
DB 0x0C

CH_@4:	;/
DB 0x00
DB 0x00
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x10
DB 0x00

CH_0:
DB 0x00
DB 0x0E
DB 0x11
DB 0x13
DB 0x15
DB 0x19
DB 0x11
DB 0x0E

CH_1:
DB 0x00
DB 0x04
DB 0x0C
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_2:
DB 0x00
DB 0x0E
DB 0x11
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x1F

CH_3:
DB 0x00
DB 0x1F
DB 0x02
DB 0x04
DB 0x02
DB 0x01
DB 0x11
DB 0x0E

CH_4:
DB 0x00
DB 0x02
DB 0x06
DB 0x0A
DB 0x12
DB 0x1F
DB 0x02
DB 0x02

CH_5:
DB 0x00
DB 0x1F
DB 0x10
DB 0x1E
DB 0x01
DB 0x01
DB 0x11
DB 0x0E

CH_6:
DB 0x00
DB 0x06
DB 0x08
DB 0x10
DB 0x1E
DB 0x11
DB 0x11
DB 0x0E

CH_7:
DB 0x00
DB 0x1F
DB 0x01
DB 0x02
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_8:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x0E
DB 0x11
DB 0x11
DB 0x0E

CH_9:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x0F
DB 0x01
DB 0x02
DB 0x0C

CH_@@@3:	;:
DB 0x00
DB 0x00
DB 0x0C
DB 0x0C
DB 0x00
DB 0x0C
DB 0x0C
DB 0x00

CH_@@@2:	;;
DB 0x00
DB 0x00
DB 0x0C
DB 0x0C
DB 0x00
DB 0x0C
DB 0x04
DB 0x08

CH_@15:	;<
DB 0x00
DB 0x02
DB 0x04
DB 0x08
DB 0x10
DB 0x08
DB 0x04
DB 0x02

CH_@13:	;=
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x00
DB 0x1F
DB 0x00
DB 0x00

CH_@10:	;>
DB 0x00
DB 0x08
DB 0x04
DB 0x02
DB 0x01
DB 0x02
DB 0x04
DB 0x08

CH_@@7:	;?
DB 0x00
DB 0x0E
DB 0x11
DB 0x01
DB 0x02
DB 0x04
DB 0x00
DB 0x04

CH_@@@@1:	;@
DB 0x00
DB 0x0E
DB 0x11
DB 0x01
DB 0x0D
DB 0x15
DB 0x15
DB 0x0E

CH_A:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x1F
DB 0x11
DB 0x11
DB 0x11

CH_B:
DB 0x00
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E

CH_C:
DB 0x00
DB 0x0E
DB 0x11
DB 0x10
DB 0x10
DB 0x10
DB 0x11
DB 0x0E

CH_D:
DB 0x00
DB 0x1C
DB 0x12
DB 0x11
DB 0x11
DB 0x11
DB 0x12
DB 0x1C

CH_E:
DB 0x00
DB 0x1F
DB 0x10
DB 0x10
DB 0x1E
DB 0x10
DB 0x10
DB 0x1F

CH_F:
DB 0x00
DB 0x1F
DB 0x10
DB 0x10
DB 0x1E
DB 0x10
DB 0x10
DB 0x10

CH_G:
DB 0x00
DB 0x0E
DB 0x11
DB 0x10
DB 0x17
DB 0x11
DB 0x11
DB 0x0E

CH_H:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x1F
DB 0x11
DB 0x11
DB 0x11

CH_I:
DB 0x00
DB 0x0E
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_J:
DB 0x00
DB 0x07
DB 0x02
DB 0x02
DB 0x02
DB 0x02
DB 0x12
DB 0x0C

CH_K:
DB 0x00
DB 0x11
DB 0x12
DB 0x14
DB 0x18
DB 0x14
DB 0x12
DB 0x11

CH_L:
DB 0x00
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x1F

CH_M:
DB 0x00
DB 0x11
DB 0x1B
DB 0x15
DB 0x15
DB 0x11
DB 0x11
DB 0x11

CH_N:
DB 0x00
DB 0x11
DB 0x11
DB 0x19
DB 0x15
DB 0x13
DB 0x11
DB 0x11

CH_O:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x0E

CH_P:
DB 0x00
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E
DB 0x10
DB 0x10
DB 0x10

CH_Q:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x15
DB 0x12
DB 0x0D

CH_R:
DB 0x00
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E
DB 0x14
DB 0x12
DB 0x11

CH_S:
DB 0x00
DB 0x0F
DB 0x10
DB 0x10
DB 0x0E
DB 0x01
DB 0x01
DB 0x1E

CH_T:
DB 0x00
DB 0x1F
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_U:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x0E

CH_V:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x0A
DB 0x04

CH_W:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x15
DB 0x15
DB 0x1B
DB 0x11

CH_X:
DB 0x00
DB 0x11
DB 0x11
DB 0x0A
DB 0x04
DB 0x0A
DB 0x11
DB 0x11

CH_Y:
DB 0x00
DB 0x11
DB 0x11
DB 0x0A
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_Z:
DB 0x00
DB 0x1F
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x10
DB 0x1F

CH_EXT4:	;[
DB 0x00
DB 0x1C
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x1C

CH_EXT5:	;\
DB 0x00
DB 0x00
DB 0x10
DB 0x08
DB 0x04
DB 0x02
DB 0x01
DB 0x00

CH_EXT3:	;]
DB 0x00
DB 0x1C
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x1C

CH_EXT6:	;^
DB 0x00
DB 0x10
DB 0x28
DB 0x44
DB 0x00
DB 0x00
DB 0x00
DB 0x00

CH_EXT7:	;_
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x7E

CH_EXT8:	;`
DB 0x00
DB 0x10
DB 0x08
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00

CH_a:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x01
DB 0x0F
DB 0x11
DB 0x0F

CH_b:
DB 0x00
DB 0x10
DB 0x10
DB 0x16
DB 0x19
DB 0x11
DB 0x11
DB 0x0E

CH_c:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x10
DB 0x10
DB 0x11
DB 0x0E

CH_d:
DB 0x00
DB 0x01
DB 0x01
DB 0x0D
DB 0x13
DB 0x11
DB 0x11
DB 0x0E

CH_e:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x1F
DB 0x10
DB 0x0E

CH_f:
DB 0x00
DB 0x02
DB 0x05
DB 0x04
DB 0x0E
DB 0x04
DB 0x04
DB 0x04

CH_g:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x0F
DB 0x01
DB 0x0E

CH_h:
DB 0x00
DB 0x10
DB 0x10
DB 0x16
DB 0x19
DB 0x11
DB 0x11
DB 0x11

CH_i:
DB 0x00
DB 0x04
DB 0x00
DB 0x0C
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_j:
DB 0x00
DB 0x02
DB 0x00
DB 0x02
DB 0x02
DB 0x02
DB 0x12
DB 0x0C

CH_k:
DB 0x00
DB 0x08
DB 0x08
DB 0x09
DB 0x0A
DB 0x0C
DB 0x0A
DB 0x09

CH_l:
DB 0x00
DB 0x0604
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_m:
DB 0x00
DB 0x00
DB 0x00
DB 0x1A
DB 0x15
DB 0x15
DB 0x15
DB 0x15

CH_n:
DB 0x00
DB 0x00
DB 0x00
DB 0x16
DB 0x19
DB 0x11
DB 0x11
DB 0x11

CH_o:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x0E

CH_p:
DB 0x00
DB 0x00
DB 0x00
DB 0x1E
DB 0x11
DB 0x1E
DB 0x10
DB 0x10

CH_q:
DB 0x00
DB 0x00
DB 0x00
DB 0x0F
DB 0x11
DB 0x0F
DB 0x01
DB 0x01

CH_r:
DB 0x00
DB 0x00
DB 0x00
DB 0x0B
DB 0x0C
DB 0x08
DB 0x08
DB 0x08

CH_s:
DB 0x00
DB 0x00
DB 0x00
DB 0x0F
DB 0x10
DB 0x0E
DB 0x01
DB 0x1E

CH_t:
DB 0x00
DB 0x00
DB 0x04
DB 0x0E
DB 0x04
DB 0x04
DB 0x05
DB 0x02

CH_u:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x13
DB 0x0D

CH_v:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x0A
DB 0x04

CH_w:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x11
DB 0x15
DB 0x15
DB 0x0A

CH_x:
DB 0x00
DB 0x00
DB 0x00
DB 0x19
DB 0x06
DB 0x04
DB 0x0C
DB 0x13

CH_y:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x09
DB 0x06
DB 0x04
DB 0x18

CH_z:
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x02
DB 0x04
DB 0x08
DB 0x1F

CH_EXT10:	;{
DB 0x00
DB 0x0C
DB 0x10
DB 0x10
DB 0x20
DB 0x10
DB 0x10
DB 0x0C

CH_EXT11:	;|
DB 0x00
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10

CH_EXT9:	;}
DB 0x00
DB 0x30
DB 0x08
DB 0x08
DB 0x04
DB 0x08
DB 0x08
DB 0x30

CH_EXT12:	;~
DB 0x00
DB 0x00
DB 0x00
DB 0x32
DB 0x4C
DB 0x00
DB 0x00
DB 0x00

CH_@@@@5:	;square
DB 0x00
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F

;--------------------------------------------------------------------
;PUTPATTERN

#PROC PUTPATTERN
LDA [PageTo]
STA [0xC007]
PutP_Xck:
MOV A,E
SUB D
JM Put_end
MOV A,C
SUB B
JM Put_XCend
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
MOV A,M
STA [0xC004]
INX HL
INC B
JMP PutP_Xck
Put_XCend:
LDA [PatCstX]
MOV B,A
INC D
JMP PutP_Xck
Put_end:
LDA [PageAct]
STA [0xC007]
RET
#END

#PROC PUTPATMIRVER
LDA [PageTo]
STA [0xC007]
MOV A,C
STA [PatCstX]
PutP_Xck2:
MOV A,E
SUB D
JM Put_end2
MOV A,C
SUB B
JM Put_XCend2
MOV A,C
STA [0xC002]
MOV A,D
STA [0xC003]
MOV A,M
STA [0xC004]
INX HL
DEC C
JMP PutP_Xck2
Put_XCend2:
LDA [PatCstX]
MOV C,A
INC D
JMP PutP_Xck2
Put_end2:
LDA [PageAct]
STA [0xC007]
RET
#END

#PROC PUTPATTWIST
LDA [PageTo]
STA [0xC007]
DEC D
MOV A,E
SUB D
STA [DRWtmp]
INC D
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
PutP_Xck3:
MOV A,E
SUB D
JM Put_end3
MOV A,C
SUB B
JM Put_XCend3
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
MOV A,M
STA [0xC004]
LDA [DRWtmp]
ADD L
MOV L,A
MVI A,0
ADC H
MOV H,A
INC B
JMP PutP_Xck3
Put_XCend3:
LDA [PatCstX]
MOV B,A
INC D
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
INX HL
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
JMP PutP_Xck3
Put_end3:
LDA [PageAct]
STA [0xC007]
RET
#END

#PROC PUTPATTWISMIR
LDA [PageTo]
STA [0xC007]
DEC D
MOV A,E
SUB D
STA [DRWtmp]
INC D
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
PutP_Xck4:
MOV A,E
SUB D
JM Put_end4
MOV A,C
SUB B
JM Put_XCend4
MOV A,B
STA [0xC002]
MOV A,E
STA [0xC003]
MOV A,M
STA [0xC004]
LDA [DRWtmp]
ADD L
MOV L,A
MVI A,0
ADC H
MOV H,A
INC B
JMP PutP_Xck4
Put_XCend4:
LDA [PatCstX]
MOV B,A
DEC E
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
INX HL
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
JMP PutP_Xck4
Put_end4:
LDA [PageAct]
STA [0xC007]
RET
#END

#PROC DELPATTERN
PutP_XckDel:
MOV A,E
SUB D
JM Put_endDel
MOV A,C
SUB B
JM Put_XCendDel
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
XOR A
STA [0xC004]
INC B
JMP PutP_XckDel
Put_XCendDel:
LDA [PatCstX]
MOV B,A
INC D
JMP PutP_XckDel
Put_endDel:
RET
#END

;--------------------------------------------------------------------
;DELAY
#PROC DELAY
delayCk:
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
DCX BC
MOV A,B
OR B
JNZ delayCk
MOV A,C
OR C
JNZ delayCk
RET
#END

;--------------------------------------------------------------------
#PROC PLOT
MOV A,B
STA [CurX]
MOV A,C
STA [CurX+1]
STA [0xC002]
MOV A,D
STA [CurY]
MOV A,E
STA [CurY+1]
STA [0xC003]
LDA [SysColor]
STA [0xC004]
RET
#END

;--------------------------------------------------------------------
#PROC RNG
LDA [RNGTABLTEDIM]
MOV D,A
LDA [RNGTABLTEDIM+1]
MOV E,A
MVI H,[HIGH RNGTABLTE]
MVI L,[LOW RNGTABLTE]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI B,0x00
MOV A,M
RRA
MOV C,A
INX DE
MOV A,D
STA [RNGTABLTEDIM]
MOV A,E
STA [RNGTABLTEDIM+1]
MVI A,0x04
AND D
JZ RNGATU%%
MVI A,0x00
STA [RNGTABLTEDIM]
STA [RNGTABLTEDIM+1]
RNGATU%%:
RET
#END

;--------------------------------------------------------------------
#PROC CLRSCR128
MVI A,1
STA [Xcoord]
STA [Ycoord]
MVI C,0x9C
MVI D,0x75
;eggyel tobb sort torol
clrscrciklA%%:
DEC D
MOV A,D
STA [0xC003]	;Yreg
clrscrciklB%%:
DEC C
MOV A,C
STA [0xC002]	;Xreg
XOR A
STA [0xC004]	;Zreg
MVI A,0xFF
AND C
JNZ clrscrciklB%%
MVI C,0x9C
MVI A,0xFF
AND D
JNZ clrscrciklA%%
RET
#END

;--------------------------------------------------------------------
#PROC MP_PUTARRAYD1
LDA [PageTo]
STA [0xC007]
LDA [indexx+1]
MOV E,A
ADD E
MOV E,A
LDA [indexx]
MOV D,A
ADC D
MOV D,A
MOV A,E
ADD L
MOV L,A
MOV A,D
ADC H
MOV H,A
MOV M,B
MVI D,0x00
MVI E,0x01
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MOV M,C
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_PUTSTRING
LDA [PageTo]
STA [0xC007]
LDA [indexx+1]
MOV E,A
LDA [indexx]
MOV D,A
MOV A,E
ADD L
MOV L,A
MOV A,D
ADC H
MOV H,A
MOV M,C
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_PUTARRAYD2
LDA [PageTo]
STA [0xC007]
MOV A,C
ADD L
MOV L,A
MOV A,B
ADC H
MOV H,A
LDA [B_tmp]
MOV B,A
LDA [C_tmp]
MOV C,A
MOV M,B
MVI D,0x00
MVI E,0x01
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MOV M,C
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_GETARRAYD1
LDA [PageTo]
STA [0xC007]
LDA [indexx+1]
MOV C,A
ADD C
MOV C,A
LDA [indexx]
MOV B,A
ADC B
MOV B,A
MOV A,C
ADD L
MOV L,A
MOV A,B
ADC H
MOV H,A
MOV D,M
MVI B,0x00
MVI C,0x01
MOV A,L
ADD C
MOV L,A
MOV A,H
ADC B
MOV H,A
MOV E,M
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_GETSTRING
LDA [PageTo]
STA [0xC007]
LDA [indexx+1]
MOV C,A
LDA [indexx]
MOV B,A
MOV A,C
ADD L
MOV L,A
MOV A,B
ADC H
MOV H,A
MOV E,M
MVI D,0x00
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_GETARRAYD2
LDA [PageTo]
STA [0xC007]
MOV A,C
ADD L
MOV L,A
MOV A,B
ADC H
MOV H,A
MOV D,M
MVI B,0x00
MVI C,0x01
MOV A,L
ADD C
MOV L,A
MOV A,H
ADC B
MOV H,A
MOV E,M
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
MP_GRETURN:
MOV A,E
STA [0xC007]
MOV A,C
STA [MPGJMPlabel%%+2]
MOV A,B
STA [MPGJMPlabel%%+3]
MPGJMPlabel%%:
JMP 0x0000

;--------------------------------------------------------------------
#PROC MP_READ
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MOV B,M
INX HL
MOV C,M
INX DE
INX DE
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SID
LDA [PageTo]
STA [0xC007]
MVI A,0x00
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x01
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x02
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x03
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x04
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg04]
INX HL
MVI A,0x05
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x06
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x07
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x08
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg08]
INX HL
MVI A,0x09
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,10
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,11
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg11]
INX HL
MVI A,12
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,13
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,14
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,15
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,16
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,17
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,18
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg18]
INX HL
MVI A,19
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,20
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,21
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,22
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,23
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,24
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg24]
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SIDS
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,0x00
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x01
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x02
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x03
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x04
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg04]
INX HL
MVI A,0x05
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x06
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x07
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x08
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg08]
INX HL
MVI A,9
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,10
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,11
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg11]
INX HL
MVI A,12
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,13
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,14
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,15
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,16
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,17
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,18
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg18]
INX HL
MVI A,19
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,20
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,21
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,22
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,23
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,24
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg24]
MVI A,25
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SVOICE1
LDA [PageTo]
STA [0xC007]
MVI A,0x00
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x01
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x02
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x03
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x04
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg04]
INX HL
MVI A,0x05
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x06
STA [0xC006]
MOV A,M
STA [0xC005]
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SVOICE1S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,0x00
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x01
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x02
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x03
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x04
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg04]
INX HL
MVI A,0x05
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x06
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,7
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SVOICE2
LDA [PageTo]
STA [0xC007]
MVI A,0x07
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x08
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg08]
INX HL
MVI A,9
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,10
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,11
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg11]
INX HL
MVI A,12
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,13
STA [0xC006]
MOV A,M
STA [0xC005]
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SVOICE2S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,0x07
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x08
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg08]
INX HL
MVI A,9
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,10
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,11
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg11]
INX HL
MVI A,12
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,13
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,7
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SVOICE3
LDA [PageTo]
STA [0xC007]
MVI A,14
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,15
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,16
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,17
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,18
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg18]
INX HL
MVI A,19
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,20
STA [0xC006]
MOV A,M
STA [0xC005]
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SVOICE3S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,14
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,15
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,16
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,17
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,18
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg18]
INX HL
MVI A,19
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,20
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,7
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SFILTER
LDA [PageTo]
STA [0xC007]
MVI A,21
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,22
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,23
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,24
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg24]
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SFILTERS
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,21
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,22
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,23
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,24
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg24]
MVI A,4
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SFREQ1S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,0x01
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x00
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,2
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SPW1S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,0x03
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,0x02
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,2
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SFREQ2S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,0x08
STA [0xC006]
MOV A,M
STA [0xC005]
STA [SIDreg08]
INX HL
MVI A,0x07
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,2
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SPW2S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,10
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,9
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,2
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SFREQ3S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,15
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,14
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,2
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

;--------------------------------------------------------------------
#PROC MP_SPW3S
LDA [PageTo]
STA [0xC007]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI A,17
STA [0xC006]
MOV A,M
STA [0xC005]
INX HL
MVI A,16
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,0x01
STA [0xC006]
MOV A,M
STA [0xC005]
MVI A,2
ADD E
MOV E,A
MVI A,0
ADC D
MOV D,A
LDA [PageAct]
STA [0xC007]
RET
#END

INPOERR: DB 0x00
;--------------------------------------------------------------------
#PROC GETCHAR
;Gets char from input, returns zero if no char present
;This function does not wait for character, it returns immediately!
;C=character from input
MVI A,0x00
STA [INPOERR]
LDA [0xC00D]
MOV B,A
MVI A,0x01
AND B
JZ nocharinp

MVI A,0x08
AND B
JZ noframeerr
bufempty_oerr:
MVI C,18
inputerrbuf:
LDA [0xC008]
DEC C
JNZ inputerrbuf
JMP nocharinp
noframeerr:
MVI A,0x02
AND B
JZ nooverrun
MVI A,0x01
STA [INPOERR]
nooverrun:

;f sztgazs
LDA [0xC008]
CMA
MOV B,A
MVI A,0xE0
SUB B
JZ scanE0
MVI A,0xE1
SUB B
JZ pausechar
MVI A,0xF0
SUB B
JZ breakchar

;rendes karakter
MVI A,0x1C
SUB B
JZ SCH_A
MVI A,0x32
SUB B
JZ SCH_B
MVI A,0x21
SUB B
JZ SCH_C
MVI A,0x23
SUB B
JZ SCH_D
MVI A,0x24
SUB B
JZ SCH_E
MVI A,0x2B
SUB B
JZ SCH_F
MVI A,0x34
SUB B
JZ SCH_G
MVI A,0x33
SUB B
JZ SCH_H
MVI A,0x43
SUB B
JZ SCH_I
MVI A,0x3B
SUB B
JZ SCH_J
MVI A,0x42
SUB B
JZ SCH_K
MVI A,0x4B
SUB B
JZ SCH_L
MVI A,0x3A
SUB B
JZ SCH_M
MVI A,0x31
SUB B
JZ SCH_N
MVI A,0x44
SUB B
JZ SCH_O
MVI A,0x4D
SUB B
JZ SCH_P
MVI A,0x15
SUB B
JZ SCH_Q
MVI A,0x2D
SUB B
JZ SCH_R
MVI A,0x1B
SUB B
JZ SCH_S
MVI A,0x2C
SUB B
JZ SCH_T
MVI A,0x3C
SUB B
JZ SCH_U
MVI A,0x2A
SUB B
JZ SCH_V
MVI A,0x1D
SUB B
JZ SCH_W
MVI A,0x22
SUB B
JZ SCH_X
MVI A,0x35
SUB B
JZ SCH_Y
MVI A,0x1A
SUB B
JZ SCH_Z
MVI A,0x45
SUB B
JZ SCH_0
MVI A,0x16
SUB B
JZ SCH_1
MVI A,0x1E
SUB B
JZ SCH_2
MVI A,0x26
SUB B
JZ SCH_3
MVI A,0x25
SUB B
JZ SCH_4
MVI A,0x2E
SUB B
JZ SCH_5
MVI A,0x36
SUB B
JZ SCH_6
MVI A,0x3D
SUB B
JZ SCH_7
MVI A,0x3E
SUB B
JZ SCH_8
MVI A,0x46
SUB B
JZ SCH_9
MVI A,0x0E
SUB B
JZ CH_APOSTR
MVI A,0x4E
SUB B
JZ CH_MINUS
MVI A,0x55
SUB B
JZ CH_EQUAL
MVI A,0x5D
SUB B
JZ CH_BACKSL
MVI A,0x66
SUB B
JZ CH_BACKSP
MVI A,0x29
SUB B
JZ CH_SPACE
MVI A,0x0D
SUB B
JZ CH_TAB
MVI A,0x58
SUB B
JZ CH_CAPS
MVI A,0x12
SUB B
JZ CH_LSHIFT
MVI A,0x14
SUB B
JZ CH_CTRL
MVI A,0x11
SUB B
JZ CH_ALT
MVI A,0x59
SUB B
JZ CH_RSHIFT
MVI A,0x5A
SUB B
JZ CH_ENTER
MVI A,0x76
SUB B
JZ CH_ESC
MVI A,0x05
SUB B
JZ CH_F1
MVI A,0x06
SUB B
JZ CH_F2
MVI A,0x04
SUB B
JZ CH_F3
MVI A,0x0C
SUB B
JZ CH_F4
MVI A,0x03
SUB B
JZ CH_F5
MVI A,0x0B
SUB B
JZ CH_F6
MVI A,0x83
SUB B
JZ CH_F7
MVI A,0x0A
SUB B
JZ CH_F8
MVI A,0x01
SUB B
JZ CH_F9
MVI A,0x09
SUB B
JZ CH_F10
MVI A,0x78
SUB B
JZ CH_F11
MVI A,0x07
SUB B
JZ CH_F12
MVI A,0x7E
SUB B
JZ CH_SCROLL
MVI A,0x54
SUB B
JZ CH_BRACKLEFT
MVI A,0x77
SUB B
JZ CH_NUM
MVI A,0x7C
SUB B
JZ CH_KPSTAR
MVI A,0x7B
SUB B
JZ CH_KPMINUS
MVI A,0x79
SUB B
JZ CH_KPPLUS
MVI A,0x71
SUB B
JZ CH_KPPOINT
MVI A,0x70
SUB B
JZ SCH_0
MVI A,0x69
SUB B
JZ SCH_1
MVI A,0x72
SUB B
JZ SCH_2
MVI A,0x7A
SUB B
JZ SCH_3
MVI A,0x6B
SUB B
JZ SCH_4
MVI A,0x73
SUB B
JZ SCH_5
MVI A,0x74
SUB B
JZ SCH_6
MVI A,0x6C
SUB B
JZ SCH_7
MVI A,0x75
SUB B
JZ SCH_8
MVI A,0x7D
SUB B
JZ SCH_9
MVI A,0x5B
SUB B
JZ CH_BRACKRIGHT
MVI A,0x4C
SUB B
JZ CH_COMMA2
MVI A,0x52
SUB B
JZ CH_APOSTROF
MVI A,0x41
SUB B
JZ CH_COMMA1
MVI A,0x49
SUB B
JZ CH_POINT
MVI A,0x4A
SUB B
JZ CH_PER
JMP nocharinp

;E0-s sztgazs
scanE0:
LDA [0xC00D]
MVI B,0x01
AND B
JZ scanE0
LDA [0xC008]
CMA
MOV B,A
MVI A,0xF0
SUB B
JZ scanE0F0
MVI A,0x12
SUB B
JZ CH_printscr

;vezrl karakterek
MVI A,0x1F
SUB B
JZ CH_LGUI
MVI A,0x14
SUB B
JZ CH_CTRL
MVI A,0x27
SUB B
JZ CH_RGUI
MVI A,0x11
SUB B
JZ CH_ALT
MVI A,0x70
SUB B
JZ CH_INSERT
MVI A,0x6C
SUB B
JZ CH_HOME
MVI A,0x7D
SUB B
JZ CH_PGUP
MVI A,0x71
SUB B
JZ CH_DELETE
MVI A,0x69
SUB B
JZ CH_END
MVI A,0x7A
SUB B
JZ CH_PGDWN
MVI A,0x75
SUB B
JZ CH_UARROW
MVI A,0x6B
SUB B
JZ CH_LARROW
MVI A,0x72
SUB B
JZ CH_DARROW
MVI A,0x74
SUB B
JZ CH_RARROW
MVI A,0x4A
SUB B
JZ CH_PER
MVI A,0x5A
SUB B
JZ CH_ENTER
JMP nocharinp

;E0,F0 sztgazs
scanE0F0:
LDA [0xC00D]
MVI B,0x01
AND B
JZ scanE0F0
LDA [0xC008]
CMA
MOV B,A
MVI A,0x7C
SUB B
JZ PrintScrBrk
;E0,F0 break char
JMP nocharinp

;F0 Break char sztgazs
breakchar:
LDA [0xC00D]
MVI B,0x01
AND B
JZ breakchar
LDA [0xC008]
JMP nocharinp

;Character termins
pausechar:
LDA [0xC00D]
MVI B,0x01
AND B
JZ pausechar
LDA [0xC008]
pausechar12:
LDA [0xC00D]
MVI B,0x01
AND B
JZ pausechar12
LDA [0xC008]
pausechar13:
LDA [0xC00D]
MVI B,0x01
AND B
JZ pausechar13
LDA [0xC008]
pausechar14:
LDA [0xC00D]
MVI B,0x01
AND B
JZ pausechar14
LDA [0xC008]
pausechar15:
LDA [0xC00D]
MVI B,0x01
AND B
JZ pausechar15
LDA [0xC008]
pausechar16:
LDA [0xC00D]
MVI B,0x01
AND B
JZ pausechar16
LDA [0xC008]
pausechar17:
LDA [0xC00D]
MVI B,0x01
AND B
JZ pausechar17
LDA [0xC008]
MVI C,22
JMP char_end
SCH_A:
MVI C,0x41
JMP char_end
SCH_B:
MVI C,0x42
JMP char_end
SCH_C:
MVI C,0x43
JMP char_end
SCH_D:
MVI C,0x44
JMP char_end
SCH_E:
MVI C,0x45
JMP char_end
SCH_F:
MVI C,0x46
JMP char_end
SCH_G:
MVI C,0x47
JMP char_end
SCH_H:
MVI C,0x48
JMP char_end
SCH_I:
MVI C,0x49
JMP char_end
SCH_J:
MVI C,0x4A
JMP char_end
SCH_K:
MVI C,0x4B
JMP char_end
SCH_L:
MVI C,0x4C
JMP char_end
SCH_M:
MVI C,0x4D
JMP char_end
SCH_N:
MVI C,0x4E
JMP char_end
SCH_O:
MVI C,0x4F
JMP char_end
SCH_P:
MVI C,0x50
JMP char_end
SCH_Q:
MVI C,0x51
JMP char_end
SCH_R:
MVI C,0x52
JMP char_end
SCH_S:
MVI C,0x53
JMP char_end
SCH_T:
MVI C,0x54
JMP char_end
SCH_U:
MVI C,0x55
JMP char_end
SCH_V:
MVI C,0x56
JMP char_end
SCH_W:
MVI C,0x57
JMP char_end
SCH_X:
MVI C,0x58
JMP char_end
SCH_Y:
MVI C,0x59
JMP char_end
SCH_Z:
MVI C,0x5A
JMP char_end
SCH_0:
MVI C,0x30
JMP char_end
SCH_1:
MVI C,0x31
JMP char_end
SCH_2:
MVI C,0x32
JMP char_end
SCH_3:
MVI C,0x33
JMP char_end
SCH_4:
MVI C,0x34
JMP char_end
SCH_5:
MVI C,0x35
JMP char_end
SCH_6:
MVI C,0x36
JMP char_end
SCH_7:
MVI C,0x37
JMP char_end
SCH_8:
MVI C,0x38
JMP char_end
SCH_9:
MVI C,0x39
JMP char_end
CH_APOSTR:
MVI C,0x60
JMP char_end
CH_MINUS:
MVI C,0x2D
JMP char_end
CH_EQUAL:
MVI C,0x3D
JMP char_end
CH_BACKSL:
MVI C,0x5C
JMP char_end
CH_BACKSP:
MVI C,0x8
JMP char_end
CH_SPACE:
MVI C,0x20
JMP char_end
CH_TAB:
MVI C,0x09
JMP char_end
CH_CAPS:
MVI C,10
JMP char_end
CH_LSHIFT:
MVI C,11
JMP char_end
CH_CTRL:
MVI C,12
JMP char_end
CH_ALT:
MVI C,14
JMP char_end
CH_RSHIFT:
MVI C,11
JMP char_end
CH_ENTER:
MVI C,0x0D
JMP char_end
CH_ESC:
MVI C,27
JMP char_end
CH_F1:
MVI C,1
JMP char_end
CH_F2:
MVI C,2
JMP char_end
CH_F3:
MVI C,3
JMP char_end
CH_F4:
MVI C,4
JMP char_end
CH_F5:
MVI C,5
JMP char_end
CH_F6:
MVI C,6
JMP char_end
CH_F7:
MVI C,7
JMP char_end
CH_F8:
MVI C,15
JMP char_end
CH_F9:
MVI C,16
JMP char_end
CH_F10:
MVI C,17
JMP char_end
CH_F11:
MVI C,18
JMP char_end
CH_F12:
MVI C,19
JMP char_end
CH_SCROLL:
MVI C,21
JMP char_end
CH_BRACKLEFT:
MVI C,0x5B
JMP char_end
CH_NUM:
MVI C,29
JMP char_end
CH_KPSTAR:
MVI C,0x2A
JMP char_end
CH_KPMINUS:
MVI C,0x2D
JMP char_end
CH_KPPLUS:
MVI C,0x2B
JMP char_end
CH_KPPOINT:
MVI C,0x2E
JMP char_end
CH_BRACKRIGHT:
MVI C,0x5D
JMP char_end
CH_COMMA2:
MVI C,0x3B
JMP char_end
CH_APOSTROF:
MVI C,0x60
JMP char_end
CH_COMMA1:
MVI C,0x2C
JMP char_end
CH_POINT:
MVI C,0x2E
JMP char_end
CH_PER:
MVI C,0x2F
JMP char_end

;vezrl char termins
CH_printscr:
LDA [0xC00D]
MVI B,0x01
AND B
JZ CH_printscr
LDA [0xC008]
CH_printscr2:
LDA [0xC00D]
MVI B,0x01
AND B
JZ CH_printscr2
LDA [0xC008]
MVI C,20
JMP char_end
CH_LGUI:
MVI C,30
JMP char_end
CH_RGUI:
MVI C,31
JMP char_end
CH_INSERT:
MVI C,23
JMP char_end
CH_HOME:
MVI C,24
JMP char_end
CH_PGUP:
MVI C,25
JMP char_end
CH_DELETE:
MVI C,26
JMP char_end
CH_END:
MVI C,27
JMP char_end
CH_PGDWN:
MVI C,28
JMP char_end
CH_UARROW:
MVI C,38
JMP char_end
CH_LARROW:
MVI C,37
JMP char_end
CH_DARROW:
MVI C,40
JMP char_end
CH_RARROW:
MVI C,39
JMP char_end
PrintScrBrk:
LDA [0xC00D]
MVI B,0x01
AND B
JZ PrintScrBrk
LDA [0xC008]
PrintScrBrk2:
LDA [0xC00D]
MVI B,0x01
AND B
JZ PrintScrBrk2
LDA [0xC008]
PrintScrBrk3:
LDA [0xC00D]
MVI B,0x01
AND B
JZ PrintScrBrk3
LDA [0xC008]
JMP nocharinp

nocharinp:
MVI C,0
char_end:
LDA [INPOERR]
MVI B,0x01
SUB B
JZ inpoerr_2
RET
inpoerr_2:
XOR A
STA [INPOERR]
JMP bufempty_oerr
#END

;--------------------------------------------------------------------
maxcharnum:
DB 0x00
charbufpoi:
DB 0x00
curblinktimer:
DB 0x00,0x3F
curblinkcycle:
DB 0x10
curstate:
DB 0x00
inpbufaddr:
DB 0x00,0x00
XcoordOrig:
DB 0x00
YcoordOrig:
DB 0x00
XcoordOld:
DB 0x00
YcoordOld:
DB 0x00

#PROC INPUT
;HL=inp. buff. addr.
;B=max char num
;BACKSPACE - delete last input
;ENTER - end input
;checking of maximum character
LDA [PageTo]
STA [0xC007]
MOV A,B
STA [maxcharnum]
MVI A,0x01
STA [charbufpoi]
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
LDA [Xcoord]
STA [XcoordOrig]
LDA [Ycoord]
STA [YcoordOrig]

inpcikl:

chinpi:
CALL GETCHAR
MVI A,0xFF
AND C
JNZ inpchar
LDA [Xcoord]
STA [XcoordOld]
LDA [Ycoord]
STA [YcoordOld]
LDA [curblinkcycle]
MOV C,A
DEC C
MOV A,C
STA [curblinkcycle]
JZ blinkChange
JMP blinkcont
blinkChange:
MVI A,0x10
STA [curblinkcycle]
LDA [curstate]
MVI C,0xFF
AND C
JNZ blinkToOFF
MVI A,0xFF
STA [curstate]
JMP blinkcont
blinkToOFF:
MVI A,0x00
STA [curstate]
blinkcont:
LDA [curstate]
MVI C,0xFF
AND C
JZ blinkON
JMP blinkOFF
blinkON:
MVI C,127
JMP curblink
blinkOFF:
MVI C,32
curblink:
CALL PUTCHAR
LDA [XcoordOld]
STA [Xcoord]
LDA [YcoordOld]
STA [Ycoord]
LDA [curblinktimer]
MOV B,A
LDA [curblinktimer+1]
MOV C,A
CALL DELAY
JMP chinpi

inpchar:
MVI A,13
SUB C
JZ ch_enter
MVI A,8
SUB C
JZ ch_bkspace
;check cursor coordinates
LDA [Ycoord]
MVI B,13
SUB B
JNZ coordOk
LDA [Xcoord]
MVI B,17
SUB B
JNZ coordOk
JMP inpcikl
coordOk:
;store character if buffer is not full
LDA [charbufpoi]
MOV B,A
LDA [maxcharnum]
SUB B
JZ inpcikl
LDA [inpbufaddr]
MOV H,A
LDA [inpbufaddr+1]
MOV L,A
MOV M,C
INX HL
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
CALL PUTCHAR
LDA [charbufpoi]
MOV B,A
INC B
STA [charbufpoi]
JMP inpcikl
;ENTER
ch_enter:
MVI C,32
CALL PUTCHAR
LDA [inpbufaddr]
MOV H,A
LDA [inpbufaddr+1]
MOV L,A
MVI C,0
MOV M,C
LDA [PageAct]
STA [0xC007]
RET
;BACKSPACE
ch_bkspace:
LDA [XcoordOrig]
MOV B,A
LDA [Xcoord]
SUB B
JNZ pbkspace
LDA [YcoordOrig]
MOV B,A
LDA [Ycoord]
SUB B
JNZ pbkspace
JMP inpcikl

pbkspace:
LDA [charbufpoi]
MOV B,A
DEC B
STA [charbufpoi]
LDA [inpbufaddr]
MOV H,A
LDA [inpbufaddr+1]
MOV L,A
DCX HL
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
MVI C,32
LDA [Xcoord]
STA [XcoordOld]
LDA [Ycoord]
STA [YcoordOld]
CALL PUTCHAR
LDA [XcoordOld]
STA [Xcoord]
LDA [YcoordOld]
STA [Ycoord]

LDA [Xcoord]
MOV B,A
DEC B
MOV A,B
STA [Xcoord]
JZ inpXzero
JMP inpcikl
inpXzero:
MVI A,18
STA [Xcoord]
LDA [Ycoord]
MOV B,A
DEC B
MOV A,B
STA [Ycoord]

JMP inpcikl
#END


;--------------------------------------------------------------------
#PROC STRCPY
;STRCPY
;DE=destination
;HL=source
strcpck:
LDA [PageTo2]
STA [0xC007]
MOV B,M
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
MOV H,D
MOV L,E
LDA [PageTo]
STA [0xC007]
MOV M,B
LDA [inpbufaddr]
MOV H,A
LDA [inpbufaddr+1]
MOV L,A
INX HL
INX DE
XOR A
OR B
JZ sckend
JMP strcpck
sckend:
LDA [PageAct]
STA [0xC007]
RET
#END


;--------------------------------------------------------------------
#PROC STRCMP
;STRCMP
;DE=str1
;HL=str2
;out:
;BC=output result
MVI A,0xFF
STA [curstate]
strcpck1:
LDA [PageTo2]
STA [0xC007]
MOV B,M
XOR A
OR B
JZ str2_zero
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
MOV H,D
MOV L,E
LDA [PageTo]
STA [0xC007]
MOV C,M
LDA [inpbufaddr]
MOV H,A
LDA [inpbufaddr+1]
MOV L,A
XOR A
OR C
JZ str1_zero
MOV A,C
SUB B
JZ scmp_eq
JC scmp_big
JMP scmp_sma
scmp_eq:
INX HL
INX DE
JMP strcpck1
str2_zero:
MVI A,0x00
STA [curstate]
MOV H,D
MOV L,E
LDA [PageTo]
STA [0xC007]
MOV D,M
XOR A
OR D
JZ scmp_equ
JMP scmp_big
str1_zero:
JMP scmp_sma
scmp_equ:
XOR A
MOV B,A
MOV C,A
JMP scmp_end
scmp_big:
XOR A
MOV B,A
MVI A,0x01
MOV C,A
JMP scmp_end
scmp_sma:
MVI A,0xFF
MOV B,A
MOV C,A
scmp_end:
LDA [PageAct]
STA [0xC007]
RET
#END


;--------------------------------------------------------------------
#PROC STRPOS
;STRPOS
;DE=str1 -ben az str2-t keresi
;HL=str2
;out:
;BC=output result
XOR A
STA [curblinkcycle]
strcpck3:
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
MOV A,D
STA [D_tmp]
MOV A,E
STA [E_tmp]
CALL STRCMP
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
LDA [D_tmp]
MOV D,A
LDA [E_tmp]
MOV E,A
LDA [curstate]
MVI B,0x00
OR B
JZ strposOK
INX DE
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
MOV H,D
MOV L,E
LDA [PageTo]
STA [0xC007]
MOV A,M
MVI B,0
OR B
JZ strposNOK
LDA [inpbufaddr]
MOV H,A
LDA [inpbufaddr+1]
MOV L,A
LDA [curblinkcycle]
MOV B,A
INC B
MOV A,B
STA [curblinkcycle]
MVI B,0xFF
SUB B
JZ strposNOK
JMP strcpck3
strposNOK:
MVI A,0xFF
MOV B,A
MOV C,A
JMP strpoEND
strposOK:
LDA [curblinkcycle]
MOV C,A
XOR A
MOV B,A
strpoEND:
LDA [PageAct]
STA [0xC007]
RET
#END


;--------------------------------------------------------------------
#PROC STRCAT
;STRCAT
;DE=str1
;HL=str2
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
MOV H,D
MOV L,E
strckx:
LDA [PageTo]
STA [0xC007]
MOV B,M
XOR A
OR B
JZ strcat_out
INX HL
JMP strckx
strcat_out:
MOV D,H
MOV E,L
LDA [inpbufaddr]
MOV H,A
LDA [inpbufaddr+1]
MOV L,A
CALL STRCPY
LDA [PageAct]
STA [0xC007]
RET
#END


;--------------------------------------------------------------------
#PROC STRLEN
;STRLEN
;HL=string
;BC=output result
LDA [PageTo]
STA [0xC007]
XOR A
STA [curblinkcycle]
strlenck:
MOV B,M
XOR A
OR B
JZ strlen_out
INX HL
LDA [curblinkcycle]
MOV B,A
INC B
MOV A,B
STA [curblinkcycle]
JMP strlenck
strlen_out:
LDA [curblinkcycle]
MOV C,A
XOR A
MOV B,A
LDA [PageAct]
STA [0xC007]
RET
#END


;--------------------------------------------------------------------
decmul:
DB 0x00,0x00
negnum:
DB 0x00
NUMres:
DB 0x00,0x00

#PROC STRTONUM
;STRTONUM
;HL=string
;BC=output result number
LDA [PageTo]
STA [0xC007]
MOV A,M
MVI B,0
SUB B
JZ strtonum_noinp
JMP atu_21310_
strtonum_noinp:
XOR A
MOV B,A
MOV C,A
JMP SNend
atu_21310_:
MVI A,0
STA [decmul]
MVI A,1
STA [decmul+1]

MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]

XOR A
STA [NUMres]
STA [NUMres+1]

;check if negative
XOR A
STA [negnum]
MOV B,M
MVI A,45
SUB B
JZ SNnegativ
JMP SNszero
SNnegativ:
MVI A,1
STA [negnum]
MVI A,48
MOV M,A

;search ZERO
SNszero:
MOV A,M
MVI B,0
OR B
JZ SNszend
INX HL
JMP SNszero
SNszend:

SNconvCk:
DCX HL
MOV A,M
MVI B,48
SUB B
MOV C,A
MVI B,0

LDA [decmul]
MOV D,A
LDA [decmul+1]
MOV E,A

MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
CALL UMultiply
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A

;NUMres+=BC
LDA [NUMres+1]
ADD C
STA [NUMres+1]
LDA [NUMres]
ADC B
STA [NUMres]

;decmul*=10
LDA [decmul]
MOV D,A
LDA [decmul+1]
MOV E,A
MVI B,0
MVI C,10
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
CALL UMultiply
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
MOV A,B
STA [decmul]
MOV A,C
STA [decmul+1]

;last char?
LDA [inpbufaddr]
SUB H
JNZ SNconvCk
LDA [inpbufaddr+1]
SUB L
JNZ SNconvCk

;if(negnum)NUMres*=-1;
LDA [negnum]
MVI B,0
OR B
JZ SNpositive

LDA [NUMres]
MOV B,A
LDA [NUMres+1]
MOV C,A
DCX BC
MOV A,B
CMA 
MOV B,A
MOV A,C
CMA 
MOV C,A
JMP SNend

SNpositive:
LDA [NUMres]
MOV B,A
LDA [NUMres+1]
MOV C,A

SNend:
LDA [PageAct]
STA [0xC007]
RET
#END


;--------------------------------------------------------------------
#PROC NUMTOSTR
;NUMTOSTR
;HL=string buffer
;BC=input number
LDA [PageTo]
STA [0xC007]
MVI A,1
STA [PrNumRedir]
MOV A,H
STA [inpbufaddr]
MOV A,L
STA [inpbufaddr+1]
LDA [Radix]
MVI H,0xFF
AND H
JZ NTSradixhex
CALL PRINTDEC
JMP NTSradixdec
NTSradixhex:
MVI A,0x01
STA [HEXANUMMODE]
CALL XPRINT
NTSradixdec:
MVI A,0
STA [PrNumRedir]
LDA [PageAct]
STA [0xC007]
RET

;redirection directs here:
Predirection:
LDA [inpbufaddr]
MOV D,A
LDA [inpbufaddr+1]
MOV E,A
CALL STRCPY
JMP xkilep
#END
