//OPENFILENAME
//File opening dialog box

#include "OpenFileClass.h"

TOpenPictureDialog::TOpenPictureDialog(HWND hwnd){
    ownerwin=hwnd;
}

TOpenPictureDialog::~TOpenPictureDialog(){

}

bool TOpenPictureDialog::Execute(){
    char szFile[260];
    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = ownerwin;
    ofn.lpstrFile = szFile;
    ofn.lpstrFile[0] = '\0';
    ofn.nMaxFile = sizeof(szFile);
    ofn.lpstrFilter = "Pictures\0*.BMP\0*.bmp\0";
    ofn.nFilterIndex = 1;
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle = "Open Picture\0";
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
 
    // Display the Open dialog box. 
 
    if (GetOpenFileName(&ofn)==TRUE){
       FileName=ofn.lpstrFile;
       return true;
    } else {
       return false; 
    }
}

//************************************************************

TOpenDialog::TOpenDialog(HWND hwnd){
    ownerwin=hwnd;
}

TOpenDialog::~TOpenDialog(){

}

bool TOpenDialog::Execute(){
    char szFile[260];
    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = ownerwin;
    ofn.lpstrFile = szFile;
    ofn.lpstrFile[0] = '\0';
    ofn.nMaxFile = sizeof(szFile);
    ofn.lpstrFilter = Filter;
    ofn.nFilterIndex = 1;
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle = "Open File\0";
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
 
    // Display the Open dialog box. 
 
    if (GetOpenFileName(&ofn)==TRUE){
       FileName=ofn.lpstrFile;
       return true;
    } else {
       return false; 
    }
}


//************************************************************

TSaveDialog::TSaveDialog(HWND hwnd){
    ownerwin=hwnd;
}

TSaveDialog::~TSaveDialog(){

}

bool TSaveDialog::Execute(){
    char szFile[260];
    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = ownerwin;
    ofn.lpstrFile = szFile;
    ofn.lpstrFile[0] = '\0';
    ofn.nMaxFile = sizeof(szFile);
    ofn.lpstrFilter = Filter;
    ofn.nFilterIndex = 1;
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle = "Save File\0";
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
 
    // Display the Open dialog box. 
 
    if (GetSaveFileName(&ofn)==TRUE){
       FileName=ofn.lpstrFile;
       return true;
    } else {
       return false; 
    }
}
