//TCheckBox

#include "TCheckBox.h"
extern int IDord;


TCheckBox::TCheckBox(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size):
Checked(this, &TCheckBox::GetChecked, &TCheckBox::SetChecked, &TCheckBox::GetRefChecked)
{
	CheckBoxHwnd = CreateWindow( "Button", Caption, 
                        WS_CHILD | WS_VISIBLE | BS_CHECKBOX,
						Size[0],Size[1],Size[2],Size[3],						 
						hwnd, (HMENU)IDord,
                        hinst, 0 );

    ID=IDord++;
	
	CheckedState=false;
	Check(false);
	hFont=NULL;
	
	CheckBoxProcAddr = (WNDPROC)GetWindowLong(CheckBoxHwnd, GWL_WNDPROC);
	SetWindowLong(CheckBoxHwnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(&TCheckBox::StatWndProc));
}

TCheckBox::~TCheckBox(){
	//if(hFont)DeleteObject(hFont);
}

void TCheckBox::SetChecked(const bool & ckh){
	CheckedState=ckh;
    Check(ckh);
}

const bool & TCheckBox::GetChecked() const{
    return CheckedState;
}

bool & TCheckBox::GetRefChecked() {
    return CheckedState;
}

void TCheckBox::Check(bool state){
	if(state)
		SendMessage(CheckBoxHwnd, BM_SETCHECK , BST_CHECKED, 0);
	else
		SendMessage(CheckBoxHwnd, BM_SETCHECK , BST_UNCHECKED, 0);
}

void TCheckBox::SetDefFont(){
	hFont = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	SendMessage(CheckBoxHwnd,WM_SETFONT ,(WPARAM)hFont,true);
}
