//MainForm
#include "CpuSimForm.h"
#include "CpuSimFormParams.h"


#define TIMERSLOW	50
#define TIMERFAST	10
#define RUNNUMFAST	10000
#define RUNNUMSLOW	1

#include "..\CPUsimDlg\CPUsimDlgForm.h"

extern CPUsimDlg* CPUsimDialog;

MainForm::MainForm(){
	Timer1=NULL;
	run=0;
	intimer=0;
	SidAudio=NULL;
	//CODE=NULL;
	
    CreateSpecial("Machine Simulator",20,20,1040,670,1);
	
	KEYBpoi=0;
}

MainForm::~MainForm(){
//user code here
	FormDestroy();
	
    DestroyForm();
	if(SidAudio)delete SidAudio;
	SidAudio=NULL;
}

//Build up form
void MainForm::BuildForm(HWND hwnd,HINSTANCE hInst){
	AnsiString s(hwnd);
    CreateGrElem( Label,   Label1 );
    CreateGrElem( Label,   Label2 );
    CreateGrElem( Label,   Label3 );
    CreateGrElem( Label,   Label4 );
    CreateGrElem( Label,   Label5 );
    CreateGrElem( Label,   Label6 );
    CreateGrElem( Label,   Label7 );
    CreateGrElem( Label,   Label8 );
    CreateGrElem( TGroupBox,   GroupBox2 );
    CreateGrElem( Label,   Label12 );
    CreateGrElem( Label,   Label13 );
    CreateGrElem( Label,   Label14 );
    CreateGrElem( Label,   Label15 );
    CreateGrElem( Label,   Label16 );
    CreateGrElem( Label,   Label17 );
    CreateGrElem( Label,   Label18 );
    CreateGrElem( Label,   Label19 );
    CreateGrElem( TGroupBox,   GroupBox1 );
    CreateGrElem( Label,   Label9 );
    CreateGrElem( Label,   Label10 );
    CreateGrElem( Label,   Label11 );
    CreateGrElem( Memo,   Memo1 );
    CreateSpecGrElem( Memo,   Memo2 );
    CreateSpecGrElem( Memo,   Memo3 );
    CreateSpecGrElem( Memo,   Memo4 );
    CreateGrElem( Button,   Button1 );
    CreateGrElem( Button,   Button2 );
    CreateGrElem( Button,   Button3 );
    CreateGrElem( Button,   Button4 );
    CreateGrElem( EditBox,   Edit1 );
    CreateGrElem( EditBox,   Edit2 );
    CreateGrElem( EditBox,   Edit3 );
    CreateGrElem( TCheckBox,   CheckBox1 );
    CreateGrElem( EditBox,   Edit4 );
    CreateGrElem( EditBox,   Edit5 );
    CreateGrElem( EditBox,   Edit6 );
    CreateGrElem( EditBox,   Edit7 );
    CreateGrElem( Button,   Button5 );
    CreateGrElem( EditBox,   Edit8 );
    CreateGrElem( EditBox,   Edit9 );
    CreateGrElem( EditBox,   Edit10 );
    CreateGrElem( EditBox,   Edit11 );
    CreateGrElem( EditBox,   Edit12 );
    CreateGrElem( EditBox,   Edit13 );
    CreateGrElem( EditBox,   Edit14 );
    CreateGrElem( EditBox,   Edit15 );
    CreateGrElem( EditBox,   Edit16 );
    CreateGrElem( EditBox,   Edit17 );
    CreateGrElem( EditBox,   Edit18 );
    CreateGrElem( Button,   Button6 );
    CreateGrElem( Button,   Button7 );
    CreateGrElem( Button,   Button8 );
    CreateGrElem( Button,   Button9 );
    CreateGrElem( Button,   Button10 );
    CreateGrElem( Button,   Button11 );
    CreateGrElem( Button,   Button12 );
    CreateGrElem( Button,   Button13 );
    CreateGrElem( Button,   Button14 );
    CreateGrElem( Button,   Button15 );
    CreateGrElem( Button,   Button16 );	
	CreateGrElem( Button,   Button17 );	
	
	Button1->SetDefFont();
	Button2->SetDefFont();
	Button3->SetDefFont();
	Button4->SetDefFont();
	Button5->SetDefFont();
	Button6->SetDefFont();
	Button7->SetDefFont();
	Button8->SetDefFont();
	Button9->SetDefFont();
	Button10->SetDefFont();
	Button11->SetDefFont();
	Button12->SetDefFont();
	Button13->SetDefFont();
	Button14->SetDefFont();
	Button15->SetDefFont();
	Button16->SetDefFont();
	Button17->SetDefFont();
	
	Label1->SetDefFont();
	Label2->SetDefFont();
	Label3->SetDefFont();
	Label4->SetDefFont();
	Label5->SetDefFont();
	Label6->SetDefFont();
	Label7->SetDefFont();
	Label8->SetDefFont();
	Label9->SetDefFont();
	Label10->SetDefFont();
	Label11->SetDefFont();
	Label12->SetDefFont();
	Label13->SetDefFont();
	Label14->SetDefFont();
	Label15->SetDefFont();
	Label16->SetDefFont();
	Label17->SetDefFont();
	Label18->SetDefFont();
	Label19->SetDefFont();
	
	GroupBox1->SetDefFont();
	GroupBox2->SetDefFont();
	CheckBox1->SetDefFont();
	
	Edit1->SetDefFont();
	Edit2->SetDefFont();
	Edit3->SetDefFont();
	Edit4->SetDefFont();
	Edit5->SetDefFont();
	Edit6->SetDefFont();
	Edit7->SetDefFont();
	Edit8->SetDefFont();
	Edit9->SetDefFont();
	Edit10->SetDefFont();
	Edit11->SetDefFont();
	Edit12->SetDefFont();
	Edit13->SetDefFont();
	Edit14->SetDefFont();
	Edit15->SetDefFont();
	Edit16->SetDefFont();
	Edit17->SetDefFont();
	Edit18->SetDefFont();

	Memo1->SetDefFont();
	Memo2->SetDefFont();
	Memo3->SetDefFont();
	Memo4->SetDefFont();

	/*
	Memo1->ReadOnly(true);
	Memo2->ReadOnly(true);
	Memo3->ReadOnly(true);
	Memo4->ReadOnly(true);
	*/
	
	Timer1=new TimerClass(hwnd,TIMERSLOW);
	Canvas=new CanvasClass(hwnd,491,236,SCRX*2,SCRY*2,1);
	OpenDialog1=new TOpenDialog(hwnd);
	
	FormCreate();
	FormShow();
}

//Destroy form
void MainForm::DestroyForm(){
    delete Label1  ;
    delete Label2  ;
    delete Label3  ;
    delete Label4  ;
    delete Label5  ;
    delete Label6  ;
    delete Label7  ;
    delete Label8  ;
    delete GroupBox2  ;
    delete Label12  ;
    delete Label13  ;
    delete Label14  ;
    delete Label15  ;
    delete Label16  ;
    delete Label17  ;
    delete Label18  ;
    delete Label19  ;
    delete GroupBox1  ;
    delete Label9  ;
    delete Label10  ;
    delete Label11  ;
    delete Memo1  ;
    delete Memo2  ;
    delete Memo3  ;
    delete Memo4  ;
    delete Button1  ;
    delete Button2  ;
    delete Button3  ;
    delete Button4  ;
    delete Edit1  ;
    delete Edit2  ;
    delete Edit3  ;
    delete CheckBox1  ;
    delete Edit4  ;
    delete Edit5  ;
    delete Edit6  ;
    delete Edit7  ;
    delete Button5  ;
    delete Edit8  ;
    delete Edit9  ;
    delete Edit10  ;
    delete Edit11  ;
    delete Edit12  ;
    delete Edit13  ;
    delete Edit14  ;
    delete Edit15  ;
    delete Edit16  ;
    delete Edit17  ;
    delete Edit18  ;
    delete Button6  ;
    delete Button7  ;
    delete Button8  ;
    delete Button9  ;
    delete Button10  ;
    delete Button11  ;
    delete Button12  ;
    delete Button13  ;
    delete Button14  ;
    delete Button15  ;
    delete Button16  ;
	delete Button17  ;
	
	delete Timer1;
	Timer1=NULL;
	delete OpenDialog1;
	delete Canvas;
}

void MainForm::OnCommand(WORD command){
	REGCALLBK(Button1) Button1Click( );
	REGCALLBK(Button2) Button2Click( );
	REGCALLBK(Button3) Button3Click( );
	REGCALLBK(Button4) Button4Click( );
	REGCALLBK(Button5) Button5Click( );
	REGCALLBK(Button6) Button6Click( );
	REGCALLBK(Button7) Button7Click( );
	REGCALLBK(Button8) Button8Click( );
	REGCALLBK(Button9) Button9Click( );
	REGCALLBK(Button10) Button10Click( );
	REGCALLBK(Button11) Button11Click( );
	REGCALLBK(Button12) Button12Click( );
	REGCALLBK(Button13) Button13Click( );
	REGCALLBK(Button14) Button14Click( );
	REGCALLBK(Button15) Button15Click( );
	REGCALLBK(Button16) Button16Click( );
	REGCALLBK(Button17) Button17Click( );
	REGCALLBK(CheckBox1) CheckBox1Click( );
	
	switch(command){
		case IDM_OPEN_F1:
			OPEN1Click();
			break;
		case IDM_START_F2:
			START1Click();
			break;
		case IDM_STOP_F1:
			STOPClick();
			break;
		case IDM_EXIT_F1:
			EXIT1Click();
			break;
		case IDM_STEP_F1:
			STEP2Click();
			break;
		case IDM_SET_DUMP1__F1:
			SETDump1Click();
			break;
		case IDM_SET_DUMP1__F2:
			SETDump2Click();
			break;
		case IDM_SET_DUMP1__F3:
			SETDump3Click();
			break;
		case IDM_MODIFY_REGISTERS_F1:
			ModifyRegisters1Click();
			break;
		case IDM_MODIFY_FLAGS_F1:
			ModifyFlags1Click();
			break;
		case IDM_MODIFY_MEMORY:
			Button14Click();
			break;
		case IDM_FOLLOW_CODE:
			CheckBox1Click();
			break;
		case IDM_PAGE0:
			SetPageMenu(0);
			break;
		case IDM_PAGE1:
			SetPageMenu(1);
			break;
		case IDM_PAGE2:
			SetPageMenu(2);
			break;
		case IDM_PAGE3:
			SetPageMenu(3);
			break;
		case IDM_PAGE4:
			SetPageMenu(4);
			break;
		case IDM_PAGE5:
			SetPageMenu(5);
			break;
		case IDM_PAGE6:
			SetPageMenu(6);
			break;
		case IDM_PAGE7:
			SetPageMenu(7);
			break;
		case IDM_PAGE8:
			SetPageMenu(8);
			break;
		case IDM_PAGE9:
			SetPageMenu(9);
			break;
		case IDM_PAGE10:
			SetPageMenu(10);
			break;
		case IDM_PAGE11:
			SetPageMenu(11);
			break;
		case IDM_PAGE12:
			SetPageMenu(12);
			break;
		}
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
//---------------------------------------------------------------------------
void  MainForm::FormCreate( )
{
	int x,y;
	run=0;
	intimer=0;
	//CODE=NULL;
	UART=NULL;

	PC=0;
	A=0;	B=0;	C=0;	D=0;	E=0;	H=0;	L=0;
	FlagZ=0;	FlagS=0;	FlagC=0;
	Xreg=Yreg=Zreg=0;
	AccTMPreg=0;
	SID_ADDR=0;
	
	KEYBpoi=0;
	for(x=0;x<16;x++){
		KEYB[x]=0;
		CODE[0xC008+x]=0;
	}

	Button1->Enabled=false;
	Button2->Enabled=false;
	Button3->Enabled=false;
	Button11->Enabled=false;
	Memo1->Clear();
	Memo2->Clear();
	Memo3->Clear();
	Memo4->Clear();
	Edit1->Text="";
	Edit2->Text="";
	Edit3->Text="";
	Edit4->Text="";
	Edit5->Text="";
	Edit6->Text="";
	Edit7->Text="";
	Edit8->Text="";
	Edit9->Text="";
	Edit10->Text="";
	Edit11->Text="";
	Edit12->Text="";
	Edit13->Text="";
	Edit14->Text="";
	Edit15->Text="";
	Edit16->Text="";
	Edit17->Text="";
	Edit18->Text="";
	Dump1st=0;
	Dump2st=0;
	Dump3st=0;
	CheckBox1->Checked=true;

	for(x=0;x<SCRX;x++)
		for(y=0;y<SCRY;y++)
			screen[x][y]=0;

	//Set display BMP buffer
	SCdirty=1;
}
//---------------------------------------------------------------------------
void  MainForm::Button5Click( )
{
	OpenDialog1->Filter="Binary file (*.bin)\0*.BIN";
	if(OpenDialog1->Execute()){
		BINfileName=OpenDialog1->FileName;
		LoadInputFile();
	}
}
//---------------------------------------------------------------------------


void  MainForm::LoadInputFile(){
	//int x;
	AnsiString title("Machine Simulator - ");
	
	QWORD FSIZE=FileSize(BINfileName.String);
	FILE*f=fopen(BINfileName.c_str(),"rb" );
	if(FSIZE<=65536){
		CODE.SetPage(0);
		for(codesize=0;codesize<65535;codesize++){
			CODE[codesize]=fgetc(f);
			if(feof(f))break;
		}
		CODE[codesize++]=0;
	}else{
		int pages = (FSIZE-32768)/32768;
		if(pages>32)pages=32;
		int pagerem = (FSIZE-32768)%32768;
		//load pages
		int pag;
		int x;
		for(pag=0;pag<pages;pag++){
			CODE.SetPage(pag);
			for(x=0;x<32768;x++){
				CODE[x]=fgetc(f);
			}
		}
		CODE.SetPage(pag);
		for(x=0;x<pagerem;x++){
			CODE[x]=fgetc(f);
		}
		//load fix page
		CODE.SetPage(0);
		for(x=32768;x<65536;x++){
			CODE[x]=fgetc(f);
		}
		codesize=65530;
	}
	fclose(f);
	
	title=title+ExtractFileName(BINfileName);
	Title(title.String);
	TitleStr=title;
	
	CheckBox1->Checked=true;
	Button1->Enabled=true;
	Button2->Enabled=true;
	Button3->Enabled=false;
	Button1->Caption="START-F2";
	Button11->Enabled=true;
	PC=0;
	RefreshAll();
	if(UART)delete[] UART;
	Puart=0;
	UART=new(unsigned char[2000]);
	Button13Click();
}


void  MainForm::DisAsm(){
	//if(!CODE)return;
	if(	!CheckBox1->Checked)return;
	AnsiString MN;
	sprintf(MN.String,"CODE   page%d",CODE.GetPage());
	Label1->Caption=MN;
	Memo1->Clear();
	Memo1->Lines->Clear();
	Memo1->Lines->BeginUpdate();
	int x,y;
	int size;
	x=0;
	while((x<codesize)&&(x<65530)){
		MN="";
		switch(CODE[x]){
			case 0x10:
				size=2;
				MN="";MN=MN+"MOV "+RegDecode((CODE[x+1]&0x70)>>4)+","+RegDecode(CODE[x+1]&0x7);
				break;
			case 0x22:
				size=2;
				MN="";MN=MN+"MOV "+RegDecode((CODE[x+1]&0x70)>>4)+",M";
				break;
			case 0x30:
				size=2;
				MN="";MN=MN+"MOV M,"+RegDecode(CODE[x+1]&0x7);
				break;
			case 0x43:
				size=3;
				MN="";MN=MN+"MVI "+RegDecode((CODE[x+1]&0x70)>>4)+","+HexDecode(CODE[x+2]);
				break;
			case 0x57:
				size=3;
				MN="";MN=MN+"LDA ["+HexAddr(CODE[x+1]+256*CODE[x+2])+"]";
				break;
			case 0xA3:
				size=4;
				switch(CODE[x+1]&0x3F){
					case 0x03:
						MN="";MN=MN+"JMP "+HexAddr(CODE[x+2]+256*CODE[x+3]);
						break;
					case 0x01:
						MN="";MN=MN+"JZ "+HexAddr(CODE[x+2]+256*CODE[x+3]);
						break;
					case 0x02:
						MN="";MN=MN+"JNZ "+HexAddr(CODE[x+2]+256*CODE[x+3]);
						break;
					case 0x04:
						MN="";MN=MN+"JC "+HexAddr(CODE[x+2]+256*CODE[x+3]);
						break;
					case 0x08:
						MN="";MN=MN+"JNC "+HexAddr(CODE[x+2]+256*CODE[x+3]);
						break;
					case 0x10:
						MN="";MN=MN+"JM "+HexAddr(CODE[x+2]+256*CODE[x+3]);
						break;
					case 0x20:
						MN="";MN=MN+"JP "+HexAddr(CODE[x+2]+256*CODE[x+3]);
						break;
					default:
						MN="";MN=MN+"unknown";size=1;
						break;
				}

				break;
			case 0x65:
				size=3;
				MN="";MN=MN+"STA ["+HexAddr(CODE[x+1]+256*CODE[x+2])+"]";
				break;
			case 0x70:
				size=2;
				switch(CODE[x+1]&0xF8){
					case 0x00:
						MN="";MN=MN+"ADD "+RegDecode(CODE[x+1]&0x7);
						break;
					case 0x10:
						MN="";MN=MN+"ADC "+RegDecode(CODE[x+1]&0x7);
						break;
					case 0x20:
						MN="";MN=MN+"AND "+RegDecode(CODE[x+1]&0x7);
						break;
					case 0x40:
						MN="";MN=MN+"OR "+RegDecode(CODE[x+1]&0x7);
						break;
					case 0x60:
						MN="";MN=MN+"XOR "+RegDecode(CODE[x+1]&0x7);
						break;
					case 0x80:
						MN="CMA ";
						break;
					case 0xA0:
						MN="RLA ";
						break;
					case 0xC0:
						MN="RRA ";
						break;
					default:
						MN="";MN=MN+"unknown";size=1;
						break;
				}
				break;
			case 0x78:
				size=2;
				switch(CODE[x+1]&0xF8){
					case 0x08:
						MN="";MN=MN+"SUB "+RegDecode(CODE[x+1]&0x7);
						break;
					case 0x10:
						MN="";MN=MN+"SBB "+RegDecode(CODE[x+1]&0x7);
						break;
					default:
						MN="unknown";size=1;
						break;
				}
				break;
			case 0x82:
				size=1;
				MN="STC";
				break;
			case 0x92:
				size=1;
				MN="RTC";
				break;
			case 0xB2:
				size=1;
				MN="HLT";
				break;
			case 0x00:
				size=1;
				MN="NOP";
				break;
			default:
				size=1;
				MN="Unknown";
				break;
		}
		Memo1->Lines->Add(HexAddr(x)+":  "+HexDecode(CODE[x])+"   "+MN );
		for(y=1;y<=size-1;y++){
			Memo1->Lines->Add(HexAddr(x+y)+":  "+HexDecode(CODE[x+y]) );
		}
		x+=size;
	}
	Memo1->Lines->EndUpdate();
}

void  MainForm::FormDestroy( )
{
	//if(CODE)delete[] CODE;
	if(UART)delete[] UART;
}
//---------------------------------------------------------------------------


AnsiString  MainForm::RegDecode(int reg){
	AnsiString R;
	switch(reg){
		case 0x7: R="A"; break;
		case 0x0: R="B"; break;
		case 0x1: R="C"; break;
		case 0x2: R="D"; break;
		case 0x3: R="E"; break;
		case 0x4: R="H"; break;
		case 0x5: R="L"; break;
	}
	return R;
}

AnsiString  MainForm::HexDecode(int addr){
	AnsiString A("0x");
	A=A+Hex((addr&0xF0)>>4)+Hex(addr&0xF);
	return A;
}

AnsiString  MainForm::HexAddr(int addr){
	AnsiString A("0x");
	A=A+Hex((addr&0xF000)>>12)+Hex((addr&0xF00)>>8)+Hex((addr&0xF0)>>4)+Hex(addr&0xF);
	return A;
}

AnsiString  MainForm::Hex(int x){
	AnsiString R="";
	switch(x){
		case 0: R="0"; break;
		case 1: R="1"; break;
		case 2: R="2"; break;
		case 3: R="3"; break;
		case 4: R="4"; break;
		case 5: R="5"; break;
		case 6: R="6"; break;
		case 7: R="7"; break;
		case 8: R="8"; break;
		case 9: R="9"; break;
		case 10: R="A"; break;
		case 11: R="B"; break;
		case 12: R="C"; break;
		case 13: R="D"; break;
		case 14: R="E"; break;
		case 15: R="F"; break;
	}
	return R;
}


long  MainForm::GetHexValue(AnsiString value){
	long N=0;
	int num=0,radix=1;
	value.UpperCase();
	
	//Hexa
	if( ((value.Length()>=2)&&(value[1]=='0')&&(value[2]=='X'))||(value[value.Length() ]=='H') ){
		if((value[1]=='0')&&(value[2]=='X'))value.Delete(1,2);
		if(value[value.Length() ]=='H')value.Delete(value.Length(),1);
		while(!value.IsEmpty()){
			switch(value[value.Length() ]){
				case '0': num=0;break;
				case '1': num=1;break;
				case '2': num=2;break;
				case '3': num=3;break;
				case '4': num=4;break;
				case '5': num=5;break;
				case '6': num=6;break;
				case '7': num=7;break;
				case '8': num=8;break;
				case '9': num=9;break;
				case 'A': num=10;break;
				case 'B': num=11;break;
				case 'C': num=12;break;
				case 'D': num=13;break;
				case 'E': num=14;break;
				case 'F': num=15;break;
				default: ShowMessage("Invalid number format");return -1; break;
			}
			N+=num*radix; radix*=16;
			value.Delete(value.Length() ,1);
		}
		return N;

	}else{
	//DECIMAL
		while(!value.IsEmpty()){
			if( (value[value.Length()]<'0')|| (value[value.Length()]>'9') ){
				ShowMessage("Invalid number format");return -1;
			}
			num=value[value.Length()]-'0';
			N+=num*radix; radix*=10;
			value.Delete(value.Length() ,1);
		}
		return N;
	}
}

void  MainForm::Button4Click( )
{
	Timer1->Enabled=false;
	Application->Terminate();
}
//---------------------------------------------------------------------------

//Regfresh GUI
void  MainForm::RefreshAll(){
	DisAsm();
	RefreshDump1();
	RefreshDump2();
	RefreshDump3();
	RefreshRegisters();
	RefreshScreen();
	RefreshHighlight();
}


void  MainForm::RefreshDump1(){
	if(	!CheckBox1->Checked)return;
	int x;
	AnsiString s,z;
	Memo2->Clear();
	Memo2->Lines->Clear();
	Memo2->Lines->BeginUpdate();
	for(x=0;x<10;x++){
		if((Dump1st+x)>65535)break;
		z=HexAddr(Dump1st+x);
		s=HexDecode(CODE[Dump1st+x]);
		Memo2->Lines->Add(z+":   "+s);
	}
	AnsiString ss;
	ss=HexAddr(Dump1st);
	Edit1->Text=ss;
	Memo2->Lines->EndUpdate();
}

void  MainForm::RefreshDump2(){
	if(	!CheckBox1->Checked)return;
	int x;
	AnsiString s,z;
	Memo3->Clear();
	Memo3->Lines->Clear();
	Memo3->Lines->BeginUpdate();
	for(x=0;x<10;x++){
		if((Dump2st+x)>65535)break;
		z=HexAddr(Dump2st+x);
		s=HexDecode(CODE[Dump2st+x]);
		Memo3->Lines->Add(z+":   "+s);
	}
	Edit2->Text=HexAddr(Dump2st);
	Memo3->Lines->EndUpdate();
}

void  MainForm::RefreshDump3(){
	if(	!CheckBox1->Checked)return;
	int x;
	AnsiString s,z;
	Memo4->Clear();
	Memo4->Lines->Clear();
	Memo4->Lines->BeginUpdate();	
	for(x=0;x<25;x++){
		if((Dump3st+x)>65535)break;
		z=HexAddr(Dump3st+x);
		s=HexDecode(CODE[Dump3st+x]);
		Memo4->Lines->Add(z+":   "+s);
	}
	Edit3->Text=HexAddr(Dump3st);
	Memo4->Lines->EndUpdate();
}


void  MainForm::RefreshRegisters(){
	if(	!CheckBox1->Checked)return;
	Edit4->Text=HexDecode(Xreg);
	Edit5->Text=HexDecode(Yreg);
	Edit6->Text=HexDecode(Zreg);
	Edit7->Text=HexDecode(KEYB[0]);
	Edit8->Text=HexAddr(PC);
	Edit9->Text=HexDecode(A);	
	Edit10->Text=HexDecode(B);	
	Edit11->Text=HexDecode(C);			
	Edit12->Text=HexDecode(D);	
	Edit13->Text=HexDecode(E);	 
	Edit14->Text=HexDecode(H);	
	Edit15->Text=HexDecode(L);			

	Edit16->Text=(FlagZ)?"1":"0";
	Edit17->Text=(FlagC)?"1":"0";
	Edit18->Text=(FlagS)?"1":"0";	

}

void  MainForm::PlotScr(int x, int y, int color){

	//MODIFICATION: temporarly 1 bit color depth existing
	if(color&0x0001)color=255;
	else color=0;
	//MODIFICATION END
	
	screen[x][y]=color;
	SCdirty=1;
}

//refresh screen
void  MainForm::RefreshScreen(){
	int x,y;
	for(x=0;x<SCRX;x++)
		for(y=0;y<SCRY;y++)
			PlotScr(x,y,screen[x][y]);
}

//EXECUTE CODE
//#define LOGTRAJECTORY
void  MainForm::Execute(){
#ifdef LOGTRAJECTORY
//Logging PC trajectory
if((CODE[PC]==0xA3)&&(CODE[PC+1]==0x03)){
	FILE*t;
	t=fopen("PC.log","a");
	if(t==NULL){
		ShowMessage("ERROR opening log file: PC.log");
		return;
	}
	char log[100];
	sprintf(log,"JMP %d:%XH\n",CODE.GetPage(),CODE[PC+2]+256*CODE[PC+3]);
	fputs(log,t);
	fclose(t);
}
#endif
	int X;
	int cond;
	int SetFlags=0;
	switch(CODE[PC]){
		case 0x10:
			PC++;
			PutReg( (CODE[PC]&0x70)>>4 ,GetReg(CODE[PC]&0x07));
			break;
		case 0x22:
			PC++;
			PutReg( (CODE[PC]&0x70)>>4 ,GetMemHL());
			break;
		case 0x30:
			PC++;
			PutMemHL(GetReg(CODE[PC]&0x07));
			break;
		case 0x43:
			PC++;
			PutReg( (CODE[PC]&0x70)>>4 ,CODE[PC+1]);
			PC++;
			break;
		case 0x57:
			if((CODE[PC+1]==(IO_UART_KB&0xFF))&&(CODE[PC+2]==(IO_UART_KB>>8)&0xFF))
				A=PopScan();
			else
				A=CODE[CODE[PC+1]+CODE[PC+2]*256];
			PC+=2;
			break;
		case 0x65:
			CODE[CODE[PC+1]+CODE[PC+2]*256]=A;
			IoPheripheral(CODE[PC+1]+CODE[PC+2]*256);
			PC+=2;
			break;
		case 0x70:
			PC++;
			SetFlags=1;
			switch(CODE[PC]&0xF8){
				case 0x00:
					AccTMPreg=GetReg(CODE[PC]&0x07);
					X=(int)A+(int)GetReg(CODE[PC]&0x07);
					FlagC=(X&0x100)?1:0;
					A=X&0xFF;
					break;
				case 0x10:
					AccTMPreg=GetReg(CODE[PC]&0x07);
					X=(int)A+(int)GetReg(CODE[PC]&0x07)+FlagC;
					FlagC=(X&0x100)?1:0;
					A=X&0xFF;				
					break;
				case 0x20:
					AccTMPreg=GetReg(CODE[PC]&0x07);
					X=(int)A+(int)GetReg(CODE[PC]&0x07);
					FlagC=(X&0x100)?1:0;
					A=A&GetReg(CODE[PC]&0x07);
					break;
				case 0x40:					
					AccTMPreg=GetReg(CODE[PC]&0x07);
					X=(int)A+(int)GetReg(CODE[PC]&0x07);
					FlagC=(X&0x100)?1:0;
					A=A|GetReg(CODE[PC]&0x07);
					break;
				case 0x60:
					AccTMPreg=GetReg(CODE[PC]&0x07);
					X=(int)A+(int)GetReg(CODE[PC]&0x07);
					FlagC=(X&0x100)?1:0;
					A=A^GetReg(CODE[PC]&0x07);
					FlagC=0;
					break;
				case 0x80:
					X=(int)A+(int)AccTMPreg;
					FlagC=(X&0x100)?1:0;
					A=255-A;
					break;					
				case 0xA0:
					X=(int)A+(int)AccTMPreg;
					FlagC=(X&0x100)?1:0;					
					X=A;
					X=X<<1;
					A=X;
					if(X&0x100)A++;
					break;					
				case 0xC0:
					X=(int)A+(int)AccTMPreg;
					FlagC=(X&0x100)?1:0;
					X=A;
					if(X&0x01)X=X|0x100;
					X=X>>1;
					A=X;
					break;
				default:
					run=0;
					UNKNOWNCODE
					break;
			}
			break;
		case 0x78:
			PC++;
			SetFlags=1;
			switch(CODE[PC]&0xF8){
				case 0x08:
					//X=(int)A-(int)GetReg(CODE[PC]&0x07);
					X=A+(~GetReg(CODE[PC]&0x07))+1;
					FlagC=(X&0x100)?0:1;
					A=X&0xFF;
					break;
				case 0x10:
					//X=(int)A-(int)GetReg(CODE[PC]&0x07)-(FlagC?0:1);
					X=A+(~GetReg(CODE[PC]&0x07))+FlagC;
					FlagC=(X&0x100)?0:1;
					A=X&0xFF;
					break;
				default:
					run=0;
					UNKNOWNCODE
					break;					
			}		
			break;
		case 0x82:
			FlagC=1;
			break;			
		case 0x92:
			FlagC=0;
			break;			
		case 0xA3:
			PC++;
			switch(CODE[PC]&0x3F){
				case 0x03:
					cond=1;	
					break;
				case 0x01:
					cond=FlagZ;
					break;
				case 0x02:
					cond=!FlagZ;
					break;
				case 0x04:
					cond=FlagC;
					break;
				case 0x08:
					cond=!FlagC;
					break;
				case 0x10:
					cond=FlagS;
					break;
				case 0x20:
					cond=!FlagS;
					break;
				default:
					run=0;
					UNKNOWNCODE
					break;					
			}
			if(cond){
				PC=CODE[PC+1]+256*CODE[PC+2];
			}else{
				PC+=3;
			}
			if(PC>=codesize){
				PC=0;run=0;
				OUTOFCODE
			}
			if(PC>=65536)PC=0;
			return;
		case 0xB2:
			run=0;
			HALTED			
			break;			
		case 0x00:
			break;
		default:
			run=0;
			UNKNOWNCODE
			break;
	}

	//FLAGS
	if(SetFlags){
		if(!A)FlagZ=1; else FlagZ=0;
		FlagS=(A&0x80)?1:0;
	}
	
	PC++;
	if(PC>=codesize){
		PC=0;run=0;
		OUTOFCODE
	}
	if(PC>=65536)PC=0;
}

//STEP
void  MainForm::Button2Click( )
{	
	Button1->Enabled=true;
	Button2->Enabled=true;
	Button3->Enabled=true;
	Button3->Caption="CONTINUE";	
	Execute();
	RefreshHighlight();
	RefreshRegisters();
}
//---------------------------------------------------------------------------

void  MainForm::CheckBox1Click( )
{
	if(CheckBox1->Checked ){
		CheckBox1->Checked=false;
		if(SidAudio==NULL)
			Timer1->Set(TIMERFAST);
		Memo1->Clear();
		Memo2->Clear();
		Memo3->Clear();
		Memo4->Clear();
		Edit1->Text="";
		Edit2->Text="";
		Edit3->Text="";
		Edit4->Text="";
		Edit5->Text="";
		Edit6->Text="";
		Edit7->Text="";
		Edit8->Text="";
		Edit9->Text="";
		Edit10->Text="";
		Edit11->Text="";
		Edit12->Text="";
		Edit13->Text="";
		Edit14->Text="";
		Edit15->Text="";
		Edit16->Text="";
		Edit17->Text="";
		Edit18->Text="";
	}else{
		CheckBox1->Checked=true;
		if(SidAudio==NULL)
			Timer1->Set(TIMERSLOW);
		RefreshAll();
	}
}
//---------------------------------------------------------------------------


unsigned char  MainForm::GetReg(int reg){
	switch(reg){
		case 7: return A;break;
		case 0: return B;break;
		case 1: return C;break;
		case 2: return D;break;						
		case 3: return E;break;
		case 4: return H;break;
		case 5: return L;break;
	}
}

void  MainForm::PutReg(int reg,unsigned char data){
	switch(reg){
		case 7: A=data;break;
		case 0: B=data;break;
		case 1: C=data;break;
		case 2: D=data;break;						
		case 3: E=data;break;
		case 4: H=data;break;
		case 5: L=data;break;
	}
}

unsigned char  MainForm::GetMemHL(){
	unsigned char H,L;
	long addr;
	H=GetReg(4);
	L=GetReg(5);
	addr=H*256+L;
	return  CODE[addr];
}

void  MainForm::PutMemHL(unsigned char data){
	unsigned char H,L;
	long addr;
	H=GetReg(4);
	L=GetReg(5);
	
	//if((addr>=0xEB50)&&(addr<=0xEB54)){
		//int a=1;
	//	STOPClick();
	//}
	
	
	addr=H*256+L;	
	CODE[addr]=data;
	IoPheripheral(addr);
}


void  MainForm::OPEN1Click( )
{
	Button5Click();
}
//---------------------------------------------------------------------------

void  MainForm::Button1Click( )
{
	//START CODE EXECUTION
	Button1->Enabled=true;
	Button2->Enabled=false;
	Button3->Enabled=true;
	PC=0;
	RefreshAll();
	Button1->Caption="RESTART-F2";
	Button3->Caption="STOP-F3";	
	run=1;
	/*
	while(run){
		Execute();
		RefreshHighlight();
		RefreshRegisters();
		MsgWaitForMultipleObjectsEx(0,NULL,1,1000,0);
		Application->ProcessMessages();
	}
	*/
}
//---------------------------------------------------------------------------

void  MainForm::START1Click( )
{
	if(Button1->Enabled)Button1Click();
}
//---------------------------------------------------------------------------

void  MainForm::STOPClick( )
{
	if(Button3->Enabled)Button3Click();
}
//---------------------------------------------------------------------------

//STOP
void  MainForm::Button3Click( )
{
	//STOP
	if(run){
		run=0;	
		Button1->Enabled=true;
		Button2->Enabled=true;
		Button3->Enabled=true;
		Button3->Caption="CONTINUE";
		RefreshAll();
	}else{
		run=1;
		Button1->Enabled=true;
		Button2->Enabled=false;
		Button3->Enabled=true;
		Button3->Caption="STOP-F3";
		/*
		while(run){
			Execute();
			RefreshHighlight();
			RefreshRegisters();
			MsgWaitForMultipleObjectsEx(0,NULL,1,1000,0);
			Application->ProcessMessages();
		}
		*/
	}
}
//---------------------------------------------------------------------------

void  MainForm::EXIT1Click( )
{
	Button4Click();
}
//---------------------------------------------------------------------------

void  MainForm::STEP2Click( )
{
	MsgWaitForMultipleObjectsEx(0,NULL,1,1000,0);
	if(Button2->Enabled)Button2Click();
}
//---------------------------------------------------------------------------

void  MainForm::Button8Click( )
{
	//DUMP1
	//if(!CODE)return;
	long addr=GetHexValue(Edit1->Text );
	if(addr<0)return;
	Dump1st=addr;
	RefreshDump1();
	RefreshHighlight();
}
//---------------------------------------------------------------------------

void  MainForm::SETDump1Click( )
{
	Button8Click();
}
//---------------------------------------------------------------------------

void  MainForm::Button10Click( )
{
	//DUMP3
	//if(!CODE)return;
	long addr=GetHexValue(Edit3->Text );
	if(addr<0)return;
	Dump3st=addr;
	RefreshDump3();
	RefreshHighlight();
}
//---------------------------------------------------------------------------

void  MainForm::Button9Click( )
{
	//DUMP2
	//if(!CODE)return;
	long addr=GetHexValue(Edit2->Text );
	if(addr<0)return;
	Dump2st=addr;
	RefreshDump2();
	RefreshHighlight();
}
//---------------------------------------------------------------------------

//Modify registers
void  MainForm::Button6Click( )
{
	//if(!CODE)return;
	long value;
	//Modify registers
	value=GetHexValue(Edit8->Text );
	if(value!=-1)PC=value;
	value=GetHexValue(Edit9->Text );
	if(value!=-1)A=value;
	value=GetHexValue(Edit10->Text );
	if(value!=-1)B=value;
	value=GetHexValue(Edit11->Text );
	if(value!=-1)C=value;
	value=GetHexValue(Edit12->Text );
	if(value!=-1)D=value;
	value=GetHexValue(Edit13->Text );
	if(value!=-1)E=value;
	value=GetHexValue(Edit14->Text );
	if(value!=-1)H=value;
	value=GetHexValue(Edit15->Text );
	if(value!=-1)L=value;
	RefreshRegisters();
	RefreshHighlight();
}
//---------------------------------------------------------------------------

void  MainForm::Button7Click( )
{
	//Modify Flags
	//if(!CODE)return;
	AnsiString s;
	s=Edit16->Text;
	if(!s.AnsiCompare("1"))	FlagZ=1;
	else if(!s.AnsiCompare("0")) FlagZ=0;
	else{ ShowMessage("Invalid value");return;}

	s=Edit17->Text;
	if(!s.AnsiCompare("1"))	FlagC=1;
	else if(!s.AnsiCompare("0")) FlagC=0;
	else{ ShowMessage("Invalid value");return;}

	s=Edit18->Text;
	if(!s.AnsiCompare("1"))	FlagS=1;
	else if(!s.AnsiCompare("0")) FlagS=0;
	else{ ShowMessage("Invalid value");return;}
	RefreshRegisters();
	RefreshHighlight();	
}
//---------------------------------------------------------------------------

void  MainForm::SETDump2Click( )
{
	Button9Click();
}
//---------------------------------------------------------------------------

void  MainForm::SETDump3Click( )
{
	Button10Click();
}
//---------------------------------------------------------------------------

void  MainForm::ModifyRegisters1Click( )
{
	Button6Click();
}
//---------------------------------------------------------------------------

void  MainForm::ModifyFlags1Click( )
{
	Button7Click();
}
//---------------------------------------------------------------------------


//RESET PC BUTTON
void  MainForm::Button11Click( )
{
	PC=0;
	RefreshAll();
}
//---------------------------------------------------------------------------

//Called on all memory access; Check if IO registers, IO handling; Check memory dirtiness
void  MainForm::IoPheripheral(long addr){
	//check if memory dump areas are modified
	if(addr<=codesize){
		DISASM
	}
	if((addr>=Dump1st)&&(addr<=Dump1st+10)){
		REFRESHDUMP1
	}
	if((addr>=Dump2st)&&(addr<=Dump2st+10)){
		REFRESHDUMP2
	}
	if((addr>=Dump3st)&&(addr<=Dump3st+25)){
		REFRESHDUMP3
	}

	//check if pheripherial registers are modified
	switch(addr){
	case IO_Xreg:
		Xreg=CODE[addr];
		break;
	case IO_Yreg:
		Yreg=CODE[addr];
		break;
	case IO_Zreg:
		Zreg=CODE[addr];
		if(Xreg>=SCRX)return;
		if(Yreg>=SCRY)return;
		PlotScr(Xreg,Yreg,Zreg);
		SCdirty=1;
		break;
/*
	case IO_UART_KB+5:
		!!!!!!!!
		KEYB=CODE[addr];
		break;
*/
	case IO_UART:
		UART[Puart++]=CODE[addr];
		if(Puart>=2000)Puart=0;
		break;
	case PAGE_REG:
		CODE.SetPage(CODE[addr]);
		DISASM
		REFRESHDUMP1
		REFRESHDUMP2
		REFRESHDUMP3
		break;
	case IO_SID_ADR:
		SID_ADDR=CODE[addr];
		break;
	case IO_SID_DAT:
		if(!SidAudio)
			SidAudio=new AudioHW();
		SidAudio->AudioReg(SID_ADDR,CODE[addr]);
		break;
	}
	
}

char MainForm::PopScan(){
	char res=KEYB[0];
	int x;
	for(x=0;x<15;x++)
		KEYB[x]=KEYB[x+1];
	KEYB[15]=0;

	KEYBpoi--;
	if(KEYBpoi<0)KEYBpoi=0;

	if(!KEYBpoi)
		CODE[IO_UART_KB+5]=0x60;
	
	return res;
}

void MainForm::PushScan(char c1){
	if(KEYBpoi>=16)
		return;
	KEYB[KEYBpoi++]=~c1;
}

void MainForm::PushScan(char c1,char c2,char c3){
	PushScan(c1);
	PushScan(c2);
	PushScan(c3);
}

void MainForm::PushScan(char c1,char c2,char c3,char c4,char c5){
	PushScan(c1);
	PushScan(c2);
	PushScan(c3);
	PushScan(c4);
	PushScan(c5);
}

void MainForm::ScanCodeToBuf(char Key){
	switch(Key){
		case VK_RETURN:
			PushScan(0x5A,0xF0,0x5A);
			break;
		case VK_SPACE:
			PushScan(0x29,0xF0,0x29);
			break;
		case 8:
			PushScan(0x66,0xF0,0x66);
			break;
		case VK_ESCAPE:
			PushScan(0x76,0xF0,0x76);
			break;
		case VK_LEFT:
			PushScan(0xE0,0x6B,0xE0,0xF0,0x6B);
			break;
		case VK_RIGHT:
			PushScan(0xE0,0x74,0xE0,0xF0,0x74);
			break;
		case VK_UP:
			PushScan(0xE0,0x75,0xE0,0xF0,0x75);
			break;
		case VK_DOWN:
			PushScan(0xE0,0x72,0xE0,0xF0,0x72);
			break;
		case 'A':
		case 'a':
			PushScan(0x1C,0xF0,0x1C);
			break;
		case 'B':
		case 'b':
			PushScan(0x32,0xF0,0x32);
			break;
		case 'C':
		case 'c':
			PushScan(0x21,0xF0,0x21);
			break;
		case 'D':
		case 'd':
			PushScan(0x23,0xF0,0x23);
			break;
		case 'E':
		case 'e':
			PushScan(0x24,0xF0,0x24);
			break;
		case 'F':
		case 'f':
			PushScan(0x2B,0xF0,0x2B);
			break;
		case 'G':
		case 'g':
			PushScan(0x34,0xF0,0x34);
			break;
		case 'H':
		case 'h':
			PushScan(0x33,0xF0,0x33);
			break;
		case 'I':
		case 'i':
			PushScan(0x43,0xF0,0x43);
			break;
		case 'J':
		case 'j':
			PushScan(0x3B,0xF0,0x3B);
			break;
		case 'K':
		case 'k':
			PushScan(0x42,0xF0,0x42);
			break;
		case 'L':
		case 'l':
			PushScan(0x4B,0xF0,0x4B);
			break;
		case 'M':
		case 'm':
			PushScan(0x3A,0xF0,0x3A);
			break;
		case 'N':
		case 'n':
			PushScan(0x31,0xF0,0x31);
			break;
		case 'O':
		case 'o':
			PushScan(0x44,0xF0,0x44);
			break;
		case 'P':
		case 'p':
			PushScan(0x4D,0xF0,0x4D);
			break;
		case 'Q':
		case 'q':
			PushScan(0x15,0xF0,0x15);
			break;
		case 'R':
		case 'r':
			PushScan(0x2D,0xF0,0x2D);
			break;
		case 'S':
		case 's':
			PushScan(0x1B,0xF0,0x1B);
			break;
		case 'T':
		case 't':
			PushScan(0x2C,0xF0,0x2C);
			break;
		case 'U':
		case 'u':
			PushScan(0x3C,0xF0,0x3C);
			break;
		case 'V':
		case 'v':
			PushScan(0x2A,0xF0,0x2A);
			break;
		case 'W':
		case 'w':
			PushScan(0x1D,0xF0,0x1D);
			break;
		case 'X':
		case 'x':
			PushScan(0x22,0xF0,0x22);
			break;
		case 'Y':
		case 'y':
			PushScan(0x35,0xF0,0x35);
			break;
		case 'Z':
		case 'z':
			PushScan(0x1A,0xF0,0x1A);
			break;
		case '0':
			PushScan(0x45,0xF0,0x45);
			break;
		case '1':
			PushScan(0x16,0xF0,0x16);
			break;
		case '2':
			PushScan(0x1E,0xF0,0x1E);
			break;
		case '3':
			PushScan(0x26,0xF0,0x26);
			break;
		case '4':
			PushScan(0x25,0xF0,0x25);
			break;
		case '5':
			PushScan(0x2E,0xF0,0x2E);
			break;
		case '6':
			PushScan(0x36,0xF0,0x36);
			break;
		case '7':
			PushScan(0x3D,0xF0,0x3D);
			break;
		case '8':
			PushScan(0x3E,0xF0,0x3E);
			break;
		case '9':
			PushScan(0x46,0xF0,0x46);
			break;
		case '-':
			PushScan(0x4E,0xF0,0x4E);
			break;
		case ';':
			PushScan(0x4C,0xF0,0x4C);
			break;
		case ',':
			PushScan(0x41,0xF0,0x41);
			break;
		case '.':
			PushScan(0x49,0xF0,0x49);
			break;
	}
	CODE[IO_UART_KB+5]=0x61;
}

void MainForm::OnChar(char Key){
	//Keyboard hit
	ScanCodeToBuf(Key);
	
	Edit7->Text=HexDecode(KEYB[0]);
	HWND Sender=GetFocus();
	if(Key==13){
		if(Sender==Edit1->Handle())Button8Click();
		if(Sender==Edit3->Handle())Button10Click();
		if(Sender==Edit2->Handle())Button9Click();
		if(Sender==Edit8->Handle())Button6Click();
		if(Sender==Edit9->Handle())Button6Click();
		if(Sender==Edit10->Handle())Button6Click();
		if(Sender==Edit11->Handle())Button6Click();
		if(Sender==Edit12->Handle())Button6Click();
		if(Sender==Edit13->Handle())Button6Click();
		if(Sender==Edit14->Handle())Button6Click();
		if(Sender==Edit15->Handle())Button6Click();
		if(Sender==Edit16->Handle())Button7Click();
		if(Sender==Edit17->Handle())Button7Click();
		if(Sender==Edit18->Handle())Button7Click();
	}
}

void MainForm::OnKeyDown(WPARAM w){
	w=w&0xFF;
	switch(w){
		case 112:	//F1
			OPEN1Click();
			break;
		case 113:	//F2
			START1Click();
			break;
		case 114:	//F3
			STOPClick();
			break;
		case 115:	//F4
			EXIT1Click();
			break;
		case 116:	//F5
			STEP2Click();
			break;
		case 117:	//F6
			SETDump1Click();
			break;
		case 118:	//F7
			SETDump2Click();
			break;
		case 119:	//F8
			SETDump3Click();
			break;
		case 120:	//F9
			ModifyRegisters1Click();
			break;
		case 121:	//F10
			ModifyFlags1Click();
			break;
		case 122:	//F11
			Button14Click();
			break;
		case 123:	//F12
			CheckBox1Click();
			break;
		case VK_LEFT:
		case VK_RIGHT:
		case VK_UP:
		case VK_DOWN:
			ScanCodeToBuf(w);
			Edit7->Text=HexDecode(KEYB[0]);
			break;
	}
}
//---------------------------------------------------------------------------

//refresh code highlight on Memo
void  MainForm::RefreshHighlight(){
	if(	!CheckBox1->Checked)return;
	//highlight actual line
	if(PC<Memo1->Count())
		Memo1->SelectLine(PC);	
}
//---------------------------------------------------------------------------
//clear screen
void  MainForm::Button12Click( )
{
	int x,y;
	for(x=0;x<SCRX;x++)
		for(y=0;y<SCRY;y++)
			screen[x][y]=0;

	RefreshScreen();
}
//---------------------------------------------------------------------------
//randomize screen
void  MainForm::Button13Click( )
{
	int x,y;
	srand ( time(NULL) );
	for(x=0;x<SCRX;x++)
		for(y=0;y<SCRY;y++)
			if((rand() % 100)>50)screen[x][y]=255;
			else screen[x][y]=0;

	RefreshScreen();
}
//---------------------------------------------------------------------------

static BOOL CALLBACK DialogFunc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam){
	switch(Msg){
		case WM_INITDIALOG:
			HICON hicon=LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
			SendMessage(hDlg,WM_SETICON,0,(LPARAM)hicon);
			return FALSE;

		case WM_COMMAND:             
			switch(LOWORD(wParam)){
				case 1001:
					EndDialog(hDlg,0);
					return TRUE;
			}
			break;      
	}
	return FALSE;
}

void  MainForm::Button14Click( )
{
	/*
	if(!CODE){
		ShowMessage("Memory is Empty!\nLoad CODE first!");
		return;
	}
	*/

//Modify memory
	long address,value;

	if(CPUsimDialog->ShowModal() == mrOk){
		address=GetHexValue(CPUsimDialog->addr);
		if(address<0)return;
		value=GetHexValue(CPUsimDialog->valu);
		if(value<0)return;
		if(address>65535){
			ShowMessage("Too big address");
			return;
		}
		if(value>255){
			ShowMessage("Too big value");
			return;
		}
		CODE[address]=value;

		RefreshAll();
	}

}
//---------------------------------------------------------------------------

void  MainForm::Button15Click( )
{
	//OUTPUT TO UART
	//Write to file
	if(!Puart){
		ShowMessage("No UART data");
		return;
	}
	AnsiString s;
	int x;
	s=ExtractFilePath(Application->ExeName)+"UART.DAT";

	FILE*f;
	f=fopen(s.c_str(),"wb");
	if(f==NULL){
		ShowMessage("Error: opening output file ! (UART.DAT)");
		return;
	}
	for(x=0;x<Puart;x++){
		fputc(UART[x],f);
	}
	fclose(f);
	AnsiString msg("");
	msg=msg+"UART written out successfully to file:\n ("+s+")";
	ShowMessage(msg);
}
//---------------------------------------------------------------------------

void  MainForm::UpdateScreen(){
	//Handle grapic buffer
	if(!SCdirty)return;
	int x,y;
	for(y=0;y<SCRY;y++){
		for(x=0;x<SCRX;x++){
			Canvas->Pixels[x*2][y*2]=RGB(screen[x][y],screen[x][y],screen[x][y]);
			Canvas->Pixels[x*2+1][y*2]=RGB(screen[x][y],screen[x][y],screen[x][y]);
			Canvas->Pixels[x*2][y*2+1]=RGB(screen[x][y],screen[x][y],screen[x][y]);
			Canvas->Pixels[x*2+1][y*2+1]=RGB(screen[x][y],screen[x][y],screen[x][y]);
		}
	}	
	SCdirty=0;
	Canvas->Update();
}

void  MainForm::Timer1Timer( ){
	
	//TEST LOG
	//if(SidAudio)
	//	SidAudio->LogTime();
	
	if(intimer){
		return;
	}
	intimer=1;
	
	//run the execution loop
	int rn;int num=CheckBox1->Checked ? RUNNUMSLOW : RUNNUMFAST ;
	if(run){
		for(rn=0;rn< num ;rn++){
			Execute();
			if(!run)break;
			//Application->ProcessMessages();
		}
		if(SidAudio==NULL){
			Application->ProcessMessages();
			RefreshHighlight();
			RefreshRegisters();
			UpdateScreen();
		}
	}
	
	if((Timer1->EnabledState)&&(SidAudio))
		PostMessage(hwnd,WM_USER,0,0);//to refresh GUI
		
	intimer=0;
}
//---------------------------------------------------------------------------

void  MainForm::FormShow( )
{
	//Load default file
	AnsiString s,INPUTfile,PATH,fname;
	TStringList* Inifile=new(TStringList);
	s=ExtractFilePath(Application->ExeName)+"Compiler.ini";
	if(FileExists(s)){
		Inifile->LoadFromFile(s);
		INPUTfile=Inifile->Strings[0];
		ChangeFileExt(INPUTfile,"BIN");
		PATH=ExtractFilePath(INPUTfile);
		fname=ExtractFileName(INPUTfile);
		fname=ChangeFileExt(fname,"BIN");
		INPUTfile=PATH+fname;
		if(FileExists(INPUTfile)){
			BINfileName=INPUTfile;
			LoadInputFile();
		}else INPUTfile="";
	}else INPUTfile="";
	delete Inifile;	
}
//---------------------------------------------------------------------------

void  MainForm::Button16Click( )
{
	SCdirty=1;
	Timer1Timer();
}
//---------------------------------------------------------------------------

void MainForm::OnPaint(){
	SCdirty=1;
	//Timer1Timer();
	Canvas->Update();
	Title(TitleStr.String);
}

void MainForm::OnTimer(unsigned TimerID){
	if(Timer1&&(TimerID==Timer1->ID)){
		Timer1Timer();
	}
}

//WM_USER sent by Audio driver callback to refresh GUI
void MainForm::OnUserMessage(WPARAM wParam, LPARAM lParam){
	if(wParam){
	  switch(wParam){
		case 1:
			DisAsm();
			RefreshHighlight();
			return;
		case 2:
			Timer1->Enabled=false;
			ShowMessage("Out of code area!");
			run=1;
			Button3Click();
			run=0;
			Timer1->Enabled=true;
			PC=0;
			RefreshAll();
			return;
		case 3:
			RefreshDump1();
			return;
		case 4:
			RefreshDump2();
			return;
		case 5:
			RefreshDump3();
			return;
		case 6:
			ShowMessage("Unknown code !");run=0;
			return;
		case 7:
			Timer1->Enabled=false;
			ShowMessage("Machine is HALTED");
			run=1;
			Button3Click();
			run=0;
			Timer1->Enabled=true;
			return;
	  }
	}
	
	RefreshHighlight();
	RefreshRegisters();

	SCcnt++;
	if(SCcnt>20){//kicsit belezavar a zene lejatszasba, akadoztatja, de fura modon nem update-olodik a kepernyo kben
		SCcnt=0;
		SendMessage(hwnd,WM_PAINT,0,0);
	}else{
		UpdateScreen();
	}

	int x;
	if(SidAudio)
		for(x=0;x<5;x++)
			SidAudio->AudioTimer();
}

void  MainForm::Button17Click(){
	FILE*f;
	int x;
	f=fopen("MemoryPages.BIN","wb");
	if(f==NULL){
		ShowMessage("ERROR: can not open MemoryPages.BIN for writing!");
		return;
	}
	int OrigPage=CODE.GetPage();
	
	//32kB pages
	for(int P=0;P<32;P++){
		CODE.SetPage(P);
		for(x=0;x<32768;x++){
			fputc(CODE[x],f);
		}
	}
	//fix page
	for(x=32768;x<65536;x++){
		fputc(CODE[x],f);
	}	
	
	CODE.SetPage(OrigPage);
	fclose(f);
	ShowMessage("Memory pages are saved to MemoryPages.BIN");
}

//setting page from menu
void  MainForm::SetPageMenu(int page){
	CODE.SetPage(page);
	RefreshAll();
}
