//MainForm
#include "BasicEmuForm.h"
#include "BasicEmuFormParams.h"

#include "..\CompilerForm\CMDstrings.h"


BasicEmu::BasicEmu(HWND Owner,int Resource){
	CreateDialogBox(Owner,Resource);
	STX=50;
	STY=50;
	WID=650+60;
	HEI=610;

//user code here	
	u="";
	TimerRun=0;
	InTimer=0;
	KEY=0;
	WaitKeyState[0]=0;
	WaitKeyState[1]=0;
	
	SidAudio=NULL;
	Timer1=NULL;
	PrintList=NULL;
}

BasicEmu::~BasicEmu(){
//user code here

}

//Build up form
void BasicEmu::BuildForm(HWND hwnd,HINSTANCE hInst){	
	CreateGrElem( Label, Label1 );
	CreateGrElem( Label, Label2 );
	CreateGrElem( Label, Label3 );
	CreateGrElem( Label, Label4 );
	CreateGrElem( TRadioButton, RadioButton1 );
	CreateGrElem( TRadioButton, RadioButton2 );
	CreateGrElem( Button, Button1 );
	CreateGrElem( Button, Button2 );
	CreateGrElem( Button, Button3 );
	CreateGrElem( Button, Button4 );
	CreateGrElem( Button, Button5 );
	CreateGrElem( Button, Button6 );
	CreateGrElem( Button, Button7 );
	CreateGrElem( Button, Button8 );
	CreateGrElem( Memo, Memo1 );
	CreateGrElem( Memo, Memo2 );
	CreateGrElem( Memo, Memo3 );
	CreateGrElem( EditBox, Edit1 );
	CreateGrElem( TCheckBox, CheckBox1 );
	
	Memo1->ReadOnly(true);
	Memo3->ReadOnly(true);
	RadioButton1->Checked=true;
	CheckBox1->Checked=true;
	
	Timer1=new TimerClass(hwnd,10);
	Canvas=new CanvasClass(hwnd,24,165,SCRX*2,SCRY*2,1);

	TimerRun=1;
	InTimer=0;
	KEY=0;
	FormShow();
	Memo1->SelectLine(0);
	
	tlist=new TStringList();
	for(int i=0;i<22;i++)
		Memo2->Add("");
	
	PrintList=new TStringList();
}

//Destroy form
void BasicEmu::DestroyForm(){
	TimerRun=0;
	KEY=1;
	Timer1->Enabled=false;
	Sleep(100);
    delete Label1;
	delete Label2;
	delete Label3;
	delete Label4;
	delete RadioButton1;
	delete RadioButton2;
	delete Button1;
	delete Button2;
	delete Button3;
	delete Button4;
	delete Button5;
	delete Button6;
	delete Button7;
	delete Button8;
	delete Memo1;
	delete Memo2;
	delete Edit1;
	delete CheckBox1;
	delete Timer1;
	Timer1=NULL;
	delete Canvas;
	FormHide();
	delete tlist;
	if(SidAudio)delete SidAudio;
	SidAudio=NULL;
	delete PrintList;
}

void BasicEmu::OnCommand(WORD command){
    REGCALLBK(Button1) Button1Click();
	REGCALLBK(Button2) Button2Click();
	REGCALLBK(Button3) Button3Click();
	REGCALLBK(Button4) Button4Click();
	REGCALLBK(Button5) Button5Click();
	REGCALLBK(Button6) Button6Click();
	REGCALLBK(Button7) Button7Click();
	REGCALLBK(Button8) Button8Click();
	REGCALLBK(RadioButton1) RadioButton1Click();
	REGCALLBK(RadioButton2) RadioButton2Click();
	REGCALLBK(CheckBox1) CheckBox1Click();
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************

void  BasicEmu::RadioButton1Click(){
	if(!RadioButton1->Checked){
		RadioButton1->Checked=true;
		ShowMessage("Selected: 156X116 Barany monocrome display");
	}
}

void  BasicEmu::RadioButton2Click(){
	if(!RadioButton2->Checked){
		RadioButton1->Checked=false;
		RadioButton2->Checked=true;
		ShowMessage("Error: Not yet implemeted");
		RadioButton1->Checked=true;
		RadioButton2->Checked=false;
	}
}

void  BasicEmu::CheckBox1Click(){
	if(!CheckBox1->Checked)
		CheckBox1->Checked=true;
	else
		CheckBox1->Checked=false;
}

void  BasicEmu::Button3Click()
{
//EXIT
	run=0;
	KEY=1;
	TimerRun=0;
	commandCNTR=0;
	GosubStackPoi=0;
	this->ModalResult(mrOk);
}
//---------------------------------------------------------------------------
void  BasicEmu::Button1Click()
{
//START
	commandCNTR=0;
	GosubStackPoi=0;
	SysColor=255;
	run=1;
	KEY=0;
	WaitKeyState[0]=0;
	WaitKeyState[1]=0;
	Button1->Enabled=false;
	Button2->Enabled=true;
	Button3->Enabled=true;
	Button4->Enabled=false;
	Memo3->Clear();
	PrintList->Clear();

}
//---------------------------------------------------------------------------
void  BasicEmu::Button2Click()
{
//PAUSE
	if(run==1){
		run=0;
		Button1->Enabled=false;
		Button2->Enabled=true;
		Button3->Enabled=true;
		Button4->Enabled=true;
		Button2->Caption="CONTINUE";
	}else{
		run=1;
		Button1->Enabled=false;
		Button2->Enabled=true;
		Button3->Enabled=true;
		Button4->Enabled=false;
		Button2->Caption="BREAK - F2";		
	}

	Memo1->SelectLine(commandCNTR);
	//if(len>10)len=10;
}
//---------------------------------------------------------------------------
void  BasicEmu::FormShow()
{
	int x,y;
	commandCNTR=0;
	GosubStackPoi=0;
	/*
	for(x=0;x<310;x++)
		for(y=0;y<310;y++)
			Image1->Canvas->Pixels[x][y]=0;
*/
	run=0;
	stepline=commandCNTR=0;
	Vcnt=0;
	//Graphics
	SysColor=255;
	MaxColorDepth=255;
	MaxX=SCRX,MaxY=SCRY;

	for(x=0;x<MaxX;x++)
		for(y=0;y<MaxY;y++)
			GRbuf[x][y]=0;

	Button1->Enabled=true;
	Button2->Enabled=false;
	Button3->Enabled=true;
	Button4->Enabled=true;
	
	Memo1->LoadText(commands);
/*
	Memo1->Clear();
	for(x=0;x<commands->Count;x++){
		Memo1->Lines->Add(commands->Strings[x] );
	}
*/	
	Memo2->Clear();
	Edit1->Clear();
	RandSeed();
	KEY=0;

	delaycnt=0;

	Button8Click();

	//Set display BMP buffer
	SCdirty=1;
}
//---------------------------------------------------------------------------

void  BasicEmu::SplitBySpace(AnsiString cmd){
	int x;
	int pos=0;
	char c[200];
	for(x=1;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R1.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R2.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R3.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R4.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R5.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R6.Sprintf("%s",c);

}

void  BasicEmu::SplitByComma(AnsiString cmd){
	int x;
	int pos=0;
	char c[200];

	//change array index separator to ';' :   A[1,2]->A[1;2]
	int arrayIS=0;
	for(x=1;x<=cmd.Length();x++ ){
		if(!arrayIS){
			if(cmd[x]=='['){
				arrayIS=1;
			}
		}else{
			if(cmd[x]==']'){
				arrayIS=0;
			}else if(cmd[x]==','){
				cmd[x]=';';
			}
		}
	}
	//SPLITTING
	for(x=1;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R1.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R2.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R3.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R4.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R5.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R6.Sprintf("%s",c);

	//CHANGE BACK ';' to ','
	for(x=1;x<=R1.Length();x++){
    	if(R1[x]==';')R1[x]=',';
	}
	for(x=1;x<=R2.Length();x++){
		if(R2[x]==';')R2[x]=',';
	}
	for(x=1;x<=R3.Length();x++){
		if(R3[x]==';')R3[x]=',';
	}
	for(x=1;x<=R4.Length();x++){
		if(R4[x]==';')R4[x]=',';
	}
	for(x=1;x<=R5.Length();x++){
		if(R5[x]==';')R5[x]=',';
	}
	for(x=1;x<=R6.Length();x++){
		if(R6[x]==';')R6[x]=',';
	}

}


void  BasicEmu::MakeCommandlist(){
	int num=commands->Count;
	CMDnum=num;
	CMD=new(command[num]);
	AnsiString str,tstr;
	AnsiString SubCmd;
	int P1;
	unsigned char quote;
	int w,x,y;
	command* futo=NULL;
	char c;

	for(x=0;x<num;x++){
		if(commands->Strings[x].IsEmpty()){
			commands->Delete(x);
			x--;
		}
		num=commands->Count;
	}
	num=commands->Count;

	for(x=0;x<num;x++){
		str=commands->Strings[x];
		if(str.IsEmpty())continue;
		P1=1;quote=0;

		SplitBySpace(str);
		CMD[x].commandCNTR=x;
		try {CMD[x].ord=R1.ToInt();}
		catch (Exception &exception) {
			AnsiString s; s.Sprintf("%d",x+1);
			ShowMessage(u+"ERROR in text line "+s+" - not a number");
			errorlinenum=x;
			this->ModalResult(mrCancel);
			return;
		}
		str.Delete(1,R1.Length()+1);
		if((str[1]=='I')&&(str[2]=='F')){
			int thx=str.AnsiPos("THEN");
			if((str[thx+4]==0)||(str[thx+5]==0)){
				AnsiString s; s.Sprintf("%d",x+1);
				ShowMessage(u+"ERROR in text line "+s+" - invalid IF-THEN statement");
				errorlinenum=x;
				this->ModalResult(mrCancel);
				return;
			}
			str[thx+4]=':';
		}
		futo=&CMD[x];

		for(w=1;w<=str.Length();w++){
			if(str[w]=='"'){quote=!quote;continue;}
			if(quote)continue;
			if((str[w]==':')||(w==str.Length())){
				SubCmd=str.SubString(P1,w-P1+1);
				P1=w+1;
				if(str[w]==':')SubCmd.Delete(SubCmd.Length(),1);
				SplitBySpace(SubCmd);

				futo->CMDtext=R1;
				for(y=0;y<CMDliteralsNUM;y++){
					sprintf(tstr.String,"%s",CMDliterals[y]);
					if(!futo->CMDtext.AnsiCompare(tstr) ){
						futo->CMDcode=y;
						break;
					}
				}
				if(y>=CMDliteralsNUM){
					futo->CMDcode=-1;
				}
				futo->PARAM=R2;
				if(!R3.IsEmpty() )futo->PARAM=futo->PARAM+" "+R3;
				if(!R4.IsEmpty() )futo->PARAM=futo->PARAM+" "+R4;
				if(!R5.IsEmpty() )futo->PARAM=futo->PARAM+" "+R5;
				if(!R6.IsEmpty() )futo->PARAM=futo->PARAM+" "+R6;
				futo->JMPcode=-1;
				futo->runstate=0;
				futo->SubCMD=NULL;
				if(str[w]==':'){
					futo->SubCMD=new(command);
					futo->SubCMD->ord=futo->ord;
					futo=futo->SubCMD;
				}
			}
		}
	}

	//BUBBLE SORT FOR COMMANDS
	command tmp;
	int csere=1;
	while(csere){
		csere=0;
		for(x=0;x<num-1;x++){
			if(CMD[x].ord>CMD[x+1].ord ){
				csere=1;
				tmp=CMD[x];
				CMD[x]=CMD[x+1];
				CMD[x+1]=tmp;
			}
		}
	}

	//Check if same ORD NUM exists
	int lastN=CMD[0].ord;
	for(x=1;x<num;x++){
		if(CMD[x].ord==lastN){
			AnsiString s; s.Sprintf("%d",x+1);
			ShowMessage(u+"ERROR in text line "+s+" - number already exists");
			errorlinenum=x-1;
			this->ModalResult(mrCancel);
			return;
		}
		lastN=CMD[x].ord;
	}

	//GOTO, FOR , ... jumping commands - preprocessing - JMPcode
	for(x=0;x<num;x++){
		futo=&CMD[x];
		while(futo){
			switch(futo->CMDcode){
				case 1:	//NEXT
					str=futo->PARAM;
					for(w=x;w>=0;w--){
						if(CMD[w].CMDcode==0){
							tstr=GetFirstVariableName(CMD[w].PARAM);
							//(str.Length()>tstr.Length())?str.Delete(tstr.Length()+1,str.Length()-tstr.Length()):tstr.Delete(str.Length()+1,tstr.Length()-str.Length());
							c=0;y=0;
							while(y<str.Length()){
								c=str.String[y];
								if( ((c>='a')&&(c<='z')) || ((c>='A')&&(c<='Z')) || ((c>='0')&&(c<='9')) || (c=='_') ){
									y++;
									continue;
								}else{
									str.String[y]=0;
									break;
								}
							}
							c=0;y=0;
							while(y<tstr.Length()){
								c=tstr.String[y];
								if( ((c>='a')&&(c<='z')) || ((c>='A')&&(c<='Z')) || ((c>='0')&&(c<='9')) || (c=='_') ){
									y++;
									continue;
								}else{
									tstr.String[y]=0;
									break;
								}
							}
							if(!str.AnsiCompare(tstr)){
								futo->JMPcode=w;
								CMD[w].JMPcode=x;
								break;
							}
						}
					}
					if(w<0){
						AnsiString s; s.Sprintf("%d",x+1);
						ShowMessage(u+"ERROR in text line "+s+" - Unmached NEXT ?");
						errorlinenum=x;
						this->ModalResult(mrCancel);
						return;
					}
					break;
				case 11:
				case 2: //GOTO, GOSUB
					if(IsNumber(futo->PARAM)){
						w=futo->PARAM.ToInt();
						for(y=0;y<num;y++){
							if(CMD[y].ord==w){
								futo->JMPcode=y;
								break;
							}
						}
						if(y>=num){
							AnsiString s; s.Sprintf("%d",x+1);
							ShowMessage(u+"ERROR in text line "+s+" - invalid GOTO/GOSUB statement");
							errorlinenum=x;
							this->ModalResult(mrCancel);
							return;
						}
					}
					break;
				case 4:	//IF
					w=futo->PARAM.AnsiPos("THEN");
					if(w==0){
						AnsiString s; s.Sprintf("%d",x+1);
						ShowMessage(u+"ERROR in text line "+s+" - invalid IF statement");
						errorlinenum=x;
						this->ModalResult(mrCancel);
						return;
					}
					str=futo->SubCMD->CMDtext;
					if(IsNumber(str)){
						w=str.ToInt();
						for(y=0;y<num;y++){
							if(CMD[y].ord==w){
								futo->JMPcode=y;
								break;
							}
						}
						if(y>=num){
							AnsiString s; s.Sprintf("%d",x+1);
							ShowMessage(u+"ERROR in text line "+s+" - invalid JUMP statement");
							errorlinenum=x;
							this->ModalResult(mrCancel);
							return;
						}
					}
					break;
				case 42://SID
				case 43://SIDS
				case 44://SVOICE1
				case 45://SVOICE1S
				case 46://SVOICE2
				case 47://SVOICE2S
				case 48://SVOICE3
				case 49://SVOICE3S
				case 50://SFILTER
				case 51://SFILTERS
				case 53://SFREQ1S
				case 55://SPW1S
				case 61://SFREQ2S
				case 63://SPW2S
				case 69://SFREQ3S
				case 71://SPW3S
				case 17:	//READ
				case 31:	//PUTPATTERN
				case 85:	//PUTPATMIRVER
				case 86:	//PUTPATTWIST
				case 87:	//PUTPATTWISMIR
				case 18:	//RESTORE
					str=futo->PARAM;
					SplitByComma(str);
					str=R1;
					//PUTPATTERN check #DATA
					if((futo->CMDcode==31)||(futo->CMDcode==85)||(futo->CMDcode==86)||(futo->CMDcode==87)){
						if(str[1]=='#'){
							str.Delete(1,1);
						}else break;
					}
					for(w=0;w<num;w++){
						if(CMD[w].CMDcode==35){
							y=CMD[w].PARAM.AnsiPos(" ");
							tstr=CMD[w].PARAM.SubString(1,y-1);
							if(!str.AnsiCompare(tstr)){
                             	futo->JMPcode=w;
								break;
							}
						}
					}
					if(w>=num){
						AnsiString s; s.Sprintf("%d",x+1);
						ShowMessage(u+"ERROR in text line "+s+" - Unmached READ, no maching DATA line");
						errorlinenum=x;
						this->ModalResult(mrCancel);
						return;
					}
					break;
			}
			futo=futo->SubCMD;
		}
	}
	//DATA lines preprocessing
	int vandata=0;
	for(x=0;x<num;x++){
		if(CMD[x].CMDcode==35){
			vandata=1;
		}
	}
	if(!vandata)return;


	//create DATA lines
	DATA=new(data_read[1000]);
	for(x=0;x<1000;x++){
		DATA[x].data=NULL;
		DATA[x].dpoi=0;
		DATA[x].dnum=0;
	}


	int* dt=new(int[10000]);
	int pdt=0;
	int RUN=1;
	for(x=0;x<num;x++){
		if(CMD[x].CMDcode==35){
			pdt=0;
			y=CMD[x].PARAM.AnsiPos(" ");
			CMD[x].PARAM.Delete(1,y);
			SplitByComma(CMD[x].PARAM);

			RUN=1;
			while(RUN){
				RUN=0;
				if( (!IsNumber(R1)) || (!R2.IsEmpty()&&!IsNumber(R2)) || (!R3.IsEmpty()&&!IsNumber(R3)) ||
					(!R4.IsEmpty()&&!IsNumber(R4)) || (!R5.IsEmpty()&&!IsNumber(R5))
				){
					AnsiString s; s.Sprintf("%d",x+1);
					ShowMessage(u+"ERROR in text line "+s+" - invalid DATA statement");
					errorlinenum=x;
					this->ModalResult(mrCancel);
					return;
				}
				dt[pdt++]=R1.ToInt();
				if(IsNumber(R2))dt[pdt++]=R2.ToInt();
				if(IsNumber(R3))dt[pdt++]=R3.ToInt();
				if(IsNumber(R4))dt[pdt++]=R4.ToInt();
				if(IsNumber(R5))dt[pdt++]=R5.ToInt();
				if(IsNumber(R6))dt[pdt++]=R6.ToInt();
				else{
					if(!R6.IsEmpty()){
						SplitByComma(R6); RUN=1;
					}
				}
			}
			for(y=0;y<1000;y++){
				if(DATA[y].data==NULL)break;
			}
			if(DATA[y].data==NULL){
				DATA[y].dnum=pdt;
				DATA[y].dpoi=0;
				DATA[y].data=new(int[pdt]);
				for(w=0;w<pdt;w++){
					DATA[y].data[w]=dt[w];
				}
			}else{
				AnsiString s; s.Sprintf("%d",x+1);
				ShowMessage(u+"ERROR in text line "+s+" - too much DATA");
				errorlinenum=x;
				this->ModalResult(mrCancel);
				return;
			}
			CMD[x].JMPcode=y;

		}

	}
	delete[] dt;
}

void  BasicEmu::DestroyCommandlist(){
	int x;

	if(DATA){
		for(x=0;x<1000;x++){
			if(DATA[x].data)delete[] DATA[x].data;
			DATA[x].data=NULL;
			DATA[x].dpoi=0;
			DATA[x].dnum=0;
		}
		delete[] DATA;
	}
	delete[] CMD;
}


void  BasicEmu::Plot(int X, int Y, int color){
//	int x,y;

	if((X<0)||(Y<0)){
		ErrorMSG("PLOT: coordinates could not be negative");run=0;return;
	}
	if((X>=MaxX)||(Y>=MaxY)){
		ErrorMSG("PLOT: coordinates out of range");run=0;return;
	}
	if((color<0)||(color>MaxColorDepth)){
		ErrorMSG("PLOT: Color value out of range");run=0;return;
	}

//	int COLOR=color+color*256+color*256*256;

	/*
	Image1->Canvas->Pixels[X*2][Y*2]=COLOR;
	Image1->Canvas->Pixels[X*2+1][Y*2+1]=COLOR;
	Image1->Canvas->Pixels[X*2+1][Y*2]=COLOR;
	Image1->Canvas->Pixels[X*2][Y*2+1]=COLOR;
    */

	GRbuf[X][Y]=color;
	GposX=X,GposY=Y;
	SCdirty=1;
			
}

void  BasicEmu::PutVariable(AnsiString name, int X, int Y, int value){
	int x;
	char c;
	//check syntax
	c=name[1];
	if( !( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z'))  ) ){
		ErrorMSG(u+"invalid variable name: '"+name+"'");return;
	}

	for(x=1;x<=name.Length();x++){
		c=name[x];
		if( !( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9')) ) ){
			ErrorMSG(u+"invalid variable name: '"+name+"'");return;
		}
	}

	//Search at first

	int megvan=0;
	for(x=0;x<Vcnt;x++){
		if(!V[x].name.AnsiCompare(name) ){
			megvan =1;
			break;
		}
	}
	//create it
	if(!megvan){
		if((X==-1)&&(Y==-1)){
        	x=Vcnt;
			V[Vcnt].name=name;
			V[Vcnt].type=1;
			V[Vcnt].value=0;
			V[Vcnt].dimX=-1;
			V[Vcnt].dimY=-1;
			Vcnt++;if(Vcnt>=5000){
				run=0;ShowMessage("FATAL: SYSTEM ERROR 12");return;
			}
		}else{
			ErrorMSG("invalid variable name");
			return;
		}
	}

	//Lookup
	switch(V[x].type){
		case 1:
			if((X!=-1)||(Y!=-1)){
				ErrorMSG("misplaced brackets[]");return;
			}
			V[x].value=value;
			break;
		case 2:
			if((X<0)||(Y!=-1)){
				ErrorMSG("misplaced brackets[]");return;
			}
			if(X>=V[x].dimX){
				ErrorMSG("out-addressing");return;
			}
			V[x].array[X]=value;
			break;
		case 3:
			if((X<0)||(Y<0)){
				ErrorMSG("out-addressing");return;
			}
			if((X>=V[x].dimX)||(Y>=V[x].dimY)){
				ErrorMSG("out-addressing");return;
			}
			V[x].array[Y*V[x].dimX+X]=value;
			break;					
	}

}

int   BasicEmu::GetVariable(AnsiString name, int X, int Y){
	int x;
	for(x=0;x<Vcnt;x++){
		if(!V[x].name.AnsiCompare(name) ){
			switch(V[x].type){
				case 1:
					if((X!=-1)||(Y!=-1)){
						ErrorMSG("misplaced brackets[]");return 0;
					}
					return V[x].value;
					break;
				case 2:
					if((X<0)||(Y!=-1)){
						ErrorMSG("misplaced brackets[]");return 0;
					}
					if(X>=V[x].dimX){
						ErrorMSG("out-addressing");return 0;
					}
					return V[x].array[X];
					break;
				case 3:
					if((X<0)||(Y<0)){
						ErrorMSG("out-addressing");return 0;
					}
					if((X>=V[x].dimX)||(Y>=V[x].dimY)){
						ErrorMSG("out-addressing");return 0;
					}
					return V[x].array[Y*V[x].dimX+X];
					break;					
			}
		}
	}

	ErrorMSG("invalid variable");return 0;
}


void  BasicEmu::FormHide()
{
	run=0;
	commandCNTR=0;
	int x;

	for(x=0;x<5000;x++)
		if((V[x].type!=1)&&(V[x].array)){
			delete[] V[x].array;
			V[x].array=NULL;
		}
	Vcnt=0;
}
//---------------------------------------------------------------------------


AnsiString  BasicEmu::GetFirstVariableName(AnsiString line){
	AnsiString ret;
	int x;
	char c;

	if(line.IsEmpty())return "";

	for(x=1;x<=line.Length();x++){
		c=line[x];
		if( !( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9')) ) ){
			break;
		}
	}
	if(c!='['){
		ret=line.SubString(1,x-1);
		return ret;
	}
	int bracketlev=1;
	x++;
	for(;x<=line.Length();x++){
		if(!bracketlev)break;
		c=line[x];
		if(c=='[')bracketlev++;
		if(c==']')bracketlev--;
	}
	if(bracketlev){
		ErrorMSG("invalid expression");ret="";return ret;
	}
	ret=line.SubString(1,x-1);

	return ret;
}

int   BasicEmu::EvaluateExpression(AnsiString expr){
	if(expr.IsEmpty()){ErrorMSG("invalid expression");return 0;}
	int x,w;
	int pos,spos;	
	int len=expr.Length();
	int brl[1000];
	int brr[1000];
	int lastbrl;
	//check brackets
	for(x=0;x<1000;x++){
		brl[x]=0;
		brr[x]=0;
	}
	for(x=1;x<=len;x++){
		if((expr[x]=='(')||(expr[x]=='[')){
			brl[x]=-1;
		}
		if((expr[x]==')')||(expr[x]==']')){
			pos=x;
			while((brl[pos]!=-1)&&(pos>=1))pos--;
			if(pos<1){
				ErrorMSG("expression sintax: brackets ()");return 0;
			}
			brl[pos]=x; 	brr[x]=pos;
		}
	}
	for(x=1;x<=len;x++){
		if((brl[x]==-1)||(brl[x]==-1)){
			ErrorMSG("expression sintax: brackets ()");return 0;
		}
	}

	//Put all arrays into brackets
	char c;
	for(x=1;x<=len;x++){
		if(expr[x]=='['){
			if((brl[x])>=expr.Length())
				expr=expr+")";
			else
				expr.Insert(")",brl[x]+1);
			pos=x-1;
			c=expr[pos];
			while( (pos>=1) && (((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9'))) ){
				c=expr[pos--];
			}
			if(!pos)pos++;
			else pos+=2;
			expr.Insert("(",pos);
			len+=2;

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}
			x++;

		}
	}

	//Put * and / operations into brackets
	for(x=1;x<=len;x++){
		if((expr[x]=='*')||(expr[x]=='/')){
			//check lower
			pos=x-1;
			if(pos<1){
				ErrorMSG("expression sintax");return 0;
			}
			if(expr[pos]==')'){
				expr.Insert("(",brr[pos] );
				lastbrl=brr[pos];
				len++;x++;
			}else{
				while((pos>=1)&&(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos--;
				}
				pos++;
				expr.Insert("(",pos);
				lastbrl=pos;
				len++;x++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if(w==lastbrl)continue;
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

			//check higher
			pos=x+1;
			if(pos>len){
				ErrorMSG("expression sintax");return 0;
			}
			if(expr[pos]=='('){
				expr.Insert(")",brl[pos] );
				len++;
			}else{
				while((pos<=len)&&(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos++;
				}
				if(pos==len)expr=expr+")";
				else expr.Insert(")",pos);
				len++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

		}
	}

	//Put RELATIONS  < , > , = , <= , >= , <>  into brackets
	for(x=1;x<=len;x++){
		if((expr[x]=='<')||(expr[x]=='>')||(expr[x]=='=')||(expr[x]=='\1')||(expr[x]=='\2')||(expr[x]=='#') ){
			//check lower
			pos=x-1;
			if(pos<1){
				ErrorMSG("expression sintax");return 0;
			}
			if(expr[pos]==')'){
				expr.Insert("(",brr[pos] );
				lastbrl=brr[pos];
				len++;x++;
			}else{
				while((pos>=1)
				/*
				(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				*/
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos--;
				}
				pos++;
				expr.Insert("(",pos);
				lastbrl=pos;
				len++;x++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if(w==lastbrl)continue;
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

			//check higher
			pos=x+1;
			if(pos>len){
				ErrorMSG("expression sintax");return 0;
			}
			if(expr[pos]=='('){
				expr.Insert(")",brl[pos] );
				len++;
			}else{
				while((pos<=len)
				/*
				&&(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				*/
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos++;
				}
				if(pos==len)expr=expr+")";
				else expr.Insert(")",pos);
				len++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

		}
	}


	return BracketRecursive(expr);


}

//Solve brackets
int   BasicEmu::BracketRecursive(AnsiString expr){
	char* brl=new(char[1000]);
	char* brr=new(char[1000]);
	int len=expr.Length();
	int w,spos;
	int evalpos;
	int oper;//operator

	//register brackets
	for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
	for(w=1;w<=len;w++){
		if(expr[w]=='('){brl[w]=-1;}
		if(expr[w]==')'){
			spos=w;
			while((brl[spos]!=-1)&&(spos>=1))spos--;
			brl[spos]=w; 	brr[w]=spos;
		}
	}


	//EVALUATE
	evalpos=1;
	oper=1;//1-addition 2-substraction 3-multiplication 4-division
	int subresult=0;
	int variable;
	int ix=-1,iy=-1;
	AnsiString name,PX,PY;
	char c;
	//evaluate
	while(evalpos<=len){
		c=expr[evalpos];

		//Embedded brackets
		if(c=='('){
			variable=BracketRecursive(expr.SubString(evalpos+1,brl[evalpos]-evalpos-1));
			evalpos=brl[evalpos]+1;

		//Variable
		}else if( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) ){
			AnsiString substr=expr;
			substr.Delete(1,evalpos-1);
			substr=GetFirstVariableName(substr);
			name=SplitArrayVariableName(substr,PX,PY);
			ix=-1,iy=-1;
			if(!PX.IsEmpty())ix=EvaluateExpression(PX);
			if(!PY.IsEmpty())iy=EvaluateExpression(PY);
			variable=GetVariable(name,ix,iy);
			evalpos+=substr.Length();

		//Number
		}else if( (c>='0')&&(c<='9') ){
			int subpos=evalpos;
			AnsiString substr;
			while((subpos<=len)&&  (((expr[subpos]>='0')&&(expr[subpos]<='9'))||(expr[subpos]=='x')||((expr[subpos]>='A')&&(expr[subpos]<='F')))  ){
				subpos++;
			}
			substr=expr.SubString(evalpos,subpos-evalpos);
			variable=substr.ToInt();
			evalpos=subpos;

		//negative sign
		}else if(c=='-'){
			oper=2;
			subresult=0;
			evalpos++;
			continue;

		//negotation operator
		}else if(c=='!'){
			evalpos++;
			if(expr[evalpos]!='('){ErrorMSG("expression sintax");return 0;}
			variable=BracketRecursive(expr.SubString(evalpos+1,brl[evalpos]-evalpos-1));
			evalpos=brl[evalpos]+1;
			if(variable)variable=0;else variable=1;

		//ERROR
		}else{
			ErrorMSG("expression sintax");return 0;
		}

		//operation
		//1-addition 2-substraction 3-multiplication 4-division
		switch(oper){
			case 1:
				subresult+=variable;
				break;
			case 2:
				subresult-=variable;
				break;
			case 3:
				subresult*=variable;
				break;
			case 4:
				subresult/=variable;
				break;
			case 5:
				if(subresult&&variable)subresult=1;else subresult=0;
				break;
			case 6:
				if(subresult||variable)subresult=1;else subresult=0;
				break;
			case 7:
				if(subresult<variable)subresult=1;else subresult=0;
				break;
			case 8:
				if(subresult>variable)subresult=1;else subresult=0;
				break;
			case 9:
				if(subresult==variable)subresult=1;else subresult=0;
				break;
			case 10:
				if(subresult!=variable)subresult=1;else subresult=0;
				break;
			case 11:
				if(subresult<=variable)subresult=1;else subresult=0;
				break;
			case 12:
				if(subresult>=variable)subresult=1;else subresult=0;
				break;
		}

		//evaluate operator
		if(evalpos<=len){
			c=expr[evalpos];
			switch(c){
				case '+':
					oper=1;
					break;
				case '-':
					oper=2;
					break;
				case '*':
					oper=3;
					break;
				case '/':
					oper=4;
					break;
				case '&':
					oper=5;
					break;
				case '|':
					oper=6;
					break;
				case '<':
					oper=7;
					break;
				case '>':
					oper=8;
					break;
				case '=':
					oper=9;
					break;
				case '#':
					oper=10;
					break;
				case '\1':
					oper=11;
					break;
				case '\2':
					oper=12;
					break;
				default:
					ErrorMSG("expression sintax");return 0;
					break;
			}

			if(evalpos>len){
				ErrorMSG("expression sintax");return 0;
			}
		}

		evalpos++;
	}

	delete brl;
	delete brr;
	
	return subresult;
}


AnsiString   BasicEmu::SplitArrayVariableName(AnsiString name, AnsiString &X, AnsiString &Y){
	char c;
	int x;
	AnsiString ret;
	AnsiString indexSTR;
//	int pos;

	X=""; Y="";

	for(x=1;x<=name.Length();x++){
    	c=name[x];
		if( !(((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9'))) ){
			break;
		}
	}
	ret=name.SubString(1,x-1);
	indexSTR=name.Delete(1,x-1);
	if(indexSTR.IsEmpty()){
    	return ret;
	}
	if((indexSTR[1]!='[')||(indexSTR[indexSTR.Length()]!=']')){
		ErrorMSG("expression sintax");return "";
	}
	indexSTR.Delete(1,1);
	indexSTR.Delete(indexSTR.Length(),1);

	int bracketlev=0;
	int stored=0;
	for(x=1;x<=indexSTR.Length();x++){
		c=indexSTR[x];
		switch(c){
			case '[':
				bracketlev++;
				break;
			case ']':
				bracketlev--;
				break;
			case ',':
				if(!bracketlev){
					X=indexSTR.SubString(1,x-1);
					Y=indexSTR.Delete(1,x);
					stored=1;
				}
				break;
		}
		if(stored)break;
	}
	if(!stored){
		X=indexSTR;
		Y="";
	}
	if(bracketlev){
		ErrorMSG("expression sintax");return "";
	}

	return ret;

}

//Execute Command
void  BasicEmu::ProcessCommand(command* COMMAND){
	int x,y;
	AnsiString s,name,varname,expression;
	AnsiString PX,PY;
	int px,py,step;
	int subresult,subresult2;
	WaitKeyState[0]=WaitKeyState[1];
	WaitKeyState[1]=KEY;
	Application->ProcessMessages();

	//Initialize SID audio
	if((COMMAND->CMDcode>=42)&&(COMMAND->CMDcode<=82)){
		if(!SidAudio)
			SidAudio=new AudioHW();
	}
	
	switch(COMMAND->CMDcode){
		case 8:		//LET
			COMMAND->CMDtext=COMMAND->PARAM;
		case -1:	//empty command ("LET") or unknown
			name=GetFirstVariableName(COMMAND->CMDtext );
			expression=COMMAND->CMDtext;
			expression.Delete(1,name.Length()+1);
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);

			subresult=EvaluateExpression(expression);
			PutVariable(name,px,py,subresult);

			break;
		case 0:		//FOR
        	step=0;
			SplitBySpace(COMMAND->PARAM);
			if(COMMAND->JMPcode==-1){ErrorMSG("FOR invalid: NEXT is missing");return;}
			if(R2.AnsiCompare("TO") ){
				ErrorMSG("FOR invalid: TO is missing");
				return;
			}
			varname=name=GetFirstVariableName(R1 );
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			if(!COMMAND->runstate ){	//0 means FOR not initialized
				//init FOR
				expression=R1;
				expression.Delete(1,varname.Length()+1);
				subresult=EvaluateExpression(expression);
				PutVariable(name,px,py,subresult);
				COMMAND->runstate=1;	//it is initialized
			}else{
				//STEP forward
				if(!R4.AnsiCompare("STEP")){
					step=EvaluateExpression(R5);
				}else{
					step=1;
				}
				PutVariable(name,px,py,GetVariable(name,px,py)+step);
			}
			//Condition check
				subresult=EvaluateExpression(R3);
				subresult2=GetVariable(name,px,py);
				if(  ((subresult2>subresult)&&(step>0)) ||  ((subresult2<subresult)&&(step<0))  ){
					COMMAND->runstate=0;
					commandCNTR=COMMAND->JMPcode;
				}

			break;
		case 1:		//NEXT
			if(COMMAND->JMPcode==-1){ErrorMSG("invalid NEXT ");return;}
			commandCNTR=COMMAND->JMPcode-1;
			break;
		case 2:		//GOTO
			if(COMMAND->JMPcode==-1){
				ErrorMSG("invalid GOTO statement");return;
			}else
				commandCNTR=COMMAND->JMPcode-1;
			break;
		case 3:		//DIM
			name=GetFirstVariableName(COMMAND->PARAM);
			for(x=1;x<name.Length();x++)if(name[x]=='[')break;
			expression=name.SubString(x,name.Length()-x+1);
			name.Delete(x,name.Length()-x+1);
			if((expression[1]!='[')||(expression[expression.Length()]!=']')){
				ErrorMSG(" ");return;
			}
			expression.Delete(1,1);
			expression.Delete(expression.Length(),1);

			for(x=0;x<Vcnt;x++){
				if(!V[x].name.AnsiCompare(name) ){
					ErrorMSG("variable name is alreday existing");run=0;return;
				}
			}

			SplitByComma(expression);
			V[Vcnt].name=name;

			if(R1.IsEmpty()){
				ErrorMSG("");return;
			}
			if(R2.IsEmpty()){
				V[Vcnt].type=2;
				try {px=R1.ToInt();}
				catch (Exception &exception) {
					ErrorMSG("argument is invalid");run=0;return;
				}
				V[Vcnt].array=new(int[px]);
				for(x=0;x<px;x++)V[Vcnt].array[x]=0;
				V[Vcnt].dimX=px;
				V[Vcnt].dimY=-1;
			}else{
				V[Vcnt].type=3;
				try {px=R1.ToInt();}
				catch (Exception &exception) {
					ErrorMSG("argument is invalid");run=0;return;
				}
				try {py=R2.ToInt();}
				catch (Exception &exception) {
					ErrorMSG("argument is invalid");run=0;return;
				}
				V[Vcnt].array=new(int[px*py]);
				for(x=0;x<px*py;x++)V[Vcnt].array[x]=0;				
				V[Vcnt].dimX=px;
				V[Vcnt].dimY=py;
			}

			Vcnt++;if(Vcnt>=5000){
				run=0;ShowMessage("FATAL: SYSTEM ERROR 12");return;
			}
			break;
		case 4:		//IF
			px=COMMAND->PARAM.AnsiPos("THEN");
			expression=COMMAND->PARAM.SubString(1,px-2);
			subresult=EvaluateBooleanExpression(expression);
			if(subresult){
				if(COMMAND->JMPcode!=-1){
					commandCNTR=COMMAND->JMPcode-1;
				}else{
					if(COMMAND->SubCMD==NULL){
	                    ErrorMSG("IF branch is missing");run=0;return;
					}
					ProcessCommand(COMMAND->SubCMD);
				}
			}
        	return;	//return to not process subcommads again
			break;
		case 5:		//PLOT
			SplitByComma(COMMAND->PARAM);
			px=EvaluateExpression(R1);
			py=EvaluateExpression(R2);
			GposX=px,GposY=py;			
			Plot(px,py,SysColor);
			break;
		case 6:		//REM
        	return;
			break;
		case 7:		//CLS
			for(x=0;x<SCRX;x++)
				for(y=0;y<SCRY;y++)
					GRbuf[x][y]=0;
			UpdateScr();
			PostMessage(DialogOwner,WM_USER,2,0);
			//Memo3->Clear();
			break;
		case 9:		//END
		case 10:	//STOP
			run=0;
			/*
			Button1->Enabled=true;
			Button2->Enabled=false;
			Button3->Enabled=true;
			Button4->Enabled=true;
			if(errorlinenum<0)ShowMessage("PROGRAM SUCCESSFULLY FINISHED");
			commandCNTR=0;
			*/
			commandCNTR=CMDnum;
			break;
		case 11:	//GOSUB
			if(GosubStackPoi>90){
				ErrorMSG("GOSUB stack overflow");return;
			}
			GosubStack[GosubStackPoi++]=commandCNTR;
			if(COMMAND->JMPcode==-1){
				ErrorMSG("invalid GOSUB statement");return;
			}else
				commandCNTR=COMMAND->JMPcode-1;
			break;
		case 12:	//RETURN
			if(GosubStackPoi<=0){
				ErrorMSG("GOSUB stack underflow");return;
			}
			commandCNTR=GosubStack[--GosubStackPoi];
			break;
		case 13:	//POP
			if(GosubStackPoi<=0){
				ErrorMSG("GOSUB stack underflow");return;
			}
			GosubStackPoi--;
			break;
		case 14:	//ON GOTO
			s=COMMAND->PARAM;
			SplitBySpace(s);
			subresult=EvaluateExpression(R1);
			if(R2.AnsiCompare("GOTO")){
				ErrorMSG("ON GOTO syntax error");return;
			}
			s.Delete(1,R1.Length()+R2.Length()+2);
			SplitByComma(s);
			if((!IsNumber(R1)&&!R1.IsEmpty())||(!IsNumber(R2)&&!R2.IsEmpty())||(!IsNumber(R3)&&!R3.IsEmpty())||
			(!IsNumber(R4)&&!R4.IsEmpty())||(!IsNumber(R5)&&!R5.IsEmpty())||(!IsNumber(R6)&&!R6.IsEmpty())){
				ErrorMSG("ON GOTO syntax error: invalid number");return;
			}
			switch(subresult){
				case 1:
					if(!IsNumber(R1)){
						ErrorMSG("ON GOTO error: invalid CASE1");return;
					}
					subresult=R1.ToInt();
					break;
				case 2:
					if(!IsNumber(R2)){
						ErrorMSG("ON GOTO error: invalid CASE2");return;
					}
					subresult=R2.ToInt();
					break;
				case 3:
					if(!IsNumber(R3)){
						ErrorMSG("ON GOTO error: invalid CASE3");return;
					}
					subresult=R3.ToInt();
					break;
				case 4:
					if(!IsNumber(R4)){
						ErrorMSG("ON GOTO error: invalid CASE4");return;
					}
					subresult=R4.ToInt();
					break;
				case 5:
					if(!IsNumber(R5)){
						ErrorMSG("ON GOTO error: invalid CASE5");return;
					}
					subresult=R5.ToInt();
					break;
				case 6:
					if(!IsNumber(R6)){
						ErrorMSG("ON GOTO error: invalid CASE6");return;
					}
					subresult=R6.ToInt();
					break;
				default:
					ErrorMSG("ON GOTO error: invalid case computed");return;
					break;
			}
			for(y=0;y<CMDnum;y++)
				if(CMD[y].ord==subresult)
					break;
			if(y>=CMDnum){
				ErrorMSG("ON GOTO error: invalid case computed");return;
			}
			commandCNTR=CMD[y].commandCNTR-1;
			break;
		case 15:	//PEEK
			break;
		case 16:	//POKE
			break;
		case 17:	//READ
			s=COMMAND->PARAM;
			SplitByComma(s);
			name=R2;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);

			y=COMMAND->JMPcode;
			y=CMD[y].JMPcode;
			x=DATA[y].dpoi++;
			while(x>=DATA[y].dnum){
				x-=DATA[y].dnum;
				y++;
				if(DATA[y].data==NULL){
					ErrorMSG("Last data reached in DATA lines");return;
				}
			}
			subresult=DATA[y].data[x];
			
			PutVariable(name,px,py,subresult);

			break;
		case 18:	//RESTORE
			y=CMD[COMMAND->JMPcode].JMPcode;
        	DATA[y].dpoi=0;
			break;
		case 19:	//RND
			name=COMMAND->PARAM;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			subresult=RandomNumber(256);
			PutVariable(name,px,py,subresult);
			break;
		case 20:	//SOUND
			break;
		case 21:	//COLOR
			subresult=EvaluateExpression(COMMAND->PARAM);
			if((subresult<0)||(subresult>MaxColorDepth)){
				ErrorMSG("COLOR: out of range");return;
			}
			SysColor=subresult;
			break;
		case 22:	//PUTPIXEL
			SplitByComma(COMMAND->PARAM);
			px=EvaluateExpression(R1);
			py=EvaluateExpression(R2);
			subresult=EvaluateExpression(R3);
			GposX=px,GposY=py;
			Plot(px,py,subresult);
			break;
		case 23:	//GETPIXEL
			SplitByComma(COMMAND->PARAM);
			x=EvaluateExpression(R2);
			y=EvaluateExpression(R3);
			name=R1;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			subresult=GRbuf[x][y];
			PutVariable(name,px,py,subresult);
			break;
		case 24:	//POSITION
			SplitByComma(COMMAND->PARAM);
			x=EvaluateExpression(R1);
			y=EvaluateExpression(R2);
            GposX=x,GposY=y;
			break;
		case 25:	//DRAWTO
			SplitByComma(COMMAND->PARAM);
			px=EvaluateExpression(R1);
			py=EvaluateExpression(R2);
			DrawTo(px,py);
			GposX=px,GposY=py;
			break;
		case 26:	//GETMAXX
			name=COMMAND->PARAM;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			subresult=MaxX;
			PutVariable(name,px,py,subresult);
			break;
		case 27:	//GETMAXY
			name=COMMAND->PARAM;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			subresult=MaxY;
			PutVariable(name,px,py,subresult);
			break;
		case 28:	//GETMAXCOLORDEPTH
			name=COMMAND->PARAM;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			subresult=MaxColorDepth;
			PutVariable(name,px,py,subresult);
			break;
		case 29:	//VERSHIFTGRLINE
			SplitByComma(COMMAND->PARAM);
			subresult=EvaluateExpression(R1);
			if((R2[1]!='\'')||(R2[3]!='\'')||(R2.Length()!=3)){
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			if(R2[2]=='U')
				VerShiftGrLine(subresult,1);
			else if(R2[2]=='D')
				VerShiftGrLine(subresult,2);
			else{
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			break;
		case 30:	//HORSHIFTGRLINE
			SplitByComma(COMMAND->PARAM);
			subresult=EvaluateExpression(R1);
			if((R2[1]!='\'')||(R2[3]!='\'')||(R2.Length()!=3)){
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			if(R2[2]=='L')
				HorShiftGrLine(subresult,1);
			else if(R2[2]=='R')
				HorShiftGrLine(subresult,2);
			else{
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			break;
		case 31:	//PUTPATTERN
			SplitByComma(COMMAND->PARAM);
			name=R1;
			x=EvaluateExpression(R2);
			y=EvaluateExpression(R3);
			px=EvaluateExpression(R4);
			py=EvaluateExpression(R5);
			PutPattern(name,x,y,px,py,COMMAND);
			break;
		case 32:	//GETPATTERN
			SplitByComma(COMMAND->PARAM);
			name=R1;
			x=EvaluateExpression(R2);
			y=EvaluateExpression(R3);
			px=EvaluateExpression(R4);
			py=EvaluateExpression(R5);
			GetPattern(name,x,y,px,py);		
			break;
		case 33:	//KEYBINPUT
			name=COMMAND->PARAM;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			subresult=KeybInput();
			PutVariable(name,px,py,subresult);
			break;
		case 34:	//WAITKEY
			name=COMMAND->PARAM;
			name=SplitArrayVariableName(name,PX,PY);
			px=-1,py=-1;
			if(!PX.IsEmpty())px=EvaluateExpression(PX);
			if(!PY.IsEmpty())py=EvaluateExpression(PY);
			
			if(WaitKeyState[0]==WaitKeyState[1]){
				s=Label4->Caption;
				if(s.IsEmpty())
					Label4->Caption="PRESS ANY KEY !";	
				commandCNTR--;
			}else{
				Label4->Caption="";
				PutVariable(name,px,py,KEY);
			}
			//subresult=WaitKey();
			break;
		case 35:	//DATA
			break;
		case 36:	//DELAY
			delaycnt=EvaluateExpression(COMMAND->PARAM);
			//Tl nagy lassits miatt , (a Timer 100ms-os)
			delaycnt=delaycnt/30;
			break;
		case 37:  	//#TEST
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			s.Sprintf("%d",subresult);
			run=0;
			ShowMessage(u+"EXPRESSION\n"+COMMAND->PARAM+"\n"+s);
			run=1;
			break;
		case 38:	//#BREAK;
			Button2Click();
			break;
		case 39:	//PRINT
			if(COMMAND->PARAM[1]=='\''){
				PrintList->Add(COMMAND->PARAM);
			}else{
				subresult=EvaluateBooleanExpression(COMMAND->PARAM);
				sprintf(s.String,"%d (0x%X)",subresult,subresult);
				PrintList->Add(u+"EXPRESSION = "+s);
			}
			break;
		case 40:	//GOTOXY
			break;
		case 41:	//ASM
			ErrorMSG("ERROR: ASSEMBLY IS NOT SUPPORTED!");return;
			break;
		case 42:	//SID
			SidAudio->AudioReg(0,DataReadHi(COMMAND));
			SidAudio->AudioReg(1,DataReadLo(COMMAND));
			SidAudio->AudioReg(2,DataReadHi(COMMAND));
			SidAudio->AudioReg(3,DataReadLo(COMMAND));
			SidAudio->AudioReg(4,SIDreg04=DataReadHi(COMMAND));
			SidAudio->AudioReg(5,DataReadLo(COMMAND));
			SidAudio->AudioReg(6,DataReadHi(COMMAND));
			SidAudio->AudioReg(7,DataReadLo(COMMAND));
			SidAudio->AudioReg(8,DataReadHi(COMMAND));
			SidAudio->AudioReg(9,DataReadLo(COMMAND));
			SidAudio->AudioReg(10,DataReadHi(COMMAND));
			SidAudio->AudioReg(11,SIDreg11=DataReadLo(COMMAND));
			SidAudio->AudioReg(12,DataReadHi(COMMAND));
			SidAudio->AudioReg(13,DataReadLo(COMMAND));
			SidAudio->AudioReg(14,DataReadHi(COMMAND));
			SidAudio->AudioReg(15,DataReadLo(COMMAND));
			SidAudio->AudioReg(16,DataReadHi(COMMAND));
			SidAudio->AudioReg(17,DataReadLo(COMMAND));
			SidAudio->AudioReg(18,SIDreg18=DataReadHi(COMMAND));
			SidAudio->AudioReg(19,DataReadLo(COMMAND));
			SidAudio->AudioReg(20,DataReadHi(COMMAND));
			SidAudio->AudioReg(21,DataReadLo(COMMAND));
			SidAudio->AudioReg(22,DataReadHi(COMMAND));
			SidAudio->AudioReg(23,DataReadLo(COMMAND));
			SidAudio->AudioReg(24,SIDreg24=DataReadHi(COMMAND));
			DataReadReset(COMMAND);
			break;
		case 43:	//SIDS
			SidAudio->AudioReg(0,DataReadHi(COMMAND));
			SidAudio->AudioReg(1,DataReadLo(COMMAND));
			SidAudio->AudioReg(2,DataReadHi(COMMAND));
			SidAudio->AudioReg(3,DataReadLo(COMMAND));
			SidAudio->AudioReg(4,SIDreg04=DataReadHi(COMMAND));
			SidAudio->AudioReg(5,DataReadLo(COMMAND));
			SidAudio->AudioReg(6,DataReadHi(COMMAND));
			SidAudio->AudioReg(7,DataReadLo(COMMAND));
			SidAudio->AudioReg(8,DataReadHi(COMMAND));
			SidAudio->AudioReg(9,DataReadLo(COMMAND));
			SidAudio->AudioReg(10,DataReadHi(COMMAND));
			SidAudio->AudioReg(11,SIDreg11=DataReadLo(COMMAND));
			SidAudio->AudioReg(12,DataReadHi(COMMAND));
			SidAudio->AudioReg(13,DataReadLo(COMMAND));
			SidAudio->AudioReg(14,DataReadHi(COMMAND));
			SidAudio->AudioReg(15,DataReadLo(COMMAND));
			SidAudio->AudioReg(16,DataReadHi(COMMAND));
			SidAudio->AudioReg(17,DataReadLo(COMMAND));
			SidAudio->AudioReg(18,SIDreg18=DataReadHi(COMMAND));
			SidAudio->AudioReg(19,DataReadLo(COMMAND));
			SidAudio->AudioReg(20,DataReadHi(COMMAND));
			SidAudio->AudioReg(21,DataReadLo(COMMAND));
			SidAudio->AudioReg(22,DataReadHi(COMMAND));
			SidAudio->AudioReg(23,DataReadLo(COMMAND));
			SidAudio->AudioReg(24,SIDreg24=DataReadHi(COMMAND));
			break;
		case 44:	//SVOICE1
			SidAudio->AudioReg(0,DataReadHi(COMMAND));
			SidAudio->AudioReg(1,DataReadLo(COMMAND));
			SidAudio->AudioReg(2,DataReadHi(COMMAND));
			SidAudio->AudioReg(3,DataReadLo(COMMAND));
			SidAudio->AudioReg(4,SIDreg04=DataReadHi(COMMAND));
			SidAudio->AudioReg(5,DataReadLo(COMMAND));
			SidAudio->AudioReg(6,DataReadHi(COMMAND));
			DataReadReset(COMMAND);
			break;
		case 45:	//SVOICE1S
			SidAudio->AudioReg(0,DataReadHi(COMMAND));
			SidAudio->AudioReg(1,DataReadLo(COMMAND));
			SidAudio->AudioReg(2,DataReadHi(COMMAND));
			SidAudio->AudioReg(3,DataReadLo(COMMAND));
			SidAudio->AudioReg(4,SIDreg04=DataReadHi(COMMAND));
			SidAudio->AudioReg(5,DataReadLo(COMMAND));
			SidAudio->AudioReg(6,DataReadHi(COMMAND));
			break;
		case 46:	//SVOICE2
			SidAudio->AudioReg(7,DataReadHi(COMMAND));
			SidAudio->AudioReg(8,DataReadLo(COMMAND));
			SidAudio->AudioReg(9,DataReadHi(COMMAND));
			SidAudio->AudioReg(10,DataReadLo(COMMAND));
			SidAudio->AudioReg(11,SIDreg11=DataReadHi(COMMAND));
			SidAudio->AudioReg(12,DataReadLo(COMMAND));
			SidAudio->AudioReg(13,DataReadHi(COMMAND));
			DataReadReset(COMMAND);
			break;
		case 47:	//SVOICE2S
			SidAudio->AudioReg(7,DataReadHi(COMMAND));
			SidAudio->AudioReg(8,DataReadLo(COMMAND));
			SidAudio->AudioReg(9,DataReadHi(COMMAND));
			SidAudio->AudioReg(10,DataReadLo(COMMAND));
			SidAudio->AudioReg(11,SIDreg11=SIDreg04=DataReadHi(COMMAND));
			SidAudio->AudioReg(12,DataReadLo(COMMAND));
			SidAudio->AudioReg(13,DataReadHi(COMMAND));
			break;
		case 48:	//SVOICE3
			SidAudio->AudioReg(14,DataReadHi(COMMAND));
			SidAudio->AudioReg(15,DataReadLo(COMMAND));
			SidAudio->AudioReg(16,DataReadHi(COMMAND));
			SidAudio->AudioReg(17,DataReadLo(COMMAND));
			SidAudio->AudioReg(18,SIDreg18=DataReadHi(COMMAND));
			SidAudio->AudioReg(19,DataReadLo(COMMAND));
			SidAudio->AudioReg(20,DataReadHi(COMMAND));
			DataReadReset(COMMAND);
			break;
		case 49:	//SVOICE3S
			SidAudio->AudioReg(14,DataReadHi(COMMAND));
			SidAudio->AudioReg(15,DataReadLo(COMMAND));
			SidAudio->AudioReg(16,DataReadHi(COMMAND));
			SidAudio->AudioReg(17,DataReadLo(COMMAND));
			SidAudio->AudioReg(18,SIDreg18=DataReadHi(COMMAND));
			SidAudio->AudioReg(19,DataReadLo(COMMAND));
			SidAudio->AudioReg(20,DataReadHi(COMMAND));
			break;
		case 50:	//SFILTER
			SidAudio->AudioReg(21,DataReadHi(COMMAND));
			SidAudio->AudioReg(22,DataReadLo(COMMAND));
			SidAudio->AudioReg(23,DataReadHi(COMMAND));
			SidAudio->AudioReg(24,SIDreg24=DataReadLo(COMMAND));
			DataReadReset(COMMAND);
			break;
		case 51:	//SFILTERS
			SidAudio->AudioReg(21,DataReadHi(COMMAND));
			SidAudio->AudioReg(22,DataReadLo(COMMAND));
			SidAudio->AudioReg(23,DataReadHi(COMMAND));
			SidAudio->AudioReg(24,SIDreg24=DataReadLo(COMMAND));
			break;
		case 52:	//SFREQ1
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(1,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(0,subresult&0xFF);
			break;
		case 53:	//SFREQ1S
			SidAudio->AudioReg(1,DataReadHi(COMMAND));
			SidAudio->AudioReg(0,DataReadLo(COMMAND));
			break;
		case 54:	//SPW1
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(3,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(2,subresult&0xFF);
			break;
		case 55:	//SPW1S
			SidAudio->AudioReg(3,DataReadHi(COMMAND));
			SidAudio->AudioReg(2,DataReadLo(COMMAND));
			break;
		case 56:	//SCONTR1
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(4,SIDreg04=subresult&0xFF);
			break;
		case 57:	//SADSR1
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(5,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(6,subresult&0xFF);
			break;
		case 58:	//SGATE1
			SidAudio->AudioReg(4,SIDreg04=SIDreg04|1);
			break;
		case 59:	//SRELEASE1
			SidAudio->AudioReg(4,SIDreg04=SIDreg04&0xFE);
			break;
		case 60:	//SFREQ2
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(8,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(7,subresult&0xFF);
			break;
		case 61:	//SFREQ2S
			SidAudio->AudioReg(8,DataReadHi(COMMAND));
			SidAudio->AudioReg(7,DataReadLo(COMMAND));
			break;
		case 62:	//SPW2
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(10,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(9,subresult&0xFF);
			break;
		case 63:	//SPW2S
			SidAudio->AudioReg(10,DataReadHi(COMMAND));
			SidAudio->AudioReg(9,DataReadLo(COMMAND));
			break;
		case 64:	//SCONTR2
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(11,SIDreg11=subresult&0xFF);
			break;
		case 65:	//SADSR2
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(12,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(13,subresult&0xFF);
			break;
		case 66:	//SGATE2
			SidAudio->AudioReg(11,SIDreg11=SIDreg11|1);
			break;
		case 67:	//SRELEASE2
			SidAudio->AudioReg(11,SIDreg11=SIDreg11&0xFE);
			break;
		case 68:	//SFREQ3
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(15,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(14,subresult&0xFF);
			break;
		case 69:	//SFREQ3S
			SidAudio->AudioReg(15,DataReadHi(COMMAND));
			SidAudio->AudioReg(14,DataReadLo(COMMAND));
			break;
		case 70:	//SPW3
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(17,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(16,subresult&0xFF);
			break;
		case 71:	//SPW3S
			SidAudio->AudioReg(17,DataReadHi(COMMAND));
			SidAudio->AudioReg(16,DataReadLo(COMMAND));
			break;
		case 72:	//SCONTR3
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(18,SIDreg18=subresult&0xFF);
			break;
		case 73:	//SADSR3
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(19,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(20,subresult&0xFF);
			break;
		case 74:	//SGATE3
			SidAudio->AudioReg(18,SIDreg18=SIDreg18|1);
			break;
		case 75:	//SRELEASE3
			SidAudio->AudioReg(18,SIDreg18=SIDreg18&0xFE);
			break;
		case 76:	//SFC
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(21,(subresult&0xFF00)>>8);
			SidAudio->AudioReg(22,subresult&0xFF);
			break;
		case 77:	//SRESFILT
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SidAudio->AudioReg(23,subresult&0xFF);
			break;
		case 78:	//SVOL
			subresult=EvaluateBooleanExpression(COMMAND->PARAM);
			SIDreg24=(SIDreg24&0xF0)|(subresult&0x0F);
			SidAudio->AudioReg(24,SIDreg24);
			break;
		case 79:	//SPOTX
			break;
		case 80:	//SPOTY
			break;
		case 81:	//SRND
			break;
		case 82:	//SENV3
			break;
		case 83:	//PICTURE
			break;
		case 84:	//TABLE
			break;
		case 85:	//PUTPATMIRVER
			SplitByComma(COMMAND->PARAM);
			name=R1;
			x=EvaluateExpression(R2);
			y=EvaluateExpression(R3);
			px=EvaluateExpression(R4);
			py=EvaluateExpression(R5);
			PutPatMirVer(name,x,y,px,py,COMMAND);
			break;
		case 86:	//PUTPATTWIST
			SplitByComma(COMMAND->PARAM);
			name=R1;
			x=EvaluateExpression(R2);
			y=EvaluateExpression(R3);
			px=EvaluateExpression(R4);
			py=EvaluateExpression(R5);
			PutPatTwist(name,x,y,px,py,COMMAND);
			break;
		case 87:	//PUTPATTWISMIR
			SplitByComma(COMMAND->PARAM);
			name=R1;
			x=EvaluateExpression(R2);
			y=EvaluateExpression(R3);
			px=EvaluateExpression(R4);
			py=EvaluateExpression(R5);
			PutPatTwisMir(name,x,y,px,py,COMMAND);
			break;
		case 88:	//ENDPICTURE
			break;
		case 89:	//ENDTABLE
			break;
		case 90:	//DELPATTERN
			SplitByComma(COMMAND->PARAM);
			x=EvaluateExpression(R1);
			y=EvaluateExpression(R2);
			px=EvaluateExpression(R3);
			py=EvaluateExpression(R4);
			DelPattern(x,y,px,py,COMMAND);
			break;
		default:
			run=0;
			ShowMessage("SYSTEM FATAL: Unknown command code\nUnsupported command");
			return;
			break;
	}

	//Process subcommand ':'
	if(COMMAND->SubCMD)	ProcessCommand(COMMAND->SubCMD);
	
}

int BasicEmu::DataReadLo(command* COMMAND){
	int x,y;
	y=CMD[COMMAND->JMPcode].JMPcode;
	x=DATA[y].dpoi++;
	while(x>=DATA[y].dnum){
		x-=DATA[y].dnum;
		y++;
		if(DATA[y].data==NULL){
			ErrorMSG("Last data reached in DATA lines");return 0;
		}
	}
	return DATA[y].data[x]&0xFF;
}

int BasicEmu::DataReadHi(command* COMMAND){
	int x,y;
	y=CMD[COMMAND->JMPcode].JMPcode;
	x=DATA[y].dpoi;
	if(x>=DATA[y].dnum){
		ErrorMSG("Last data reached in DATA lines");return 0;
	}	
	return (DATA[y].data[x]&0xFF00)>>8;
}

int BasicEmu::DataReadReset(command* COMMAND){
	DATA[CMD[COMMAND->JMPcode].JMPcode].dpoi=0;
}

//ERROR AT LINE - compiling error message  
void  BasicEmu::ErrorMSG(AnsiString msg){
	AnsiString c,t;
	TimerRun=0;
	t.Sprintf("%d",CMD[commandCNTR].ord);
	c=commands->Strings[ commandCNTR ];
	run=0;
	errorlinenum=commandCNTR;
	ShowMessage(u+"ERROR AT LINE "+ t+" - "+msg+"\n"+c);
	PostMessage(DialogOwner,WM_USER,1,0);//Send Quiting message
}


int   BasicEmu::IsNumber(AnsiString str){
	int x;
	if(str.IsEmpty())return 0;
	if((str[1]=='0')&&(str[2]=='x')){
		for(x=3;x<=str.Length();x++){
			if((str[x]>='0')&&(str[x]<='9'))continue;
			if((str[x]>='A')&&(str[x]<='F'))continue;
			else return 0;
		}
		return 1;
	}
	for(x=1;x<=str.Length();x++){
		if((str[x]>='0')&&(str[x]<='9'))continue;
		else return 0;
	}
	return 1;
}


int   BasicEmu::EvaluateBooleanExpression(AnsiString expr){
	int pos,len;
	char c;
	//substitue
	while(pos=expr.AnsiPos("AND") ){
		expr[pos]='&';
		expr.Delete(pos+1,2);
	}
	while(pos=expr.AnsiPos("OR") ){
		expr[pos]='|';
		expr.Delete(pos+1,1);
	}
	while(pos=expr.AnsiPos("NOT") ){
		expr[pos]='!';
		expr.Delete(pos+1,2);
	}
	while(pos=expr.AnsiPos("<>") ){
		expr[pos]='#';
		expr.Delete(pos+1,1);
	}
	while(pos=expr.AnsiPos("<=") ){
		expr[pos]='\1';
		expr.Delete(pos+1,1);
	}
	while(pos=expr.AnsiPos(">=") ){
		expr[pos]='\2';
		expr.Delete(pos+1,1);
	}

	//delete spaces
	len=expr.Length();
	for(pos=1;pos<=len;pos++){
		c=expr[pos];
		if((c=='&')||(c=='|')||(c=='!')||(c=='>')||(c=='<')||(c=='=')){
			if((pos>1)&&(expr[pos-1]==' ')){expr.Delete(pos-1,1);pos--;}
			if((pos<len)&&(expr[pos+1]==' '))expr.Delete(pos+1,1);
			if((pos+1<len)&&(expr[pos+2]==' '))expr.Delete(pos+2,1);
		}
		len=expr.Length();
	}
	//syntax check
	len=expr.Length();
	for(pos=1;pos<=len;pos++){
		c=expr[pos];
		if((c=='&')||(c=='|')){
			if(expr[pos-1]!=')') {ErrorMSG("Boolean Expression syntax");return 0;}
			if(expr[pos+1]!='!'){
				if(expr[pos+1]!='('){ErrorMSG("Boolean Expression syntax");return 0;}
			}else if(expr[pos+2]!='('){ErrorMSG("Boolean Expression syntax");return 0;}
		}
		if((c=='!')&&(expr[pos+1])!='('){ErrorMSG("Boolean Expression syntax");return 0;}
		//)
	}

	return EvaluateExpression(expr);

}

void  BasicEmu::Button4Click()
{
	//STEP CODE
	Button1->Enabled=false;
	Button2->Enabled=true;
	Button3->Enabled=true;
	Button4->Enabled=true;
	Button2->Caption="CONTINUE";
	if(commandCNTR>=CMDnum){
    	commandCNTR=0;
	}
	
	ProcessCommand(&CMD[commandCNTR]);
	
	WatchVar();
	commandCNTR++;

	if(commandCNTR>=CMDnum){
		run=0;
		Button1->Enabled=true;
		Button2->Enabled=false;
		Button3->Enabled=true;
		Button4->Enabled=true;
		if(errorlinenum<0)ShowMessage("PROGRAM SUCCESSFULLY FINISHED");
		commandCNTR=0;
		FormHide();
	}
	Memo1->SelectLine(commandCNTR);
	//if(len>10)len=10;
}
//---------------------------------------------------------------------------

//variable Watch
void  BasicEmu::WatchVar(){	
	int x,w,px,py,res;
	AnsiString e,name,rawname,PX,PY,msg;
	
	tlist->Clear();
	px=0;
	for(x=0;x<Memo2->Count();x++){
		if(!Memo2->Lines->Strings[x].IsEmpty()){
			tlist->Add(Memo2->Lines->Strings[x]);
			px++;
		}
	}
	if(!px)return;
	
	for(x=0;x<tlist->Count;x++){
		e=tlist->Strings[x];
		rawname=GetFirstVariableName( e );
		name=SplitArrayVariableName(rawname,PX,PY);

		for(w=0;w<Vcnt;w++){
			if(!V[w].name.AnsiCompare(name) ){
				break;
			}
		}
		if(w>=Vcnt)continue;

		px=-1,py=-1;
		if(!PX.IsEmpty())px=EvaluateExpression(PX);
		if(!PY.IsEmpty())py=EvaluateExpression(PY);
		res=GetVariable(name,px,py);
		e.Sprintf("%d",res);
		msg=rawname+"="+e;
		tlist->Strings[x]=msg;
	}
	//Memo2->Clear();
	for(x=0;x<tlist->Count;x++){
		if(tlist->Strings[x].IsEmpty())
			tlist->Delete(x);
	}
	Memo2->LoadText(tlist);
	while(Memo2->Count()<=22)
		Memo2->Add("");
}

//Modify variable
void  BasicEmu::Button5Click()
{
	AnsiString str=Edit1->Text;
	AnsiString name,expression,PX,PY;
	int px,py,w,subresult;
//MODIFY variable
	name=GetFirstVariableName( str );
	expression=str;
	expression.Delete(1,name.Length()+1);
	name=SplitArrayVariableName(name,PX,PY);

	for(w=0;w<Vcnt;w++){
		if(!V[w].name.AnsiCompare(name) ){
			break;
		}
	}
	if(w>=Vcnt){
		ShowMessage(u+"ERROR: The variable '"+name+"' does not exist");
		return;
	}

	px=-1,py=-1;
	if(!PX.IsEmpty())px=EvaluateExpression(PX);
	if(!PY.IsEmpty())py=EvaluateExpression(PY);

	subresult=EvaluateExpression(expression);
	PutVariable(name,px,py,subresult);
}
//---------------------------------------------------------------------------

void  BasicEmu::Button6Click()
{
	WatchVar();
	Memo1->SelectLine(commandCNTR);
	//if(len>10)len=10;
}
//---------------------------------------------------------------------------

//initialize random seeds (1.st and 2.st seeds)
void  BasicEmu::RandSeed(){
/* initialize random seed: */
  srand ( time(NULL) );
}

int   BasicEmu::RandomNumber(int randmax){
  /* generate secret number: */
  return(rand() % randmax);
}

//GRAPHICS
void  BasicEmu::DrawTo(int x,int y){
	int Sx,Sy,Ex,Ey;
	int w;

	if((x<0)||(y<0)){
		ErrorMSG("PLOT: coordinates could not be negative");run=0;return;
	}
	if((x>=MaxX)||(y>=MaxY)){
		ErrorMSG("PLOT: coordinates out of range");run=0;return;
	}

	Sx=x,Sy=y;
	Ex=GposX,Ey=GposY;
	Plot(Ex,Ey,SysColor);
	Plot(Sx,Sy,SysColor);
	float m;

	if(abs(Ey-Sy)<=abs(Ex-Sx)){
		m=((float)Ey-(float)Sy)/((float)Ex-(float)Sx);
		for(w=0;((Ex-Sx)>=0)?(w<Ex-Sx):(w>Ex-Sx);((Ex-Sx)>=0)?w++:w--){
			Plot(w+Sx,m*w+Sy,SysColor);
		}
	}else{
		m=((float)Ex-(float)Sx)/((float)Ey-(float)Sy);
		for(w=0;((Ey-Sy)>=0)?(w<Ey-Sy):(w>Ey-Sy);((Ey-Sy)>=0)?w++:w--){
			Plot(m*w+Sx,w+Sy,SysColor);
		}
	}
}

//GRAPHICS
void  BasicEmu::VerShiftGrLine(int line,char dir){
	if((line<0)||(line>=MaxX)){
		ErrorMSG("invalid vertical line number");return;
	}
	int x,y;
	x=line;
	if(dir==1){
		for(y=1;y<MaxY;y++)
			GRbuf[x][y-1]=GRbuf[x][y];
		GRbuf[x][MaxY-1]=0;

	}else{
		for(y=MaxY-2;y>=0;y--)
			GRbuf[x][y+1]=GRbuf[x][y];
		GRbuf[x][0]=0;
	}

	UpdateScr();
}

//GRAPHICS
void 	BasicEmu::HorShiftGrLine(int line,char dir){
	if((line<0)||(line>=MaxY)){
		ErrorMSG("invalid horisontal line number");return;
	}
	int x,y;
	y=line;
	if(dir==1){
		for(x=1;x<MaxX;x++){
			GRbuf[x-1][y]=GRbuf[x][y];
		}
		GRbuf[MaxX-1][y]=0;
	}else{
		for(x=MaxX-2;x>=0;x--)
			GRbuf[x+1][y]=GRbuf[x][y];
		GRbuf[0][y]=0;
	}

	UpdateScr();
}

//GRAPHICS
void 	BasicEmu::PutPattern(AnsiString name,int x,int y,int px,int py,command* COMMAND){
	int X,Y,tx,ty,color,mode,xx,yy,poi;
	if(name[1]=='#')mode=1;
	else mode=0;

	if(mode){
		yy=COMMAND->JMPcode;
		yy=CMD[yy].JMPcode;
		poi=0;

		for(Y=y,ty=0;Y<=py;Y++,ty++)
			for(X=x,tx=0;X<=px;X++,tx++){
				while(poi>=DATA[yy].dnum){
					yy++;
					poi-=DATA[yy].dnum;
					if(DATA[yy].data==NULL){
						ErrorMSG("Last data reached in DATA lines");return;
					}
				}
				color=DATA[yy].data[poi];
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
				poi++;
			}
		DATA[yy].dpoi=0;
	}else{
		for(X=x,tx=0;X<=px;X++,tx++)
			for(Y=y,ty=0;Y<=py;Y++,ty++){
				color=GetVariable(name,tx,ty);
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
			}
	}
	SCdirty=1;
}

void    BasicEmu::PutPatMirVer(AnsiString name,int x,int y,int px,int py,command* COMMAND){
	int X,Y,tx,ty,color,mode,xx,yy,poi;
	if(name[1]=='#')mode=1;
	else mode=0;

	if(mode){
		yy=COMMAND->JMPcode;
		yy=CMD[yy].JMPcode;
		poi=0;

		for(Y=y,ty=0;Y<=py;Y++,ty++)
			//for(X=x,tx=0;X<=px;X++,tx++){
			for(X=px,tx=0;X>=x;X--,tx++){
				while(poi>=DATA[yy].dnum){
					yy++;
					poi-=DATA[yy].dnum;
					if(DATA[yy].data==NULL){
						ErrorMSG("Last data reached in DATA lines");return;
					}
				}
				color=DATA[yy].data[poi];
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
				poi++;
			}
		DATA[yy].dpoi=0;
	}else{
		for(X=px,tx=0;X>=x;X--,tx++)
		//for(X=x,tx=0;X<=px;X++,tx++)
			for(Y=y,ty=0;Y<=py;Y++,ty++){
				color=GetVariable(name,tx,ty);
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
			}
	}
	SCdirty=1;
}

void    BasicEmu::PutPatTwist(AnsiString name,int x,int y,int px,int py,command* COMMAND){
	int X,Y,tx,ty,color,mode,xx,yy,poi;
	if(name[1]=='#')mode=1;
	else mode=0;

	if(mode){
		yy=COMMAND->JMPcode;
		yy=CMD[yy].JMPcode;
		poi=0;

		for(X=x,tx=0;X<=px;X++,tx++)
			for(Y=y,ty=0;Y<=py;Y++,ty++){
				while(poi>=DATA[yy].dnum){
					yy++;
					poi-=DATA[yy].dnum;
					if(DATA[yy].data==NULL){
						ErrorMSG("Last data reached in DATA lines");return;
					}
				}
				color=DATA[yy].data[poi];
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
				poi++;
			}
		DATA[yy].dpoi=0;
	}else{
		for(Y=y,ty=0;Y<=py;Y++,ty++)
			for(X=x,tx=0;X<=px;X++,tx++){
				color=GetVariable(name,tx,ty);
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
			}
	}
	SCdirty=1;
}

void    BasicEmu::PutPatTwisMir(AnsiString name,int x,int y,int px,int py,command* COMMAND){
	int X,Y,tx,ty,color,mode,xx,yy,poi;
	if(name[1]=='#')mode=1;
	else mode=0;

	if(mode){
		yy=COMMAND->JMPcode;
		yy=CMD[yy].JMPcode;
		poi=0;

		for(X=x,tx=0;X<=px;X++,tx++)
			//for(Y=y,ty=0;Y<=py;Y++,ty++){
			for(Y=py,ty=0;Y>=y;Y--,ty++){
				while(poi>=DATA[yy].dnum){
					yy++;
					poi-=DATA[yy].dnum;
					if(DATA[yy].data==NULL){
						ErrorMSG("Last data reached in DATA lines");return;
					}
				}
				color=DATA[yy].data[poi];
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
				poi++;
			}
		DATA[yy].dpoi=0;
	}else{
		//for(Y=y,ty=0;Y<=py;Y++,ty++)
		for(Y=py,ty=0;Y>=y;Y--,ty++)
			for(X=x,tx=0;X<=px;X++,tx++){
				color=GetVariable(name,tx,ty);
				if((X>=MaxX)||(Y>=MaxY)){
					ErrorMSG("coordinates out of range");return;
				}
				GRbuf[X][Y]=color;
			}
	}
	SCdirty=1;
}

void    BasicEmu::DelPattern(int x,int y,int px,int py,command* COMMAND){
	int X,Y;
	for(X=x;X<=px;X++)
		for(Y=y;Y<=py;Y++){
			if((X>=MaxX)||(Y>=MaxY)){
				ErrorMSG("coordinates out of range");return;
			}
			GRbuf[X][Y]=0;
		}
	SCdirty=1;
}

//GRAPHICS
void 	BasicEmu::GetPattern(AnsiString name,int x,int y,int px,int py){
	int X,Y,tx,ty,color;
	for(X=x,tx=0;X<=px;X++,tx++)
		for(Y=y,ty=0;Y<=py;Y++,ty++){
			color=GRbuf[X][Y];
			if((X>=MaxX)||(Y>=MaxY)){
				ErrorMSG("coordinates out of range");return;
			}
			PutVariable(name,tx,ty,color);
		}
	UpdateScr();
}

//KEYBOARD
int  	BasicEmu::KeybInput(){
	int K;
	K=KEY;
	KEY=0;
	return K;
}

//KEYBOARD
int  	BasicEmu::WaitKey(){
	/*
	int K;
	Label4->Caption="PRESS ANY KEY !";
	KEY=0;
	run=0;
	InTimer=1;
	Button2Click();

	while((KEY==0) && TimerRun){
		Application->ProcessMessages();
		MsgWaitForMultipleObjectsEx(0,NULL,100,0,0);
	}
	
	ShowMessage("TEST - Waitkey exited");
	InTimer=0;
	run=1;
	K=KEY;
	Label4->Caption="";	
	return K;
	*/
}

//---------------------------------------------------------------------------

//Redraw screen from buffer
void  BasicEmu::UpdateScr(){
	int x,y;

	for(x=0;x<MaxX;x++)
		for(y=0;y<MaxY;y++)
			Plot(x,y,GRbuf[x][y]);
	SCdirty=1;
}

void  BasicEmu::OnChar(char Key){
	KEY=Key;
}

void  BasicEmu::OnKeyDown(WPARAM w){
	w=w&0xFF;
	char c=(char)w;
	if(w==112){
		if(Button1->Enabled)Button1Click();
	}
	if(w==113){
		if(Button2->Enabled)Button2Click();
	}
	if(w==114){
		if(Button4->Enabled)Button4Click();
	}
	if(w==115){
		if(Button3->Enabled)Button3Click();
	}
	if(w==123){//F12
		CheckBox1Click();
	}
	switch(w){
		case VK_LEFT:
		case VK_RIGHT:
		case VK_UP:
		case VK_DOWN:
		case VK_ESCAPE:
		case VK_TAB:
		case VK_SPACE:
			KEY=c;
			break;
	}
}

//---------------------------------------------------------------------------


void  BasicEmu::Button7Click()
{
	int x,y;
	//clear screen
	for(x=0;x<SCRX;x++)
		for(y=0;y<SCRY;y++)
			GRbuf[x][y]=0;
	UpdateScr();
}
//---------------------------------------------------------------------------

void  BasicEmu::Button8Click()
{
	//randmize screen
	int x,y;
	srand ( time(NULL) );
	for(x=0;x<SCRX;x++)
		for(y=0;y<SCRY;y++)
			if((rand() % 100)>50)GRbuf[x][y]=255;
			else GRbuf[x][y]=0;

	UpdateScr();
}

//---------------------------------------------------------------------------
void  BasicEmu::Timer1Timer()
{
//RUNTIMER
	if(!run)return;
	if(delaycnt){
		delaycnt--;
		return;
	}
		
	if(commandCNTR<CMDnum)
		ProcessCommand(&CMD[commandCNTR]);
	commandCNTR++;

	stepline=commandCNTR;
		
	if(SidAudio==NULL){
		if(CheckBox1->Checked){
			if((Memo1->LastSelectedLine!=commandCNTR)&&(commandCNTR<Memo1->Count()))
				Memo1->SelectLine(commandCNTR);
			WatchVar();
		}
		if(commandCNTR>=CMDnum){
			run=0;
			Button1->Enabled=true;
			Button2->Enabled=false;
			Button3->Enabled=true;
			Button4->Enabled=true;
			if(errorlinenum<0){ShowMessage("PROGRAM SUCCESSFULLY FINISHED");}
			commandCNTR=0;
			FormHide();
		}
	}
}

//---------------------------------------------------------------------------
void  BasicEmu::Timer2Timer()
{
	//Handle grapic buffer
	if(!SCdirty)return;
	int x,y;
	for(y=0;y<SCRY;y++){
		for(x=0;x<SCRX;x++){
			Canvas->Pixels[x*2][y*2] = RGB(GRbuf[x][y],GRbuf[x][y],GRbuf[x][y]);
			Canvas->Pixels[x*2+1][y*2] = RGB(GRbuf[x][y],GRbuf[x][y],GRbuf[x][y]);
			Canvas->Pixels[x*2][y*2+1] = RGB(GRbuf[x][y],GRbuf[x][y],GRbuf[x][y]);
			Canvas->Pixels[x*2+1][y*2+1] = RGB(GRbuf[x][y],GRbuf[x][y],GRbuf[x][y]);
		}
	}
	SCdirty=0;
	Canvas->Update();
}

void BasicEmu::OnPaint(){
	SCdirty=1;
	//Canvas->Update();
}
//---------------------------------------------------------------------------

void BasicEmu::OnTimer(unsigned TimerID){
	static volatile int tmrcnt=0;
	if(!TimerRun)return;
	if(InTimer)return;
	InTimer=1;
	int x;
	if(TimerID==Timer1->ID){
		if(!CheckBox1->Checked)
			for(x=0;x<13;x++)
				Timer1Timer();
		Timer1Timer();
		
		if(SidAudio==NULL){
			if(PrintList->Count){
				Memo3->Add(PrintList->Strings[0]);
				PrintList->Delete(0);
			}
			if(tmrcnt>=4){
				tmrcnt=0;
				Timer2Timer();
			}
			tmrcnt++;
		}
	}

	if(SidAudio)
		if(Timer1->EnabledState)
			PostMessage(DialogOwner,WM_USER,0,0);
		
	InTimer=0;
}

void BasicEmu::OnUserMessage(WPARAM wParam, LPARAM lParam){
	static volatile int tmrcnt=0;
	if(wParam==1){
		this->ModalResult(mrCancel);
		return;
	}
	
	if(wParam==2){
		Memo3->Clear();
		return;
	}

	if(!TimerRun)return;
	if(InTimer)return;
	InTimer=1;	

	if(PrintList->Count){
		Memo3->Add(PrintList->Strings[0]);
		PrintList->Delete(0);
	}

	if(tmrcnt>=4){
		tmrcnt=0;
		Timer2Timer();
	}
	tmrcnt++;
	if(CheckBox1->Checked){
		if((Memo1->LastSelectedLine!=commandCNTR)&&(commandCNTR<Memo1->Count()))
			Memo1->SelectLine(commandCNTR);
		WatchVar();
	}
	if(commandCNTR>=CMDnum){
		run=0;
		Button1->Enabled=true;
		Button2->Enabled=false;
		Button3->Enabled=true;
		Button4->Enabled=true;
		if(errorlinenum<0)ShowMessage("PROGRAM SUCCESSFULLY FINISHED");
		commandCNTR=0;
		FormHide();
	}
	
	int x;
	if(SidAudio)
		for(x=0;x<5;x++)
			SidAudio->AudioTimer();

	InTimer=0;
}
