
RNGTABLTE: DB 0x00
HLT
NOP



HLT
NOP

sr1swap: DB 0x00,0x00
indexx: DB 0x00,0x00
indexy: DB 0x00,0x00
forstepind: DB 0x00
;Cursor
CurX: DB 0x00,0x00
CurY: DB 0x00,0x00
SysColor: DB 0xFF
;pattern coords
PatCstX: DB 0x00
PatCstY: DB 0x00
PatCenX: DB 0x00
PatCenY: DB 0x00
;Random number generation
RNGTABLTEDIM: DB 0x00,0x00
;Keyboard
KEYBreg: DB 0x00

;Temporary registers
B_tmp: DB 0x00
C_tmp: DB 0x00
D_tmp: DB 0x00
E_tmp: DB 0x00
H_tmp: DB 0x00
L_tmp: DB 0x00

;SID registers
SIDreg04: DB 0x00
SIDreg08: DB 0x00
SIDreg11: DB 0x00
SIDreg18: DB 0x00
SIDreg24: DB 0x00

;*********************************************
; SUBROUTINES
;*********************************************

;DUMMY CALLS
CALL Multiply
CALL Divider
CALL PRINT
CALL XPRINT
CALL DRAWTO
CALL PUTPATTERN
CALL PUTPATMIRVER
CALL PUTPATTWIST
CALL PUTPATTWISMIR
CALL DELPATTERN
CALL DELAY
CALL PLOT
CALL RNG
CALL CLRSCR128

;--------------------------------------------------------------------
; MULTIPLIER

#PROC Multiply
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
MVI A,0x80
AND B
JM compl1
MVI A,0x80
AND D
JM compl2
NormMul:
CALL UMultiply
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
RET

compl1:
CALL Compl2BC
MVI A,0x80
AND D
JM compl3
JMP complX

compl2:
CALL Compl2DE
MVI A,0x80
AND B
JM compl4
complX:
CALL UMultiply
CALL Compl2BC
RET

compl3:
CALL Compl2DE
JMP NormMul

compl4:
CALL Compl2BC
JMP NormMul

#END


#PROC UMultiply
MVI A,0x01
AND C
JZ m1
MOV L,E
MOV H,D
JMP m2
m1: MVI H,0
MVI L,0
m2: 
CALL SHLXDE

MVI A,0x02
AND C
JZ m3

CALL ADDXDE
m3: 
CALL SHLXDE
MVI A,0x04
AND C
JZ m4

CALL ADDXDE
m4: 
CALL SHLXDE
MVI A,0x08
AND C
JZ m5

CALL ADDXDE
m5: 
CALL SHLXDE
MVI A,0x10
AND C
JZ m6

CALL ADDXDE
m6: 
CALL SHLXDE
MVI A,0x20
AND C
JZ m7

CALL ADDXDE
m7: 
CALL SHLXDE
MVI A,0x40
AND C
JZ m8

CALL ADDXDE
m8: 
CALL SHLXDE
MVI A,0x80
AND C
JZ m9

CALL ADDXDE
m9: 
CALL SHLXDE
MVI A,0x01
AND B
JZ m10

CALL ADDXDE
m10: 
CALL SHLXDE
MVI A,0x02
AND B
JZ m11

CALL ADDXDE
m11: 
CALL SHLXDE
MVI A,0x04
AND B
JZ m12

CALL ADDXDE
m12: 
CALL SHLXDE
MVI A,0x08
AND B
JZ m13

CALL ADDXDE
m13: 
CALL SHLXDE
MVI A,0x10
AND B
JZ m14

CALL ADDXDE
m14: 
CALL SHLXDE
MVI A,0x20
AND B
JZ m15

CALL ADDXDE
m15: 
CALL SHLXDE
MVI A,0x40
AND B
JZ m16

CALL ADDXDE
m16:
MOV B,H
MOV C,L
RET
#END

#PROC ADDXDE
;ADDX
MOV A,E
ADD L
MOV L,A
MOV A,D
ADC H
MOV H,A
RET
#END


;--------------------------------------------------------------------
;DIVIDER

#PROC Divider
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
MVI A,0x80
AND B
JM compl1_d
MVI A,0x80
AND D
JM compl2_d
NormDiv:
CALL UDivider
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
RET

compl1_d:
CALL Compl2BC
MVI A,0x80
AND D
JM compl3_d
JMP complX_d

compl2_d:
CALL Compl2DE
MVI A,0x80
AND B
JM compl4_d
complX_d:
CALL UDivider
CALL Compl2BC
RET

compl3_d:
CALL Compl2DE
JMP NormDiv

compl4_d:
CALL Compl2BC
JMP NormDiv

#END



;BC=BC/DE
#PROC UDivider
XOR A
OR E
JNZ divcnt
XOR A
OR D
JNZ divcnt
MVI B,0xFF
MVI C,0xFF
RET

divcnt:
XOR A
OR B
JNZ divsh
XOR A
OR C
JNZ divsh
RET

divsh:
MVI A,0x01
SUB E
JNZ divgencnt
XOR A
SUB D
JNZ divgencnt
RET
divgencnt:
MVI A,0x01
AND E
JNZ divug1
CALL SHRXDE
CALL SHRXBC
JMP divsh

divug1:

XOR A
STA [shcntr]
STA [divsumH]
STA [divsumL]
MOV H,A
MOV L,A
MOV A,C
SUB E
JNZ divgen3
MOV A,B
SBB D
JNZ divgen3
MVI B,0x00
MVI C,0x01
RET

divgen3:
CALL SHLXDE
LDA [shcntr]
MVI H,0x01
ADD H
STA [shcntr]
MOV A,C
SUB E
MOV A,B
SBB D
JP divgen3
CALL SHRXDE
LDA [shcntr]
MVI H,0x01
SUB H
STA [shcntr]



mainsubcyc:
XOR A
MOV L,A
MOV H,A

;cycle for substraction
divsubs:
MOV A,C
SUB E
MOV C,A
MOV A,B
SBB D
MOV B,A
JM subsvege
INX HL
JMP divsubs
subsvege:
;correction with addition
MOV A,C
ADD E
MOV C,A
MOV A,B
ADC D
MOV B,A

;check if HL=0
XOR A
SUB H
JNZ atugr1
XOR A
SUB L
JZ subatugr
atugr1:

LDA [shcntr]
STA [mulcnt]
MOV A,H
STA [PdivsumH]
MOV A,L
STA [PdivsumL]

;test if sub counter ==0
MVI H,0x00
LDA [mulcnt]
SUB H
JZ nosubshift

;Shift sub counter
multcyc:
LDA [PdivsumL]
MOV L,A
LDA [PdivsumH]
MOV H,A
MOV A,L
ADD L
STA [PdivsumL]
MVI A,H
ADC H
STA [PdivsumH]
LDA [mulcnt]
MVI H,0x01
SUB H
STA [mulcnt]
JNZ multcyc

nosubshift:

;ADD to main result
LDA [PdivsumL]
MOV L,A
LDA [PdivsumH]
MOV H,A
LDA [divsumL]
ADD L
STA [divsumL]
LDA [divsumH]
ADC H
STA [divsumH]

subatugr:
;test if divider ==1
MVI A,0x01
SUB E
JZ testif0x1
JMP not0x1
testif0x1:
MVI A,0x00
SUB D
JZ divvegeend
not0x1:

CALL SHRXDE
LDA [shcntr]
MVI H,0x00
ADD H
JZ divvegeend
MVI H,0x01
SUB H
STA [shcntr]
JMP mainsubcyc

divvegeend:
LDA [divsumH]
MOV B,A
LDA [divsumL]
MOV C,A

RET
shcntr:
DB 0x00
divsumH:
DB 0x00
divsumL:
DB 0x00
mulcnt:
DB 0x00
PdivsumH:
DB 0x00
PdivsumL:
DB 0x00
NOP
#END


#PROC SHRXDE
;SHR
MOV A,D
RRA
MOV D,A
MOV A,E
RRA
MOV E,A
MVI A,0x7F
AND E
MOV E,A
MVI A,0x80
AND D
OR E
MOV E,A
MVI A,0x7F
AND D
MOV D,A
RET
#END

#PROC SHRXBC
;SHR
MOV A,B
RRA
MOV B,A
MOV A,C
RRA
MOV C,A
MVI A,0x7F
AND C
MOV C,A
MVI A,0x80
AND B
OR C
MOV C,A
MVI A,0x7F
AND B
MOV B,A
RET
#END

;legfelso bit nem lehet 1-es -> tulcsordulas
#PROC SHLXDE
;SHL
MOV A,D
RLA
MOV D,A
MOV A,E
RLA
MOV E,A
MVI A,0x01
AND E
OR D
MOV D,A
MVI A,0xFE
AND E
MOV E,A
RET
#END


#PROC Compl2BC
MOV A,B
CMA
MOV B,A
MOV A,C
CMA
MOV C,A
MVI A,0x01
ADD C
MOV C,A
MVI A,0x00
ADC B
MOV B,A
RET
#END

#PROC Compl2DE
MOV A,D
CMA
MOV D,A
MOV A,E
CMA
MOV E,A
MVI A,0x01
ADD E
MOV E,A
MVI A,0x00
ADC D
MOV D,A
RET
#END


;--------------------------------------------------------------------
;DRAWTO

#PROC DRAWTO
;Check if coords bigger than 255
MVI A,0x00
OR B
JNZ dr_inv%%
MVI A,0x00
OR D
JNZ dr_inv%%
LDA [CurX]
MVI B,0x00
OR B
JNZ dr_inv%%
LDA [CurY]
MVI B,0x00
OR B
JNZ dr_inv%%
;save endpoints
MOV A,C
STA [PEndX]
MOV A,E
STA [PEndY]
;check if StartX>EndX
LDA [CurX+1]
MOV B,A
MOV A,C
SUB B
JC dr_signOk%%
LDA [CurX+1]
MOV B,A
MOV A,C
STA [CurX+1]
MOV C,B
LDA [CurY+1]
MOV B,A
MOV A,E
STA [CurY+1]
MOV E,B
dr_signOk%%:
;compute Xdiff and Ydiff
LDA [CurX+1]
MOV B,A
MOV A,C
SUB B
STA [Xdiff]
LDA [CurY+1]
MOV B,A
MOV A,E
SUB B
STA [Ydiff]
;Check if Ydiff<0
MVI B,0x00
ADD B
JP dr_ypoz%%
CMA
MVI B,0x01
ADD B
STA [Ydiff]
MVI A,0x01
STA [Mmod]
JMP dr_ypn%%
dr_ypoz%%:
MVI A,0x00
STA [Mmod]
dr_ypn%%:
;check if Xdiff<Ydiff
LDA [Ydiff]
MOV B,A
LDA [Xdiff]
SUB B
JNC dr_mode1%%
MVI A,0x00
STA [Dmod]
JMP dr_mode0%%
;exchange X and Y coords
dr_mode1%%:
MVI A,0x01
STA [Dmod]
MOV A,C
MOV C,E
MOV E,A
LDA [CurX+1]
MOV B,A
LDA [CurY+1]
MOV D,A
MOV A,B
STA [CurY+1]
MOV A,D
STA [CurX+1]
LDA [Xdiff]
MOV B,A
LDA [Ydiff]
MOV D,A
MOV A,B
STA [Ydiff]
MOV A,D
STA [Xdiff]

dr_mode0%%:
MVI A,0x00
STA [Yerr]
STA [Yerr+1]

;compute line
LDA [CurX+1]
MOV B,A
LDA [CurY+1]
MOV D,A
;special case:
;when Dmod=Mmod=1
;XCHG start and endpoint
LDA [Mmod]
OR A
JZ dr_atusp%%
LDA [Dmod]
OR A
JZ dr_atusp%%
MOV A,B
MOV B,C
MOV C,A
MOV A,D
MOV D,E
MOV E,A
dr_atusp%%:
;drawing loop
drw_loop%%:
MOV A,B
SUB C
JZ drw_loop_ok%%
JNC drw_loop_ok%%
JMP drw_end%%
drw_loop_ok%%:
LDA [Dmod]
OR A
JZ dr_modeS%%
MOV A,B
STA [0xC003]
MOV A,D
STA [0xC002]
JMP dr_modeATU%%
dr_modeS%%:
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
dr_modeATU%%:
LDA [SysColor]
STA [0xC004]

LDA [Yerr+1]
MOV E,A
LDA [Ydiff]
ADD E
STA [Yerr+1]
LDA [Yerr]
MVI E,0
ADC E
STA [Yerr]

LDA [Yerr+1]
MOV E,A
LDA [Xdiff]
SUB E;Xdif-Yerr
STA [DRWtmp]
LDA [Yerr]
MOV E,A
MVI A,0x00
SBB E
JNC drw_cmp%%
MOV E,A
LDA [DRWtmp]
OR E
JZ drw_cmp%%
JMP drw_loop_inc%%

drw_cmp%%:
LDA [Mmod]
OR A
JZ dr_yNov%%
MOV A,D
MVI D,0x01
SUB D
MOV D,A
JMP dr_yVari%%
dr_yNov%%:
MVI A,0x01
ADD D
MOV D,A
dr_yVari%%:
;Yerr=Yerr-Xdiff
LDA [Xdiff]
MOV E,A
LDA [Yerr+1]
SUB E
STA [Yerr+1]
LDA [Yerr]
MVI E,0
SBB E
STA [Yerr]

drw_loop_inc%%:
MVI A,0x01
ADD B
MOV B,A
JMP drw_loop%%

dr_inv%%:
drw_end%%:
;cursor=endpoint of line
LDA [PEndX]
STA [CurX+1]
LDA [PEndY]
STA [CurY+1]
RET

#END

Xdiff: DB 0x00;unsigned
Ydiff: DB 0x00;unsigned
Yerr:  DB 0x00,0x00;signed
Dmod:  DB 0x00;mode: 1 or 0
Mmod:  DB 0x00;mode: 1 or 0
PEndX: DB 0x00
PEndY: DB 0x00
DRWtmp:DB 0x00

;--------------------------------------------------------------------


SZOVEG:
DB 0x53
DB 0x7A
DB 0x69
DB 0x61
DB 0x20
DB 0x42
DB 0x61
DB 0x72
DB 0x69
DB 0x00

HEXANUM:
DB 0x48
DB 0x45
DB 0x58
DB 0x41
DB 0x20
DB 0x20
DB 0x20
DB 0x30
DB 0x78
HEXANUMST:
DB 0x41
DB 0x41
DB 0x41
DB 0x41
DB 0x0A
DB 0x00

#PROC XPRINT
;BC=KIIRANDO HEXA SZAM
MOV A,B
RRA
RRA
RRA
RRA
MVI E,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST]
MOV E,B
MVI A,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST+1]

MOV A,C
RRA
RRA
RRA
RRA
MVI E,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST+2]
MOV E,C
MVI A,0x0F
AND E
MOV E,A
CALL XHPRCONV
MOV A,E
STA [HEXANUMST+3]


LDA [Xcoord]
MVI B,0xFE
AND B
JZ NXRSTCUR
MVI C,0x0A
CALL PUTCHAR
NXRSTCUR:
MVI H,[HIGH HEXANUM]
MVI L,[LOW HEXANUM]
CALL PRINT
RET
#END

#PROC XHPRCONV
MOV A,E
MVI D,0x0A
SUB D
JM XHP09
MOV A,E
MVI D,0x37
ADD D
JMP XHPV
XHP09:
MOV A,E
MVI D,0x30
ADD D
XHPV:
MOV E,A
RET
#END

#PROC PRINT
;HL: pointer to NULL terminated string
xcyc:
MOV C,M
MOV A,C
MVI B,0xFF
AND B
JZ xkilep
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
CALL PUTCHAR
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
INX HL
JMP xcyc
xkilep:
RET
#END

#PROC PUTCHAR
;C=char to print out
;check if carriage return (10 or 13)
MVI A,10
SUB C
JZ carriageret
MVI A,13
SUB C
JZ carriageret
MOV E,C
LDA [Xcoord]
RLA
RLA
RLA
STA [XcoordTMP]
LDA [Ycoord]
RLA
RLA
RLA
STA [YcoordTMP]
MOV A,C
MVI B,0x20
SUB B
MVI B,0
MOV C,A
ADD C
MOV C,A
MOV A,B
ADC B
MOV B,A
MOV A,C
ADD C
MOV C,A
MOV A,B
ADC B
MOV B,A
MOV A,C
ADD C
MOV C,A
MOV A,B
ADC B
STA [AddrAddonH]
MOV A,C
STA [AddrAddonL]
MOV C,E
MVI A,0x07
STA [Xcikl]
STA [Ycikl]

putchcikl:	;cycle outside -------------

MVI A,[LOW CHARSET]
MOV L,A
MVI A,[HIGH CHARSET]
MOV H,A
LDA [AddrAddonL]
ADD L
MOV L,A
LDA [AddrAddonH]
ADC H
MOV H,A
LDA [Ycikl]
ADD L
MOV L,A
MVI A,0
ADC H
MOV H,A
MOV A,M
STA [Pixtmp]

putchciklins:	;cycle inside -------------

LDA [XcoordTMP]
MOV H,A
LDA [Xcikl]
ADD H
STA [0xC002]	;Xreg
LDA [YcoordTMP]
MOV H,A
LDA [Ycikl]
ADD H
STA [0xC003]	;Yreg

LDA [Pixtmp]
MOV L,A
RRA
STA [Pixtmp]
MOV A,L
MVI H,0x01
AND H
JZ nullpix
MVI A,255
STA [0xC004]	;Zreg
JMP pixatug
nullpix:
MVI A,0
STA [0xC004]	;Zreg
pixatug:
LDA [Xcikl]
MVI H,1
SUB H
STA [Xcikl]
JNZ putchciklins
LDA [Ycikl]
MVI H,1
SUB H
STA [Ycikl]
MVI A,7
STA [Xcikl]
JNZ putchcikl
;move cursor
LDA [Xcoord]
MVI B,1
ADD B
STA [Xcoord]
MVI B,19
SUB B
JM chplotexit
carriageret:
MVI A,0x01
STA [Xcoord]
LDA [Ycoord]
MVI B,0x01
ADD B
STA [Ycoord]
MVI B,14
SUB B
JM chplotexit
MVI A,0x01
STA [Ycoord]
chplotexit:
RET
#END

Pixtmp:
DB 0x00
Xcikl:
DB 0x00
Ycikl:
DB 0x00
AddrAddonL:
DB 0x00
AddrAddonH:
DB 0x00
XcoordTMP:
DB 0x00
YcoordTMP:
DB 0x00
Xcoord:
DB 0x01
Ycoord:
DB 0x01


CHARSET:

CH_@1:
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00

CH_@2:
DB 0x00
DB 0x00
DB 0x04
DB 0x04
DB 0x1F
DB 0x04
DB 0x04
DB 0x00

CH_@3:
DB 0x00
DB 0x00
DB 0x04
DB 0x15
DB 0x0E
DB 0x15
DB 0x04
DB 0x00

CH_@4:
DB 0x00
DB 0x00
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x10
DB 0x00

CH_@5:
DB 0x00
DB 0x04
DB 0x0E
DB 0x15
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_@6:
DB 0x00
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x00
DB 0x04

CH_@7:
DB 0x00
DB 0x0A
DB 0x0A
DB 0x0A
DB 0x00
DB 0x00
DB 0x00
DB 0x00

CH_@8:
DB 0x00
DB 0x0A
DB 0x0A
DB 0x1F
DB 0x0A
DB 0x1F
DB 0x0A
DB 0x0A

CH_@9:
DB 0x00
DB 0x04
DB 0x0F
DB 0x14
DB 0x0E
DB 0x05
DB 0x1E
DB 0x04

CH_@10:
DB 0x00
DB 0x08
DB 0x04
DB 0x02
DB 0x01
DB 0x02
DB 0x04
DB 0x08

CH_@11:
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x00
DB 0x00
DB 0x00

CH_@12:
DB 0x00
DB 0x10
DB 0x08
DB 0x04
DB 0x02
DB 0x1F
DB 0x00
DB 0x1F

CH_@13:
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x00
DB 0x1F
DB 0x00
DB 0x00

CH_@14:
DB 0x00
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x1F
DB 0x00
DB 0x1F

CH_@15:
DB 0x00
DB 0x02
DB 0x04
DB 0x08
DB 0x10
DB 0x08
DB 0x04
DB 0x02

CH_@16:
DB 0x00
DB 0x00
DB 0x08
DB 0x1F
DB 0x04
DB 0x1F
DB 0x02
DB 0x00

CH_0:
DB 0x00
DB 0x0E
DB 0x11
DB 0x13
DB 0x15
DB 0x19
DB 0x11
DB 0x0E

CH_1:
DB 0x00
DB 0x04
DB 0x0C
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_2:
DB 0x00
DB 0x0E
DB 0x11
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x1F

CH_3:
DB 0x00
DB 0x1F
DB 0x02
DB 0x04
DB 0x02
DB 0x01
DB 0x11
DB 0x0E

CH_4:
DB 0x00
DB 0x02
DB 0x06
DB 0x0A
DB 0x12
DB 0x1F
DB 0x02
DB 0x02

CH_5:
DB 0x00
DB 0x1F
DB 0x10
DB 0x1E
DB 0x01
DB 0x01
DB 0x11
DB 0x0E

CH_6:
DB 0x00
DB 0x06
DB 0x08
DB 0x10
DB 0x1E
DB 0x11
DB 0x11
DB 0x0E

CH_7:
DB 0x00
DB 0x1F
DB 0x01
DB 0x02
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_8:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x0E
DB 0x11
DB 0x11
DB 0x0E

CH_9:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x0F
DB 0x01
DB 0x02
DB 0x0C

CH_@@1:
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x0C
DB 0x0C

CH_@@2:
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x0A
DB 0x0A
DB 0x0A
DB 0x13

CH_@@3:
DB 0x00
DB 0x08
DB 0x04
DB 0x02
DB 0x02
DB 0x02
DB 0x04
DB 0x08

CH_@@4:
DB 0x00
DB 0x02
DB 0x04
DB 0x08
DB 0x08
DB 0x08
DB 0x04
DB 0x02

CH_@@5:
DB 0x00
DB 0x07
DB 0x00
DB 0x1C
DB 0x10
DB 0x1C
DB 0x10
DB 0x1C

CH_@@6:
DB 0x00
DB 0x00
DB 0x00
DB 0x1E
DB 0x10
DB 0x1C
DB 0x10
DB 0x1E

CH_@@7:
DB 0x00
DB 0x0E
DB 0x11
DB 0x01
DB 0x02
DB 0x04
DB 0x00
DB 0x04

CH_A:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x1F
DB 0x11
DB 0x11
DB 0x11

CH_B:
DB 0x00
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E

CH_C:
DB 0x00
DB 0x0E
DB 0x11
DB 0x10
DB 0x10
DB 0x10
DB 0x11
DB 0x0E

CH_D:
DB 0x00
DB 0x1C
DB 0x12
DB 0x11
DB 0x11
DB 0x11
DB 0x12
DB 0x1C

CH_E:
DB 0x00
DB 0x1F
DB 0x10
DB 0x10
DB 0x1E
DB 0x10
DB 0x10
DB 0x1F

CH_F:
DB 0x00
DB 0x1F
DB 0x10
DB 0x10
DB 0x1E
DB 0x10
DB 0x10
DB 0x10

CH_G:
DB 0x00
DB 0x0E
DB 0x11
DB 0x10
DB 0x17
DB 0x11
DB 0x11
DB 0x0E

CH_H:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x1F
DB 0x11
DB 0x11
DB 0x11

CH_I:
DB 0x00
DB 0x0E
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_J:
DB 0x00
DB 0x07
DB 0x02
DB 0x02
DB 0x02
DB 0x02
DB 0x12
DB 0x0C

CH_K:
DB 0x00
DB 0x11
DB 0x12
DB 0x14
DB 0x18
DB 0x14
DB 0x12
DB 0x11

CH_L:
DB 0x00
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x10
DB 0x1F

CH_M:
DB 0x00
DB 0x11
DB 0x1B
DB 0x15
DB 0x15
DB 0x11
DB 0x11
DB 0x11

CH_N:
DB 0x00
DB 0x11
DB 0x11
DB 0x19
DB 0x15
DB 0x13
DB 0x11
DB 0x11

CH_O:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x0E

CH_P:
DB 0x00
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E
DB 0x10
DB 0x10
DB 0x10

CH_Q:
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x15
DB 0x12
DB 0x0D

CH_R:
DB 0x00
DB 0x1E
DB 0x11
DB 0x11
DB 0x1E
DB 0x14
DB 0x12
DB 0x11

CH_S:
DB 0x00
DB 0x0F
DB 0x10
DB 0x10
DB 0x0E
DB 0x01
DB 0x01
DB 0x1E

CH_T:
DB 0x00
DB 0x1F
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_U:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x0E

CH_V:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x11
DB 0x0A
DB 0x04

CH_W:
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x15
DB 0x15
DB 0x1B
DB 0x11

CH_X:
DB 0x00
DB 0x11
DB 0x11
DB 0x0A
DB 0x04
DB 0x0A
DB 0x11
DB 0x11

CH_Y:
DB 0x00
DB 0x11
DB 0x11
DB 0x0A
DB 0x04
DB 0x04
DB 0x04
DB 0x04

CH_Z:
DB 0x00
DB 0x1F
DB 0x01
DB 0x02
DB 0x04
DB 0x08
DB 0x10
DB 0x1F

CH_@@@1:
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x00
DB 0x0C
DB 0x04
DB 0x08

CH_@@@2:
DB 0x00
DB 0x00
DB 0x0C
DB 0x0C
DB 0x00
DB 0x0C
DB 0x04
DB 0x08

CH_@@@3:
DB 0x00
DB 0x00
DB 0x0C
DB 0x0C
DB 0x00
DB 0x0C
DB 0x0C
DB 0x00

CH_@@@4:
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x0E
DB 0x00

CH_@@@5:
DB 0x00
DB 0x1F
DB 0x11
DB 0x08
DB 0x04
DB 0x08
DB 0x11
DB 0x1F

CH_@@@6:
DB 0x00
DB 0x0C
DB 0x12
DB 0x12
DB 0x0C
DB 0x00
DB 0x00
DB 0x00

CH_a:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x01
DB 0x0F
DB 0x11
DB 0x0F

CH_b:
DB 0x00
DB 0x10
DB 0x10
DB 0x16
DB 0x19
DB 0x11
DB 0x11
DB 0x0E

CH_c:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x10
DB 0x10
DB 0x11
DB 0x0E

CH_d:
DB 0x00
DB 0x01
DB 0x01
DB 0x0D
DB 0x13
DB 0x11
DB 0x11
DB 0x0E

CH_e:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x1F
DB 0x10
DB 0x0E

CH_f:
DB 0x00
DB 0x02
DB 0x05
DB 0x04
DB 0x0E
DB 0x04
DB 0x04
DB 0x04

CH_g:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x0F
DB 0x01
DB 0x0E

CH_h:
DB 0x00
DB 0x10
DB 0x10
DB 0x16
DB 0x19
DB 0x11
DB 0x11
DB 0x11

CH_i:
DB 0x00
DB 0x04
DB 0x00
DB 0x0C
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_j:
DB 0x00
DB 0x02
DB 0x00
DB 0x02
DB 0x02
DB 0x02
DB 0x12
DB 0x0C

CH_k:
DB 0x00
DB 0x08
DB 0x08
DB 0x09
DB 0x0A
DB 0x0C
DB 0x0A
DB 0x09

CH_l:
DB 0x00
DB 0x0604
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x04
DB 0x0E

CH_m:
DB 0x00
DB 0x00
DB 0x00
DB 0x1A
DB 0x15
DB 0x15
DB 0x15
DB 0x15

CH_n:
DB 0x00
DB 0x00
DB 0x00
DB 0x16
DB 0x19
DB 0x11
DB 0x11
DB 0x11

CH_o:
DB 0x00
DB 0x00
DB 0x00
DB 0x0E
DB 0x11
DB 0x11
DB 0x11
DB 0x0E

CH_p:
DB 0x00
DB 0x00
DB 0x00
DB 0x1E
DB 0x11
DB 0x1E
DB 0x10
DB 0x10

CH_q:
DB 0x00
DB 0x00
DB 0x00
DB 0x0F
DB 0x11
DB 0x0F
DB 0x01
DB 0x01

CH_r:
DB 0x00
DB 0x00
DB 0x00
DB 0x0B
DB 0x0C
DB 0x08
DB 0x08
DB 0x08

CH_s:
DB 0x00
DB 0x00
DB 0x00
DB 0x0F
DB 0x10
DB 0x0E
DB 0x01
DB 0x1E

CH_t:
DB 0x00
DB 0x00
DB 0x04
DB 0x0E
DB 0x04
DB 0x04
DB 0x05
DB 0x02

CH_u:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x13
DB 0x0D

CH_v:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x11
DB 0x11
DB 0x0A
DB 0x04

CH_w:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x11
DB 0x15
DB 0x15
DB 0x0A

CH_x:
DB 0x00
DB 0x00
DB 0x00
DB 0x19
DB 0x06
DB 0x04
DB 0x0C
DB 0x13

CH_y:
DB 0x00
DB 0x00
DB 0x00
DB 0x11
DB 0x09
DB 0x06
DB 0x04
DB 0x18

CH_z:
DB 0x00
DB 0x00
DB 0x00
DB 0x1F
DB 0x02
DB 0x04
DB 0x08
DB 0x1F

CH_@@@@1:
DB 0x00
DB 0x0E
DB 0x11
DB 0x01
DB 0x0D
DB 0x15
DB 0x15
DB 0x0E

CH_@@@@2:
DB 0x00
DB 0x00
DB 0x0A
DB 0x1F
DB 0x1F
DB 0x0E
DB 0x04
DB 0x00

CH_@@@@3:
DB 0x00
DB 0x00
DB 0x04
DB 0x0E
DB 0x1F
DB 0x0E
DB 0x04
DB 0x00

CH_@@@@4:
DB 0x00
DB 0x0C
DB 0x12
DB 0x14
DB 0x08
DB 0x15
DB 0x12
DB 0x0D

CH_@@@@5:
DB 0x00
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F
DB 0x1F

;--------------------------------------------------------------------
;PUTPATTERN

#PROC PUTPATTERN
PutP_Xck:
MOV A,E
SUB D
JM Put_end
MOV A,C
SUB B
JM Put_XCend
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
MOV A,M
STA [0xC004]
INX HL
INC B
JMP PutP_Xck
Put_XCend:
LDA [PatCstX]
MOV B,A
INC D
JMP PutP_Xck
Put_end:
RET
#END

#PROC PUTPATMIRVER
MOV A,C
STA [PatCstX]
PutP_Xck2:
MOV A,E
SUB D
JM Put_end2
MOV A,C
SUB B
JM Put_XCend2
MOV A,C
STA [0xC002]
MOV A,D
STA [0xC003]
MOV A,M
STA [0xC004]
INX HL
DEC C
JMP PutP_Xck2
Put_XCend2:
LDA [PatCstX]
MOV C,A
INC D
JMP PutP_Xck2
Put_end2:
RET
#END

#PROC PUTPATTWIST
DEC D
MOV A,E
SUB D
STA [DRWtmp]
INC D
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
PutP_Xck3:
MOV A,E
SUB D
JM Put_end3
MOV A,C
SUB B
JM Put_XCend3
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
MOV A,M
STA [0xC004]
LDA [DRWtmp]
ADD L
MOV L,A
MVI A,0
ADC H
MOV H,A
INC B
JMP PutP_Xck3
Put_XCend3:
LDA [PatCstX]
MOV B,A
INC D
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
INX HL
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
JMP PutP_Xck3
Put_end3:
RET
#END

#PROC PUTPATTWISMIR
DEC D
MOV A,E
SUB D
STA [DRWtmp]
INC D
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
PutP_Xck4:
MOV A,E
SUB D
JM Put_end4
MOV A,C
SUB B
JM Put_XCend4
MOV A,B
STA [0xC002]
MOV A,E
STA [0xC003]
MOV A,M
STA [0xC004]
LDA [DRWtmp]
ADD L
MOV L,A
MVI A,0
ADC H
MOV H,A
INC B
JMP PutP_Xck4
Put_XCend4:
LDA [PatCstX]
MOV B,A
DEC E
LDA [H_tmp]
MOV H,A
LDA [L_tmp]
MOV L,A
INX HL
MOV A,H
STA [H_tmp]
MOV A,L
STA [L_tmp]
JMP PutP_Xck4
Put_end4:
RET
#END

#PROC DELPATTERN
PutP_XckDel:
MOV A,E
SUB D
JM Put_endDel
MOV A,C
SUB B
JM Put_XCendDel
MOV A,B
STA [0xC002]
MOV A,D
STA [0xC003]
XOR A
STA [0xC004]
INC B
JMP PutP_XckDel
Put_XCendDel:
LDA [PatCstX]
MOV B,A
INC D
JMP PutP_XckDel
Put_endDel:
RET
#END

;--------------------------------------------------------------------
;DELAY
#PROC DELAY
delayCk:
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
DCX BC
MOV A,B
OR B
JNZ delayCk
MOV A,C
OR C
JNZ delayCk
RET
#END

;--------------------------------------------------------------------
#PROC PLOT
MOV A,B
STA [CurX]
MOV A,C
STA [CurX+1]
STA [0xC002]
MOV A,D
STA [CurY]
MOV A,E
STA [CurY+1]
STA [0xC003]
LDA [SysColor]
STA [0xC004]
RET
#END

;--------------------------------------------------------------------
#PROC RNG
LDA [RNGTABLTEDIM]
MOV D,A
LDA [RNGTABLTEDIM+1]
MOV E,A
MVI H,[HIGH RNGTABLTE]
MVI L,[LOW RNGTABLTE]
MOV A,L
ADD E
MOV L,A
MOV A,H
ADC D
MOV H,A
MVI B,0x00
MOV A,M
RRA
MOV C,A
INX DE
MOV A,D
STA [RNGTABLTEDIM]
MOV A,E
STA [RNGTABLTEDIM+1]
MVI A,0x04
AND D
JZ RNGATU%%
MVI A,0x00
STA [RNGTABLTEDIM]
STA [RNGTABLTEDIM+1]
RNGATU%%:
RET
#END

;--------------------------------------------------------------------
#PROC CLRSCR128
MVI A,1
STA [Xcoord]
STA [Ycoord]
MVI C,0x9C
MVI D,0x75
;eggyel tobb sort torol
clrscrciklA%%:
DEC D
MOV A,D
STA [0xC003]	;Yreg
clrscrciklB%%:
DEC C
MOV A,C
STA [0xC002]	;Xreg
XOR A
STA [0xC004]	;Zreg
MVI A,0xFF
AND C
JNZ clrscrciklB%%
MVI C,0x9C
MVI A,0xFF
AND D
JNZ clrscrciklA%%
RET
#END
