//DwnldForm
#include "DwnldForm.h"

DwnldForm* THISCLASS;

DwnldForm::DwnldForm(){
	THISCLASS=this;
	InitRun=1;
	AutomatedMode=0;
	CreateSpecial("Program Downloader",50,50,280,250,1);

//user code here	
	
}

DwnldForm::~DwnldForm(){
//user code here

    DestroyForm();
}

//Build up form
void DwnldForm::BuildForm(HWND hwnd,HINSTANCE hInst){
	char Ports[10][6]={
		"COM1", "COM2", "COM3", "COM4", 
		"COM5", "COM6", "COM7", "COM8", 
		"COM9", "COM10"
	};
	InitRun=1;
	AnsiString s(hwnd);
	
	Button1=new Button(hwnd,hInst,"Open HEX/BIN",Button1P);
	Button2=new Button(hwnd,hInst,"DOWNLOAD",Button2P);
	Edit1=new EditBox(hwnd,hInst,"",Edit1P);
	Label1=new Label(hwnd,hInst,"File to download:",Label1P);
	Label2=new Label(hwnd,hInst,"Port setting:",Label2P);
	Combo=new ComboBox(hwnd,hInst,"MyCombo",Combo1P);
	Progress=new ProgressBar(hwnd,hInst,"MyProgress",Progress1P);
	
	for(int x=0;x<10;x++){
		Combo->AddItem(Ports[x]);
	}
	
	OpenDialog1=new TOpenDialog(hwnd);
	
	Button1->SetDefFont();
	Button2->SetDefFont();
	Edit1->SetDefFont();
	Edit1->ReadOnly(true);
	Label1->SetDefFont();
	Label2->SetDefFont();
	
	DLoader=new BaranyDwnld();
	
	//INI file kiolvasas
	BIN_HEX=0;
	AnsiString ProgPort,name;
	s=ExtractFilePath(Application->ExeName)+"Compiler.ini";

	TStringList* Inifile=new(TStringList);
	if(FileExists(s)){
		Inifile->LoadFromFile(s);
		
		HexFile=Inifile->Strings[0];
		HexFile=ChangeFileExt(HexFile,"BIN");
		if(FileExists(HexFile)){
			BIN_HEX=1;
			name=ExtractFileName(HexFile);
			Edit1->Text=name;
		}

		if(Inifile->Count<2){
			ProgPort="ProgrammerPort=COM1";
		}else{
			ProgPort=Inifile->Strings[1];
		}
		if(ProgPort.Pos("ProgrammerPort=COM")==1){
			switch(ProgPort[ProgPort.Length()]){
			case '0':
				strcpy(DLoader->PortSelected,"Com10");
				Combo->SelectItem(9);
				break;
			case '1':
				strcpy(DLoader->PortSelected,"Com1");
				Combo->SelectItem(0);
				break;
			case '2':
				strcpy(DLoader->PortSelected,"Com2");
				Combo->SelectItem(1);
				break;
			case '3':
				strcpy(DLoader->PortSelected,"Com3");
				Combo->SelectItem(2);
				break;
			case '4':
				strcpy(DLoader->PortSelected,"Com4");
				Combo->SelectItem(3);
				break;
			case '5':
				strcpy(DLoader->PortSelected,"Com5");
				Combo->SelectItem(4);
				break;
			case '6':
				strcpy(DLoader->PortSelected,"Com6");
				Combo->SelectItem(5);
				break;
			case '7':
				strcpy(DLoader->PortSelected,"Com7");
				Combo->SelectItem(6);
				break;
			case '8':
				strcpy(DLoader->PortSelected,"Com8");
				Combo->SelectItem(7);
				break;
			case '9':
				strcpy(DLoader->PortSelected,"Com9");
				Combo->SelectItem(8);
				break;
			default:
				strcpy(DLoader->PortSelected,"Com1");
				Combo->SelectItem(0);
			}
		}else{
			Combo->SelectItem(0);
		}
	}else{
		Inifile->Add("default.BASIC");
		Inifile->Add("ProgrammerPort=COM1");
		Inifile->SaveToFile(s);
		Combo->SelectItem(0);
	}
	delete Inifile;

	//set initialise phase end flag to init ended state
	InitRun=0;
}

//Destroy form
void DwnldForm::DestroyForm(){
	delete Button1;
	delete Button2;
	delete Edit1;
	delete OpenDialog1;
	delete DLoader;
	delete Combo;
	delete Label1;
	delete Label2;
	delete Progress;
}

void DwnldForm::OnCommand(WORD command){
    REGCALLBK(Button1) Button1Click();
	REGCALLBK(Button2) Button2Click();
	REGCALLBK(Combo) ComboClick();
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
//open HEX/BIN file
void  DwnldForm::Button1Click(){
	int len;
	AnsiString name;
	OpenDialog1->Filter="Hexa file (*.hex)\0*.HEX\0Binary file (*.bin)\0*.BIN\0";
	if(OpenDialog1->Execute()){
		HexFile=OpenDialog1->FileName;
		len=HexFile.Length();
		if((HexFile[len-2]=='b')&&(HexFile[len-1]=='i')&&(HexFile[len]=='n'))BIN_HEX=1;
		if((HexFile[len-2]=='B')&&(HexFile[len-1]=='I')&&(HexFile[len]=='N'))BIN_HEX=1;
		if((HexFile[len-2]=='h')&&(HexFile[len-1]=='e')&&(HexFile[len]=='x'))BIN_HEX=2;
		if((HexFile[len-2]=='H')&&(HexFile[len-1]=='E')&&(HexFile[len]=='X'))BIN_HEX=2;
		if((BIN_HEX!=1)&&(BIN_HEX!=2)){
			ShowError("Wrong file format (1)","ERROR");
		}else{
			name=ExtractFileName(HexFile);
			Edit1->Text=name;
		}
	}
}

//download
void  DwnldForm::Button2Click(){
	Button1->Enabled=false;
	Button2->Enabled=false;
	DownLoadProcess();
	Button1->Enabled=true;
	Button2->Enabled=true;
}
	
void  DwnldForm::DownLoadProcess(){
	Progress->SetPos(0);
	if((BIN_HEX!=1)&&(BIN_HEX!=2)){
		ShowError("Wrong file format","ERROR");
		return;
	}
	
//#ifndef DEBUG
	if(!DLoader->Open()){
		ShowError("Opening FAILED","ERROR");
		return;
	}
	if(!DLoader->Connect()){
		ShowError("Connecting FAILED","ERROR");
		return;
	}
//#endif
	if(!DLoader->Program(HexFile,BIN_HEX)){
		ShowError("Programming FAILED","ERROR");
		return;
	}
//#ifndef DEBUG
	if(!DLoader->Disconnect()){
		ShowError("Disconnecting FAILED","ERROR");
		return;
	}
	DLoader->Close();	
//#endif
	
	Progress->SetPos(100);
	if(AutomatedMode){
		Application->Terminate(5);
	}else{
		ShowMessage("Successfully downloaded");
	}
}

void DwnldForm::ComboClick(){
	
}

void DwnldForm::ComboChange(){
	AnsiString s,ProgPort;
	
	int z=Combo->GetItem();
	switch(z){
	case 0:
		strcpy(DLoader->PortSelected,"Com1");
		ProgPort="ProgrammerPort=COM1";
		break;
	case 1:
		strcpy(DLoader->PortSelected,"Com2");
		ProgPort="ProgrammerPort=COM2";
		break;
	case 2:
		strcpy(DLoader->PortSelected,"Com3");
		ProgPort="ProgrammerPort=COM3";
		break;
	case 3:
		strcpy(DLoader->PortSelected,"Com4");
		ProgPort="ProgrammerPort=COM4";
		break;
	case 4:
		strcpy(DLoader->PortSelected,"Com5");
		ProgPort="ProgrammerPort=COM5";
		break;
	case 5:
		strcpy(DLoader->PortSelected,"Com6");
		ProgPort="ProgrammerPort=COM6";
		break;
	case 6:
		strcpy(DLoader->PortSelected,"Com7");
		ProgPort="ProgrammerPort=COM7";
		break;
	case 7:
		strcpy(DLoader->PortSelected,"Com8");
		ProgPort="ProgrammerPort=COM8";
		break;
	case 8:
		strcpy(DLoader->PortSelected,"Com9");
		ProgPort="ProgrammerPort=COM9";
		break;
	case 9:
		strcpy(DLoader->PortSelected,"Com10");
		ProgPort="ProgrammerPort=COM10";
		break;
	default:
		strcpy(DLoader->PortSelected,"Com1");
		ProgPort="ProgrammerPort=COM1";
	}
	
	s=ExtractFilePath(Application->ExeName)+"Compiler.ini";
	TStringList* Inifile=new(TStringList);
	if(FileExists(s)){
		Inifile->LoadFromFile(s);
		if(Inifile->Count<2){
			Inifile->Clear();
			Inifile->Add("default.BASIC");
			Inifile->Add("ProgrammerPort=COM1");
		}
		Inifile->Strings[1]=ProgPort;
		Inifile->SaveToFile(s);
	}
	delete Inifile;
}

//Demand on immediately start to download
void DwnldForm::Demand(char*cmd){
	if(!strcmp(cmd,"imme")){
		AutomatedMode=1;
		while(InitRun)
			MsgWaitForMultipleObjectsEx(0,NULL,100,0,0);
		PostMessage(this->hwnd,WM_USER,0,0);
		//Button2Click();
	}
}

void DwnldForm::OnUserMessage(WPARAM wParam, LPARAM lParam){
	Button2Click();
}


void DwnldForm::ShowStatus(int x){
	Progress->SetPos(x);
}

//***********************************************************
//	CALLBACK from downloader module
void BaranyDwnld::ShowStatus(int x){
	THISCLASS->ShowStatus(x);
}
