//DwnldForm
#ifndef DwnldFormH
#define DwnldFormH

#include "..\FormClass.h"
#include "..\ButtonClass.h"
#include "..\EditClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\OpenFileClass.h"
#include "..\LabelClass.h"
#include "..\ComboBox.h"
#include "..\TStringListClass.h"
#include "..\ProgressBar.h"

#include "resource.h"
#include "DwnldFormParams.h"
#include "BaranyDwnld.h"

static volatile int InitRun=1;

class DwnldForm : public FormClass{
public:
	DwnldForm();
	~DwnldForm();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnCommand(WORD command);
	void OnUserMessage(WPARAM wParam, LPARAM lParam);
	
	Button* Button1;
	Button* Button2;
	EditBox* Edit1;
	Label* Label1;
	Label* Label2;
	TOpenDialog *OpenDialog1;
	ComboBox*Combo;
	ProgressBar* Progress;

	void Button1Click();
	void Button2Click();
	void ComboClick();
	
	void ComboChange();
	
	void Demand(char*cmd);
	
	void ShowStatus(int x);
	
private:	// User declarations
	AnsiString HexFile;
	int BIN_HEX;	//file type
	BaranyDwnld* DLoader;
	
	int AutomatedMode;	//Automated download request from basic compiler
	
	void DownLoadProcess();
	
};

#endif
