//MainForm
#include "PictureToAsmForm.h"
#include "PictureToAsmFormParams.h"

PictureToAsm::PictureToAsm(HWND Owner,int Resource){
    //CreateSpecial("Picture to ASM",50,50,290,220,1);
	CreateDialogBox(Owner,Resource);
	
//user code here	

}

PictureToAsm::~PictureToAsm(){
//user code here

    //DestroyForm();
}

//Build up form
void PictureToAsm::BuildForm(HWND hwnd,HINSTANCE hInst){	
	CreateGrElem( Label, Label1 );
	CreateGrElem( Button, Button1 );
	CreateGrElem( Button, Button2 );
	OpenPictureDialog1=new TOpenPictureDialog(hwnd);
	Image1=new ImageClass(hwnd,25,25,SCRX,SCRY);
}

//Destroy form
void PictureToAsm::DestroyForm(){
    delete Label1;
	delete Button1;
	delete Button2;
	delete OpenPictureDialog1;
	delete Image1;
}

void PictureToAsm::OnCommand(WORD command){
    REGCALLBK(Button1) Button1Click();
	REGCALLBK(Button2) Button2Click();
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************

void PictureToAsm::Button1Click(){
	if(OpenPictureDialog1->Execute()){
		Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
		filename=OpenPictureDialog1->FileName;
	}

}
//---------------------------------------------------------------------------
void PictureToAsm::Button2Click(){
//SAVE
	int x,y,z;
	int r,g,b;
	AnsiString s;
	TStringList* ASMfile=new(TStringList);
	
	for(x=0;x<42;x++)
		ASMfile->Add(PicDrawAsmCode[x]);
	for(x=0;x<3;x++)
		ASMfile->Add("");

	ASMfile->Add("PICTURE:");

	for(y=0;y<SCRY;y++){
		for(x=0;x<SCRX;x++){
			r=Image1->Picture->Bitmap->Canvas->Pixels[x][y]&0xFF;
			g=(Image1->Picture->Bitmap->Canvas->Pixels[x][y]>>8)&0xFF;
			b=(Image1->Picture->Bitmap->Canvas->Pixels[x][y]>>16)&0xFF;
			z=r/3+g/3+b/3;
			z=(z>128)?0xFF:0;/*z&0x1*/
			sprintf(s.String,"DB 0x%X",z);
			Image1->Picture->Bitmap->Canvas->Pixels[x][y]=z+(z<<8)+(z<<16);
			ASMfile->Add(s);
		}
	}

	filename=ChangeFileExt(filename,"asm");
	ASMfile->SaveToFile(filename);

	delete ASMfile;
	Image1->Canvas->Update();
	
	ShowMessage("Picture is converted to ASM file");
}

void PictureToAsm::OnPaint(){
	Image1->Repaint();
}
